<?php
/*
Plugin Name: HeatMap AdAptive Pro Plugin
Plugin URI: http://heatmaptheme.com
Description: Adds additional pro features to HeatMap Theme AdAptive 
Version: 1.1.5
Author: Stuart Wider
Author URI: http://stuartwider.com
Licence: GNU General Public License v2 or later
License URI: http://www.gnu.org/licenses/gpl-2.0.html
 
Copyright Stuart Wider / StuartCindy Art 2012

The name 'HeatMap Theme' and the notched circle 
and flame logo is a registered trademark of Stuart Wider / StuartCindy Art.
*/

/* 
This file is part of HeatMap AdAptive Pro
See license.txt (distributed with this file) for details of
license, contributors, copyright notices, credits and trademarks.
*/

function heatmapthemead_social_scripts () {
	wp_enqueue_script( 'heatmapthemead-social-scripts', HMTAP_JS_URL . 'social.js','','20130606');
}

function heatmapthemeap_init_plugin () {
	
	// set text domain for translations
	load_plugin_textdomain( 'heatmapthemeap', false, dirname( plugin_basename( __FILE__ ) ) . '/languages/' );
	
	define( 'HMTAP_PATH', plugin_dir_path(__FILE__) );
	define( 'HMTAP_IMAGES_URL', plugins_url( '/images/' , __FILE__ ) );
	define( 'HMTAP_COLOURS_URL', plugins_url( '/colours/' , __FILE__ ) );
	define( 'HMTAP_JS_URL', plugins_url( '/js/' , __FILE__ ) );
	
	require HMTAP_PATH .  'inc/pro-options.php';
	require HMTAP_PATH .  'inc/pro-tags.php';
	
	$options = heatmapthemead_get_theme_options();

	if ( $options['twitter_like'] == 'on' || $options['googleplusone_like'] == 'on' ):
		add_action( 'wp_enqueue_scripts', 'heatmapthemead_social_scripts' );
	endif;
	
}
add_action ( 'heatmapthemead_additional_plugins_hook', 'heatmapthemeap_init_plugin' );
?>