<?php
function heatmapthemeap_exists () {
	return true;
}

/* REGISTER ADDITIONAL WIDGET POSITIONS
--------------------------------------------------------------------------------------------- */

// SITE TOP
function heatmapthemeap_register_sitetop () {
	register_sidebar(
		array(
		'name' => __( 'Site (top)','heatmapthemeap' ),
		'id' => 'heatmapthemeapsitetop',
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => '</aside>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4>'
		)
	);
}

add_action( 'heatmapthemead_secondary_sidebar_registration_hook', 'heatmapthemeap_register_sitetop' );

// SITE BOTTOM
function heatmapthemeap_register_sitebottom () {	
	register_sidebar(
		array(
		'name' => __( 'Site (bottom)','heatmapthemeap' ),
		'id' => 'heatmapthemeapsitebottom',
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => '</aside>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4>'
		)
	);
}

add_action( 'heatmapthemead_blog_bottom_registration_hook', 'heatmapthemeap_register_sitebottom' );


/* ADDITIONAL WIDGET POSITION FUNCTIONS
--------------------------------------------------------------------------------------------- */

// SITE TOP
function heatmapthemeap_widget_position_sitetop() {
	if ( heatmapthemead_is_sidebar_active ( 'heatmapthemeapsitetop' ) ) {	
		print '<div id="heatmapthemeap-widget-position-sitetop" class="heatmapthemeap-widget-position heatmapthemeap-sitetop widget-area" role="complementary">';
		dynamic_sidebar( 'heatmapthemeapsitetop' );
		print '</div> <!-- id="heatmapthemeap-widget-position-sitetop" -->'; 
		print HMTA_NL;
	}
}

add_action('heatmapthemead_header_hook', 'heatmapthemeap_widget_position_sitetop', 1);

// SITE BOTTOM
function heatmapthemeap_widget_position_sitebottom() {
	if ( heatmapthemead_is_sidebar_active ( 'heatmapthemeapsitebottom' ) ) {	
		print '<div id="heatmapthemeap-widget-position-sitebottom" class="heatmapthemeap-widget-position heatmapthemeap-sitebottom widget-area" role="complementary">';
		dynamic_sidebar( 'heatmapthemeapsitebottom' );
		print '</div> <!-- id="heatmapthemeap-widget-position-sitebottom" -->'; 
		print HMTA_NL;
	}
}

add_action('heatmapthemead_post_footer_hook', 'heatmapthemeap_widget_position_sitebottom', 99);

/* PRO FONTS
--------------------------------------------------------------------------------------------- */
/* PRO FONT STYLES
----------------------------------------------- */

function heatmapthemeap_pro_font_style ( $select_options ) {


	$select_pro_options = array(
		'opensans' => array(
			'value' =>	'opensans',
			'label' => __( 'Open Sans', 'heatmapthemeap' )
		),
		'opensanslight' => array(
			'value' =>	'opensanslight',
			'label' => __( 'Open Sans Light', 'heatmapthemeap' )
		),
		'robotolight' => array(
			'value' =>	'robotolight',
			'label' => __( 'Roboto Light', 'heatmapthemeap' )
		),
		'ubuntulight' => array(
			'value' =>	'ubuntulight',
			'label' => __( 'Ubuntu Light', 'heatmapthemeap' )
		),
		'lora' => array(
			'value' =>	'lora',
			'label' => __( 'Lora', 'heatmapthemeap' )
		),											
		'georgia' => array(
			'value' =>	'georgia',
			'label' => __( 'Georgia', 'heatmapthemeap' )
		),
		'courier-new' => array(
			'value' =>	'courier-new',
			'label' => __( 'Courier New', 'heatmapthemeap' )
		),
		'tahoma' => array(
			'value' =>	'tahoma',
			'label' => __( 'Tahoma', 'heatmapthemeap' )
		),
		'trebuchet' => array(
			'value' =>	'trebuchet',
			'label' => __( 'Trebuchet', 'heatmapthemeap' )
		),
		'times-new-roman' => array(
			'value' =>	'times-new-roman',
			'label' => __( 'Times New Roman', 'heatmapthemeap' )
		),
		'palatino-linotype' => array(
			'value' =>	'palatino-linotype',
			'label' => __( 'Palatino Linotype', 'heatmapthemeap' )
		),
		'lucida-sans-unicode' => array(
			'value' =>	'lucida-sans-unicode',
			'label' => __( 'Lucida Sans Unicode', 'heatmapthemeap' )
		),
		'ms-serif' => array(
			'value' =>	'ms-serif',
			'label' => __( 'MS Serif', 'heatmapthemeap' )
		),
		'lucida-console' => array(
			'value' =>	'lucida-console',
			'label' => __( 'Lucida Console', 'heatmapthemeap' )
		),
		'comic-sans' => array(
			'value' =>	'comic-sans',
			'label' => __( 'Comic Sans', 'heatmapthemeap' )
		),
		'cabin' => array(
			'value' =>	'cabin',
			'label' => __( 'Cabin', 'heatmapthemeap' )
		),
		'pontanosans' => array(
			'value' =>	'pontanosans',
			'label' => __( 'Pontano Sans', 'heatmapthemeap' )
		),
		'arimo' => array(
			'value' =>	'arimo',
			'label' => __( 'Arimo', 'heatmapthemeap' )
		),
		'georgia-arial' => array(
			'value' =>	'georgia-arial',
			'label' => __( 'Georgia / Arial', 'heatmapthemeap' )
		),
		'arialblack-arial' => array(
			'value' =>	'arialblack-arial',
			'label' => __( 'Arial Black / Arial', 'heatmapthemeap' )
		),
		'arvo-ptsans' => array(
			'value' =>	'arvo-ptsans',
			'label' => __( 'Arvo / PT Sans', 'heatmapthemeap' )
		),
		'molengo-lekton' => array(
			'value' =>	'molengo-lekton',
			'label' => __( 'Molengo / Lekton', 'heatmapthemeap' )
		),
		'droidserif-droidsans' => array(
			'value' =>	'droidserif-droidsans',
			'label' => __( 'Droid Serif / Droid Sans', 'heatmapthemeap' )
		),
		'ubuntu-vollkorn' => array(
			'value' =>	'ubuntu-vollkorn',
			'label' => __( 'Ubuntu / Vollkorn', 'heatmapthemeap' )
		),
		'playfairdisplay-muli' => array(
			'value' =>	'playfairdisplay-muli',
			'label' => __( 'Playfair Display / Muli', 'heatmapthemeap' )
		),
		'istokweb-lora' => array(
			'value' =>	'istokweb-lora',
			'label' => __( 'Istok Web / Lora', 'heatmapthemeap' )
		),
	);

	$select_options = array_merge( $select_options, $select_pro_options);
	return $select_options;
}

add_filter ( 'heatmapthemead_font_style', 'heatmapthemeap_pro_font_style' );


/* INJECT PRO FONT STYLES INTO HEAD
----------------------------------------------- */

function heatmapthemeap_pro_head_fonts ( $current_combo ) {

	switch ($current_combo) {
		
	case "opensans":
		print '<link href="http://fonts.googleapis.com/css?family=Open+Sans" rel="stylesheet" type="text/css">';
		break;	
	case "opensanslight":
		print '<link href="http://fonts.googleapis.com/css?family=Open+Sans:300" rel="stylesheet" type="text/css">';
		break;
	case "robotolight":
		print '<link href="http://fonts.googleapis.com/css?family=Roboto:300" rel="stylesheet" type="text/css">';
		break;
	case "ubuntulight":
		print '<link href="http://fonts.googleapis.com/css?family=Ubuntu:300" rel="stylesheet" type="text/css">';
		break;
	case "lora":
		print '<link href="http://fonts.googleapis.com/css?family=Lora" rel="stylesheet" type="text/css">';
		break;						
	case "cabin":
		print '<link href="http://fonts.googleapis.com/css?family=Cabin" rel="stylesheet" type="text/css">';
		break;
	case "arvo-ptsans":
		print '<link href="http://fonts.googleapis.com/css?family=Arvo" rel="stylesheet" type="text/css">';
		print '<link href="http://fonts.googleapis.com/css?family=PT+Sans" rel="stylesheet" type="text/css">';
		break;
	case "molengo-lekton":
		print '<link href="http://fonts.googleapis.com/css?family=Lekton" rel="stylesheet" type="text/css">';
		print '<link href="http://fonts.googleapis.com/css?family=Molengo" rel="stylesheet" type="text/css">';
		break;
	case "droidserif-droidsans":
		print '<link href="http://fonts.googleapis.com/css?family=Droid+Serif" rel="stylesheet" type="text/css">';
		print '<link href="http://fonts.googleapis.com/css?family=Droid+Sans" rel="stylesheet" type="text/css">';
		break;
	case "ubuntu-vollkorn":
		print '<link href="http://fonts.googleapis.com/css?family=Ubuntu:bold" rel="stylesheet" type="text/css">';
		print '<link href="http://fonts.googleapis.com/css?family=Vollkorn" rel="stylesheet" type="text/css">';
		break;
	case "pontanosans":
		print '<link href="http://fonts.googleapis.com/css?family=Pontano+Sans" rel="stylesheet" type="text/css">';
		break;
	case "playfairdisplay-muli":
		print '<link href="http://fonts.googleapis.com/css?family=Playfair+Display" rel="stylesheet" type="text/css">';
		print '<link href="http://fonts.googleapis.com/css?family=Muli" rel="stylesheet" type="text/css">';
		break;
	case "istokweb-lora":
		print '<link href="http://fonts.googleapis.com/css?family=Istok+Web" rel="stylesheet" type="text/css">';
		print '<link href="http://fonts.googleapis.com/css?family=Lora" rel="stylesheet" type="text/css">';
		break;
	case "arimo":
		print '<link href="http://fonts.googleapis.com/css?family=Arimo" rel="stylesheet" type="text/css">';
		break;
	}
	
}

add_action('heatmapthemead_head_fonts_hook', 'heatmapthemeap_pro_head_fonts');


/* ADD STYLE BLOCK FOR PRO FONT STYLES
----------------------------------------------- */

function heatmapthemeap_print_pro_font_css( $current_combo ){
	
	switch ($current_combo) {
	case "georgia-arial": 
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family: Georgia, "Times New Roman", Times, serif; font-weight: normal; }
			.heatmapthemead-menu { font-family: Arial, Helvetica, sans-serif; }
			body { font-size: 1.7em; }
			body, button, input, select, textarea { font-family:  Arial, Helvetica, sans-serif; }
		</style> 
	<?php
	break;
			
	case "courier-new": 
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family: "Courier New", Courier, monospace;}
			#heatmapthemead-header-text h1 {font-weight: bold; }
			.heatmapthemead-menu { font-family: "Courier New", Courier, monospace;}
			body { font-size: 1.8em; } 
			body, button, input, select, textarea { font-family: "Courier New", Courier, monospace; }
		</style> 
	<?php
	break;
	
	case "tahoma": 
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family: Tahoma, Geneva, sans-serif; }
			.heatmapthemead-menu { font-family: Tahoma, Geneva, sans-serif; }
			body { font-size: 1.7em; } 
			body, button, input, select, textarea { font-family: Tahoma, Geneva, sans-serif; }
		</style> 
	<?php
	break;
	
	case "trebuchet": 
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family: "Trebuchet MS", Arial, Helvetica, sans-serif; }
			.heatmapthemead-menu { font-family: "Trebuchet MS", Arial, Helvetica, sans-serif; }
			body { font-size: 1.8em; } 
			body, button, input, select, textarea { font-family: "Trebuchet MS", Arial, Helvetica, sans-serif; }
		</style> 
	<?php
	break;
	
	case "arialblack-arial": 
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family:  "Arial Black", Gadget, sans-serif; }
			.heatmapthemead-menu { font-family: Arial, Helvetica, sans-serif; }
			body, button, input, select, textarea { font-family: Arial, Helvetica, sans-serif; }
		</style> 
	<?php
	break;
	
	case "times-new-roman": 
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family: "Times New Roman", Times, serif; }
			.heatmapthemead-menu { font-family: "Times New Roman", Times, serif;}
			body { font-size: 1.9em; } 
			body, button, input, select, textarea { font-family: "Times New Roman", Times, serif; }
		</style> 
	<?php
	break;
	
	case "palatino-linotype": 
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family: "Palatino Linotype", "Book Antiqua", Palatino, serif; }
			.heatmapthemead-menu { font-family: "Palatino Linotype", "Book Antiqua", Palatino, serif; }
			body { font-size: 1.9em; }
			body, button, input, select, textarea { font-family: "Palatino Linotype", "Book Antiqua", Palatino, serif; }
		</style> 
	<?php
	break;
	
	case "lucida-sans-unicode": 
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family: "Lucida Sans Unicode", "Lucida Grande", sans-serif; }
			.heatmapthemead-menu { font-family: "Lucida Sans Unicode", "Lucida Grande", sans-serif; }
			body { font-size: 1.7em; }
			body, button, input, select, textarea { font-family: "Lucida Sans Unicode", "Lucida Grande", sans-serif;  }
		</style> 
	<?php
	break;
	
	case "ms-serif": 
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family: "MS Serif", "New York", serif; }
			.heatmapthemead-menu { font-family: "MS Serif", "New York", serif; }
			body { font-size: 1.9em; }
			body, button, input, select, textarea { font-family: "MS Serif", "New York", serif; }
		</style> 
	<?php
	break;
	
	case "lucida-console": 
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family: "Lucida Console", Monaco, monospace; }
			.heatmapthemead-menu { font-family: "Lucida Console", Monaco, monospace;  }
			body { font-size: 1.7em; }
			body, button, input, select, textarea { font-family: "Lucida Console", Monaco, monospace; }
		</style> 
	<?php
	break;
	
	case "comic-sans": 
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family: "Comic Sans MS", cursive; }
			.heatmapthemead-menu { font-family: "Comic Sans MS", cursive;  }
			body { font-size: 1.8em; }
			body, button, input, select, textarea { font-family: "Comic Sans MS", cursive;  }
		</style> 
	<?php
	break;
			
	case "cabin": 
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family:'Cabin', Helvetica, Arial, sans-serif; }
			.heatmapthemead-menu { font-family: 'Cabin', Helvetica, Arial, sans-serif; }
			body { font-size: 1.9em; }
			body, button, input, select, textarea { font-family: 'Cabin', Helvetica, Arial, sans-serif; }
		</style> 
	<?php
	break;
	
	case "georgia":
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family: Georgia, Times, serif; font-weight: normal; }
			.heatmapthemead-menu { font-family: Georgia, Times, serif; }
			body { font-size: 1.8em; }
			body, button, input, select, textarea { font-family: Georgia, Times, serif; }
		</style> 
	<?php
	break;
	
	case "arvo-ptsans":
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family: 'Arvo', Georgia, Times, serif; }
			.heatmapthemead-menu { font-family: 'PT Sans', Helvetica, Arial, sans-serif; }
			body { font-size: 1.8em; }
			body, button, input, select, textarea { font-family: 'PT Sans', Helvetica, Arial, sans-serif; }
		</style> 
	<?php
	break;
	
	case "molengo-lekton":
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family: 'Molengo', Georgia, Times, serif; }
			.heatmapthemead-menu { font-family: 'Lekton', Helvetica, Arial, sans-serif; }
			body { font-size: 1.8em; }
			body, button, input, select, textarea { font-family: 'Lekton', Helvetica, Arial, sans-serif; }
		</style> 
	<?php
	break;
	
	case "droidserif-droidsans":
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family: 'Droid Serif', Georgia, Times, serif; }
			.heatmapthemead-menu { font-family: 'Droid Sans', Helvetica, Arial, sans-serif; }
			body { font-size: 1.8em; }
			body, button, input, select, textarea { font-family: 'Droid Sans', Helvetica, Arial, sans-serif; }
		</style> 
	<?php
	break;
	
	case "ubuntu-vollkorn":
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family: 'Ubuntu', Helvetica, Arial, sans-serif; }
			.heatmapthemead-menu { font-family: 'Vollkorn', Georgia, Times, serif; }
			body { font-size: 1.8em; }
			body, button, input, select, textarea { font-family: 'Vollkorn', Georgia, Times, serif; }
		</style> 
	<?php
	break;
	
	case "pontanosans":
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family: 'Pontano Sans', Verdana, Helvetica, sans-serif; }
			.heatmapthemead-menu { font-family: 'Pontano Sans', Verdana, Helvetica, sans-serif; }
			body { font-size: 1.8em; }
			body, button, input, select, textarea { font-family: 'Pontano Sans', Verdana, Helvetica, sans-serif; }
		</style> 
	<?php
	break;
	
	case "playfairdisplay-muli":
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family: 'Playfair Display', Georgia, serif; }
			body { font-size: 1.7em; }
			.heatmapthemead-menu { font-family: 'Muli', Verdana, Helvetica, sans-serif; }
			body, button, input, select, textarea { font-family: 'Muli', Verdana, Helvetica, sans-serif; }
		</style> 
	<?php
	break;
	
	case "istokweb-lora":
	?>
		<style>
			/* Font Style */
			body { font-size: 1.7em; }
			body, button, input, select, textarea { font-family: 'Lora', Georgia, serif; }
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family: 'Istok Web', Verdana, Helvetica, sans-serif; }
			.heatmapthemead-menu { font-family: 'Lora', Georgia, serif; }
		</style> 
	<?php
	break;
	
	case "arimo":
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family: 'Arimo', Verdana, Helvetica, sans-serif; }
			.heatmapthemead-menu { font-family: 'Arimo', Verdana, Helvetica, sans-serif;}
			body { font-size: 1.7em; }
			body, button, input, select, textarea { font-family: 'Arimo', Verdana, Helvetica, sans-serif; }
		</style> 
	<?php
	break;
	
	case "opensans": 
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family: 'Open Sans', Arial, Helvetica, sans-serif; }
			.heatmapthemead-menu { font-family: 'Open Sans', Arial, Helvetica, sans-serif; }
			body { font-size: 1.7em; }
			body, button, input, select, textarea { font-family: 'Open Sans', Arial, Helvetica, sans-serif; }
		</style> 
	<?php
	break;
	
	
	case "opensanslight": 
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family: 'Open Sans', Arial, Helvetica, sans-serif; }
			.heatmapthemead-menu { font-family: 'Open Sans', Arial, Helvetica, sans-serif; }
			body { font-size: 1.7em; }
			body, button, input, select, textarea { font-family: 'Open Sans', Arial, Helvetica, sans-serif; }
		</style> 
	<?php
	break;
	
	case "robotolight": 
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family: 'Roboto', Arial, Helvetica, sans-serif; }
			.heatmapthemead-menu { font-family: 'Roboto', Arial, Helvetica, sans-serif; }
			body { font-size: 1.7em; }
			body, button, input, select, textarea { font-family: 'Roboto', Arial, Helvetica, sans-serif; }
		</style> 
	<?php
	break;
	
	case "ubuntulight": 
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family: 'Ubuntu', Arial, Helvetica, sans-serif; }
			.heatmapthemead-menu { font-family: 'Ubuntu', Arial, Helvetica, sans-serif; }
			body { font-size: 1.7em; }
			body, button, input, select, textarea { font-family: 'Ubuntu', Arial, Helvetica, sans-serif; }
		</style> 
	<?php
	break;
	
	case "lora": 
	?>
		<style>
			/* Font Style */
			h1,h2,h3,h4,h5,h6,
			#heatmapthemead-header-text p#site-title,
			#heatmapthemead-header-text p#site-description { font-family: 'Lora', Georgia, serif; }
			.heatmapthemead-menu { font-family: 'Lora', Georgia, serif; }
			body { font-size: 1.7em; }
			body, button, input, select, textarea { font-family: 'Lora', Georgia, serif; }
		</style> 
	<?php
	break;
	
	
	}	
}

add_action('heatmapthemead_print_font_css_hook', 'heatmapthemeap_print_pro_font_css');


/* STYLE THE HEADER PRO FONT STYLE IN THE ADMIN
----------------------------------------------- */

function heatmapthemeap_print_admin_header_pro_font_css( $current_combo ) {

	switch ($current_combo) {
	case "georgia-arial": 
	?>
		<style>
			/* Font Style */
			#headimg h1, #desc { font-family: Georgia, "Times New Roman", Times, serif; font-weight: normal;}
		</style> 
	<?php
	break;
	
	case "courier-new": 
	?>
		<style>
			/* Font Style */
			#headimg h1, #desc { font-family: "Courier New", Courier, monospace;}
		</style> 
	<?php
	break;
	
	case "tahoma": 
	?>
		<style>
			/* Font Style */
			#headimg h1, #desc { font-family: Tahoma, Geneva, sans-serif; }
		</style> 
	<?php
	break;
	
	case "trebuchet": 
	?>
		<style>
			/* Font Style */
			#headimg h1, #desc { font-family: "Trebuchet MS", Arial, Helvetica, sans-serif; }
		</style> 
	<?php
	break;
	
	case "arialblack-arial": 
	?>
		<style>
			/* Font Style */
			#headimg h1, #desc { font-family:  "Arial Black", Gadget, sans-serif; }
		</style> 
	<?php
	break;
	
	case "times-new-roman": 
	?>
		<style>
			/* Font Style */
			#headimg h1, #desc { font-family: "Times New Roman", Times, serif; }
		</style> 
	<?php
	break;
	
	case "palatino-linotype": 
	?>
		<style>
			/* Font Style */
			#headimg h1, #desc { font-family: "Palatino Linotype", "Book Antiqua", Palatino, serif; }
		</style> 
	<?php
	break;
	
	case "lucida-sans-unicode": 
	?>
		<style>
			/* Font Style */
			#headimg h1, #desc { font-family: "Lucida Sans Unicode", "Lucida Grande", sans-serif; }

		</style> 
	<?php
	break;
	
	case "ms-serif": 
	?>
		<style>
			/* Font Style */
			#headimg h1, #desc { font-family: "MS Serif", "New York", serif; }
		</style> 
	<?php
	break;
	
	case "lucida-console": 
	?>
		<style>
			/* Font Style */
			#headimg h1, #desc { font-family: "Lucida Console", Monaco, monospace; }
		</style> 
	<?php
	break;
	
	case "comic-sans": 
	?>
		<style>
			#headimg h1, #desc{ font-family: "Comic Sans MS", cursive; }
		</style> 
	<?php
	break;
	
	case "opensans": 
	?>
		<style>
			#headimg h1, #desc { font-family: 'Open Sans', Arial, Helvetica, sans-serif; }
		</style> 
	<?php
	break;
	
	case "opensanslight": 
	?>
		<style>
			#headimg h1, #desc { font-family: 'Open Sans', Arial, Helvetica, sans-serif; }
		</style> 
	<?php
	break;
	
	case "robotolight": 
	?>
		<style>
			#headimg h1, #desc { font-family: 'Roboto', Arial, Helvetica, sans-serif; }
		</style> 
	<?php
	break;
	
	case "ubuntulight": 
	?>
		<style>
			#headimg h1, #desc { font-family: 'Ubuntu', Arial, Helvetica, sans-serif; }
		</style> 
	<?php
	break;
	
	case "lora": 
	?>
		<style>
			#headimg h1, #desc { font-family: 'Lora', Arial, Helvetica, sans-serif; }
		</style> 
	<?php
	break;
	
		
	case "cabin": 
	?>
		<style>
			#headimg h1, #desc { font-family:'Cabin', Helvetica, Arial, sans-serif; }
		</style> 
	<?php
	break;
	
	case "georgia":
	?>
		<style>
			#headimg h1, #desc { font-family: Georgia, Times, serif; font-weight: normal; }
		</style> 
	<?php
	break;
	
	case "arvo-ptsans":
	?>
		<style>
			#headimg h1, #desc { font-family: 'Arvo', Georgia, Times, serif; }
		</style> 
	<?php
	break;
	
	case "molengo-lekton":
	?>
		<style>
			#headimg h1, #desc { font-family: 'Molengo', Georgia, Times, serif; }
		</style> 
	<?php
	break;
	
	case "droidserif-droidsans":
	?>
		<style>
			#headimg h1, #desc { font-family: 'Droid Serif', Georgia, Times, serif; }
		</style> 
	<?php
	break;
	
	case "ubuntu-vollkorn":
	?>
		<style>
			#headimg h1, #desc { font-family: 'Ubuntu', Helvetica, Arial, sans-serif; }
		</style> 
	<?php
	break;
	
	case "pontanosans":
	?>
		<style>
			#headimg h1, #desc { font-family: 'Pontano Sans', Verdana, Helvetica, sans-serif; }
		</style> 
	<?php
	break;
	
	case "playfairdisplay-muli":
	?>
		<style>
			#headimg h1, #desc{ font-family: 'Playfair Display', Georgia, serif; }
		</style> 
	<?php
	break;
	
	case "istokweb-lora":
	?>
		<style>
			#headimg h1, #desc { font-family: 'Istok Web', Verdana, Helvetica, sans-serif; }
		</style> 
	<?php
	break;
	
	case "arimo":
	?>
		<style>
			#headimg h1, #desc { font-family: 'Arimo', Verdana, Helvetica, sans-serif; }
		</style> 
	<?php
	break;
	}

}

add_action('heatmapthemead_print_admin_header_font_css_hook', 'heatmapthemeap_print_admin_header_pro_font_css');


/* PRO COLOURS
--------------------------------------------------------------------------------------------- */
/* ADD PRO COLOUR SCHEMES TO ARRAY
----------------------------------------------- */

function heatmapthemeap_add_pro_colour_scheme ( $color_scheme_options ) {

	$additional_color_schemes = array(

		'the-blues' => array(
			'value' => 'the-blues',
			'label' => __( 'The Blues', 'heatmapthemeap' ),
			'thumbnail' => HMTAP_IMAGES_URL . 'the-blues.png',
			'default_link_color' => '#5658A9',
			'default_header_title_color' => 'FFFFFF' /* important - no # required here */
		),
		'purple-velvet' => array(
			'value' => 'purple-velvet',
			'label' => __( 'Purple Velvet', 'heatmapthemeap' ),
			'thumbnail' => HMTAP_IMAGES_URL . 'purple-velvet.png',
			'default_link_color' => '#5658A9',
			'default_header_title_color' => 'FFFFFF' /* important - no # required here */
		),
		'sky-medic' => array(
			'value' => 'sky-medic',
			'label' => __( 'Sky Medic', 'heatmapthemeap' ),
			'thumbnail' => HMTAP_IMAGES_URL . 'sky-medic.png',
			'default_link_color' => '#007AA8',
			'default_header_title_color' => 'FFFFFF' /* important - no # required here */
		),	
		'autumn-redwood' => array(
			'value' => 'autumn-redwood',
			'label' => __( 'Autumn RedWood', 'heatmapthemeap' ),
			'thumbnail' => HMTAP_IMAGES_URL . 'autumn-redwood.png',
			'default_link_color' => '#CB6C68',
			'default_header_title_color' => '5C5753' /* important - no # required here */
		),
		'thirty-fourteen' => array(
			'value' => 'thirty-fourteen',
			'label' => __( 'Thirty Fourteen', 'heatmapthemeap' ),
			'thumbnail' => HMTAP_IMAGES_URL . 'thirty-fourteen.png',
			'default_link_color' => '#333366',
			'default_header_title_color' => '333333' /* important - no # required here */
		),
		'snow-speeding' => array(
			'value' => 'snow-speeding',
			'label' => __( 'Snow Speeding', 'heatmapthemeap' ),
			'thumbnail' => HMTAP_IMAGES_URL . 'snow-speeding.png',
			'default_link_color' => '#0059B2',
			'default_header_title_color' => '333333;' /* important - no # required here */
		),
		'classy-parchment' => array(
			'value' => 'classy-parchment',
			'label' => __( 'Classy Parchment', 'heatmapthemeap' ),
			'thumbnail' => HMTAP_IMAGES_URL . 'classy-parchment.png',
			'default_link_color' => '#611B18',
			'default_header_title_color' => 'FFFFFF' /* important - no # required here */
		),
		'sepia-fourteen' => array(
			'value' => 'sepia-fourteen',
			'label' => __( 'Sepia Fourteen', 'heatmapthemeap' ),
			'thumbnail' => HMTAP_IMAGES_URL . 'sepia-fourteen.png',
			'default_link_color' => '#9A2700',
			'default_header_title_color' => '1C160D' /* important - no # required here */
		),
		
		'safety-yellow' => array(
			'value' => 'safety-yellow',
			'label' => __( 'Safety Yellow', 'heatmapthemeap' ),
			'thumbnail' => HMTAP_IMAGES_URL . 'safety-yellow.png',
			'default_link_color' => '#002DB2',
			'default_header_title_color' => '000000' /* important - no # required here */
		),						
		'green-crunch' => array(
			'value' => 'green-crunch',
			'label' => __( 'Green Crunch', 'heatmapthemeap' ),
			'thumbnail' => HMTAP_IMAGES_URL . 'green-crunch.png',
			'default_link_color' => '#00A700',
			'default_header_title_color' => '006D00' /* important - no # required here */
		),
		'blue-crunch' => array(
			'value' => 'blue-crunch',
			'label' => __( 'Blue Crunch', 'heatmapthemeap' ),
			'thumbnail' => HMTAP_IMAGES_URL . 'blue-crunch.png',
			'default_link_color' => '#005496',
			'default_header_title_color' => '323232' /* important - no # required here */
		),
		'red-crunch' => array(
			'value' => 'red-crunch',
			'label' => __( 'Red Crunch', 'heatmapthemeap' ),
			'thumbnail' => HMTAP_IMAGES_URL . 'red-crunch.png',
			'default_link_color' => '#730202',
			'default_header_title_color' => '260104' /* important - no # required here */
		),
		'orange-crunch' => array(
			'value' => 'orange-crunch',
			'label' => __( 'Orange Crunch', 'heatmapthemeap' ),
			'thumbnail' => HMTAP_IMAGES_URL . 'orange-crunch.png',
			'default_link_color' => '#D13400',
			'default_header_title_color' => '0A0200' /* important - no # required here */
		),
		'black-crunch' => array(
			'value' => 'black-crunch',
			'label' => __( 'Black Crunch', 'heatmapthemeap' ),
			'thumbnail' => HMTAP_IMAGES_URL . 'black-crunch.png',
			'default_link_color' => '#0049B2',
			'default_header_title_color' => '000000' /* important - no # required here */
		),
		'purple-crunch' => array(
			'value' => 'purple-crunch',
			'label' => __( 'Purple Crunch', 'heatmapthemeap' ),
			'thumbnail' => HMTAP_IMAGES_URL . 'purple-crunch.png',
			'default_link_color' => '#630E48',
			'default_header_title_color' => '28241E' /* important - no # required here */
		),	
	);
	
	$color_scheme_options = array_merge( $color_scheme_options, $additional_color_schemes);
	return $color_scheme_options;	
}

add_filter ( 'heatmapthemead_color_schemes', 'heatmapthemeap_add_pro_colour_scheme' );


/* ENQUEUE PRO COLOUR SCHEME IF SET
----------------------------------------------- */

function heatmapthemeap_enqueue_pro_colour_scheme ( $color_scheme ) {
	
	if ( 'green-crunch' == $color_scheme )
		wp_enqueue_style( 'greencrunch', HMTAP_COLOURS_URL . 'green-crunch.css', array(), null );
		
	if ( 'blue-crunch' == $color_scheme )
		wp_enqueue_style( 'bluecrunch', HMTAP_COLOURS_URL . 'blue-crunch.css', array(), null );
		
	if ( 'red-crunch' == $color_scheme )
		wp_enqueue_style( 'redcrunch', HMTAP_COLOURS_URL . 'red-crunch.css', array(), null );
		
	if ( 'orange-crunch' == $color_scheme )
		wp_enqueue_style( 'orangecrunch', HMTAP_COLOURS_URL . 'orange-crunch.css', array(), null );
		
	if ( 'black-crunch' == $color_scheme )
		wp_enqueue_style( 'blackcrunch', HMTAP_COLOURS_URL . 'black-crunch.css', array(), null );	
		
	if ( 'purple-crunch' == $color_scheme )
		wp_enqueue_style( 'purple-crunch', HMTAP_COLOURS_URL . 'purple-crunch.css', array(), null );
		
	if ( 'thirty-fourteen' == $color_scheme )
		wp_enqueue_style( 'thirty-fourteen', HMTAP_COLOURS_URL . 'thirty-fourteen.css', array(), null );	
		
	if ( 'sepia-fourteen' == $color_scheme )
		wp_enqueue_style( 'sepia-fourteen', HMTAP_COLOURS_URL . 'sepia-fourteen.css', array(), null );
		
	if ( 'snow-speeding' == $color_scheme )
		wp_enqueue_style( 'snow-speeding', HMTAP_COLOURS_URL . 'snow-speeding.css', array(), null );
		
	if ( 'the-blues' == $color_scheme )
		wp_enqueue_style( 'the-blues', HMTAP_COLOURS_URL . 'the-blues.css', array(), null );
		
	if ( 'purple-velvet' == $color_scheme )
		wp_enqueue_style( 'the-blues', HMTAP_COLOURS_URL . 'purple-velvet.css', array(), null );
		
	if ( 'safety-yellow' == $color_scheme )
		wp_enqueue_style( 'safety-yellow', HMTAP_COLOURS_URL . 'safety-yellow.css', array(), null );
		
	if ( 'classy-parchment' == $color_scheme )
		wp_enqueue_style( 'classy-parchment', HMTAP_COLOURS_URL . 'classy-parchment.css', array(), null );
		
	if ( 'sky-medic' == $color_scheme )
		wp_enqueue_style( 'sky-medic', HMTAP_COLOURS_URL . 'sky-medic.css', array(), null );	
		
	if ( 'autumn-redwood' == $color_scheme )
		wp_enqueue_style( 'autumn-redwood', HMTAP_COLOURS_URL . 'autumn-redwood.css', array(), null );	
		
}

add_action('heatmapthemead_enqueue_color_scheme', 'heatmapthemeap_enqueue_pro_colour_scheme');


/* PRO LAYOUTS 
--------------------------------------------------------------------------------------------- */

function heatmapthemeap_pro_layout_options () {
	
	add_settings_field( 'home_page_layout', __( 'Home Page Layout', 'heatmapthemeap' ), 'heatmapthemead_settings_field_home_page_layout', 'layout_options', 'layout' );
	add_settings_field( 'page_layout', __( 'Page Layout', 'heatmapthemeap' ), 'heatmapthemead_settings_field_page_layout', 'layout_options', 'layout' );
	add_settings_field( 'post_layout', __( 'Post Layout', 'heatmapthemeap' ), 'heatmapthemead_settings_field_post_layout', 'layout_options', 'layout' );
}

add_action('heatmapthemead_layout_options_top_hook', 'heatmapthemeap_pro_layout_options');


/* PRO HOME PAGE
----------------------------------------------- */

function heatmapthemeap_pro_home_page_layouts( $layout_options ) {
	
	$pro_layout_options = array(
		
		'primary-sidebar-content' => array(
			'value' => 'primary-sidebar-content',
			'label' => __( 'Primary Sidebar + Content', 'heatmapthemeap' ),
			'thumbnail' => get_template_directory_uri() . '/images/primary-sidebar-content.png',
		),
		'content-secondary-sidebar' => array(
			'value' => 'content-secondary-sidebar',
			'label' => __( 'Content + Secondary Sidebar', 'heatmapthemeap' ),
			'thumbnail' => get_template_directory_uri() . '/images/content-secondary-sidebar.png',
		),
		'content' => array(
			'value' => 'content',
			'label' => __( 'Content', 'heatmapthemeap' ),
			'thumbnail' => get_template_directory_uri() . '/images/content.png',
		)
	);
	
	$layout_options = array_merge( $layout_options, $pro_layout_options);

	return $layout_options;
}

add_filter ( 'heatmapthemead_home_page_layouts', 'heatmapthemeap_pro_home_page_layouts' );


/* PRO FULL WIDTH NAVIGATION SETTINGS FIELD
----------------------------------------------- */

function heatmapthemeap_pro_full_width_navigation () {
		
	add_settings_field( 'full_width_navigation', __( 'Full Width Navigation Background', 'heatmapthemeap' ), 'heatmapthemeap_settings_field_full_width_navigation', 'layout_options', 'layout' );	

}

add_action('heatmapthemead_layout_options_group_hook', 'heatmapthemeap_pro_full_width_navigation');


function heatmapthemeap_pro_featured_image_floatleft () {

	add_settings_field( 'featured_image_floatleft', __( 'Featured Image Text Wrap', 'heatmapthemeap' ), 'heatmapthemeap_settings_field_featured_image_floatleft', 'layout_options', 'layout' );

}

add_action('heatmapthemead_layout_options_bottom_hook', 'heatmapthemeap_pro_featured_image_floatleft');


/* PRO FULL WIDTH NAVIGATION SETTINGS FORM FIELD
----------------------------------------------- */

if ( ! function_exists( 'heatmapthemeap_settings_field_full_width_navigation' ) ):

	function heatmapthemeap_settings_field_full_width_navigation() {
		
		$options = heatmapthemead_get_theme_options();
		?>
		<label for="heatmapthemead-full-width-navigation">
			<input type="checkbox" name="heatmapthemead_theme_options[full_width_navigation]" id="heatmapthemead-full-width-navigation" <?php checked( 'on', $options['full_width_navigation'] ); ?> />
		</label>
		<?php
	}

endif; // heatmapthemeap_settings_field_full_width_navigation


/* PRO FEATURED IMAGE FLOATLEFT SETTINGS FORM FIELD
----------------------------------------------- */

if ( ! function_exists( 'heatmapthemeap_settings_field_featured_image_floatleft' ) ):

	function heatmapthemeap_settings_field_featured_image_floatleft() {
		
		$options = heatmapthemead_get_theme_options();
		?>
		<label for="heatmapthemead-featured_image_floatleft">
			<input type="checkbox" name="heatmapthemead_theme_options[featured_image_floatleft]" id="heatmapthemead-featured-image-floatleft" <?php checked( 'on', $options['featured_image_floatleft'] ); ?> />
		<?php	
		print ' ';
		_e ( 'Wrap text to the right of the featured image when image is narrower than content width', 'heatmapthemeap' );	
		?>	
		</label>
		<?php
	}

endif; // heatmapthemeap_settings_field_featured_image_floatleft



/* SANITIZE PRO LAYOUTS
----------------------------------------------- */

function heatmapthemeap_pro_layout_santize ( $output, $input ) {

	$layout_options = '';

	// THEME HOME PAGE LAYOUT
	if ( isset( $input['theme_home_page_layout'] ) && array_key_exists( $input['theme_home_page_layout'], heatmapthemead_home_page_layouts( $layout_options ) ) )
		$output['theme_home_page_layout'] = $input['theme_home_page_layout'];
	// THEME PAGE LAYOUT
	if ( isset( $input['theme_page_layout'] ) && array_key_exists( $input['theme_page_layout'], heatmapthemead_page_layouts( $layout_options ) ) )
		$output['theme_page_layout'] = $input['theme_page_layout'];
	// THEME POST LAYOUT
	if ( isset( $input['theme_post_layout'] ) && array_key_exists( $input['theme_post_layout'], heatmapthemead_post_layouts( $layout_options ) ) )
		$output['theme_post_layout'] = $input['theme_post_layout'];	
	// FULL WIDTH NAVIGATION
	if ( ! isset( $input['full_width_navigation'] ) )
		$input['full_width_navigation'] = 'off';
	$output['full_width_navigation'] = ( $input['full_width_navigation'] == 'on' ? 'on' : 'off' );
	// FEATURED IMAGE FLOAT LEFT	
	if ( ! isset( $input['featured_image_floatleft'] ) )
		$input['featured_image_floatleft'] = 'off';
	$output['featured_image_floatleft'] = ( $input['featured_image_floatleft'] == 'on' ? 'on' : 'off' );		
		
	return $output;
}

add_filter('heatmapthemead_layout_options_sanitize_hook', 'heatmapthemeap_pro_layout_santize',10,2);
// santize the customize screen too
add_filter('heatmapthemead_customize_options_sanitize_hook', 'heatmapthemeap_pro_layout_santize',10,2);


/* PRO PAGE
----------------------------------------------- */

function heatmapthemeap_pro_page_layouts( $layout_options ) {
	
	$pro_layout_options = array(
		
		'primary-sidebar-content' => array(
			'value' => 'primary-sidebar-content',
			'label' => __( 'Primary Sidebar + Content', 'heatmapthemeap' ),
			'thumbnail' => get_template_directory_uri() . '/images/primary-sidebar-content.png',
		),
		'content-secondary-sidebar' => array(
			'value' => 'content-secondary-sidebar',
			'label' => __( 'Content + Secondary Sidebar', 'heatmapthemeap' ),
			'thumbnail' => get_template_directory_uri() . '/images/content-secondary-sidebar.png',
		),
		'content' => array(
			'value' => 'content',
			'label' => __( 'Content', 'heatmapthemeap' ),
			'thumbnail' => get_template_directory_uri() . '/images/content.png',
		)
	);
	
	$layout_options = array_merge( $layout_options, $pro_layout_options);

	return $layout_options;
}

add_filter ( 'heatmapthemead_page_layouts', 'heatmapthemeap_pro_page_layouts' );


/* PRO POST
----------------------------------------------- */

function heatmapthemeap_pro_post_layouts( $layout_options ) {
	
	$pro_layout_options = array(
		
		'primary-sidebar-content' => array(
			'value' => 'primary-sidebar-content',
			'label' => __( 'Primary Sidebar + Content', 'heatmapthemeap' ),
			'thumbnail' => get_template_directory_uri() . '/images/primary-sidebar-content.png',
		),
		'content-secondary-sidebar' => array(
			'value' => 'content-secondary-sidebar',
			'label' => __( 'Content + Secondary Sidebar', 'heatmapthemeap' ),
			'thumbnail' => get_template_directory_uri() . '/images/content-secondary-sidebar.png',
		),
		'content' => array(
			'value' => 'content',
			'label' => __( 'Content', 'heatmapthemeap' ),
			'thumbnail' => get_template_directory_uri() . '/images/content.png',
		)
	);
	
	$layout_options = array_merge( $layout_options, $pro_layout_options);

	return $layout_options;
}

add_filter ( 'heatmapthemead_post_layouts', 'heatmapthemeap_pro_post_layouts' );


/* RENDER LAYOUT CONDITIONAL
----------------------------------------------- */

function heatmapthemeap_render_pro_layout_conditional ( $current_theme_layout ) {

	$heatmapthemead_options = heatmapthemead_get_theme_options();

	if ( is_home() ) $current_theme_layout = $heatmapthemead_options['theme_home_page_layout'];
	if ( is_single() ) $current_theme_layout = $heatmapthemead_options['theme_post_layout'];
	if ( is_page() ) $current_theme_layout = $heatmapthemead_options['theme_page_layout'];
	return $current_theme_layout;
}

add_filter('heatmapthemead_render_layout_options', 'heatmapthemeap_render_pro_layout_conditional',10,1);


/* ADDITIONAL PRO BODY CLASSES
----------------------------------------------- */

function heatmapthemeap_pro_body_class ( $temp_layout_class ) {

	$heatmapthemead_options = heatmapthemead_get_theme_options();

	if ( !is_home() && !is_single() && !is_page() ) $temp_layout_class = 'heatmapthemead-layout-' . $heatmapthemead_options['theme_layout'];
	if ( is_home() ) $temp_layout_class = 'heatmapthemead-layout-' . $heatmapthemead_options['theme_home_page_layout'];
	if ( is_single() ) $temp_layout_class = 'heatmapthemead-layout-' . $heatmapthemead_options['theme_post_layout'];
	if ( is_page() ) $temp_layout_class = 'heatmapthemead-layout-' . $heatmapthemead_options['theme_page_layout'];
	
	return $temp_layout_class;
}

add_filter('heatmapthemead_add_layout_class', 'heatmapthemeap_pro_body_class',10,1);


function heatmapthemeap_pro_floatleft_class ( $temp_layout_class ) {
	
	$heatmapthemead_options = heatmapthemead_get_theme_options();
	
	if ( $heatmapthemead_options ['featured_image_floatleft'] == 'on' ) 
	$temp_layout_class .= ' heatmapthemead-featured-image-floatleft';
	
	return $temp_layout_class;
	
}

add_filter('heatmapthemead_add_layout_class', 'heatmapthemeap_pro_floatleft_class',10,1);

/* PRO FEATURES
--------------------------------------------------------------------------------------------- */

/* ADD SETTING SECTIONS
----------------------------------------------- */

function heatmapthemeap_pro_features () {
	
	// HEADER
	add_settings_section( 'header', __( 'Header Bar', 'heatmapthemeap' ), '__return_false', 'features_options' );
		add_settings_field( 'branding', __( 'Header', 'heatmapthemeap' ), 'heatmapthemeap_settings_field_branding', 'features_options', 'header' );
		
		do_action('heatmapthemeap_header_options_hook');
		
	// NAVIGATION
	add_settings_section( 'navigation', __( 'Navigation Bars', 'heatmapthemeap' ), '__return_false', 'features_options' );
		add_settings_field( 'primary_navigation', __( 'Primary Navigation', 'heatmapthemeap' ), 'heatmapthemeap_settings_field_primary_navigation', 'features_options', 'navigation' );
		add_settings_field( 'secondary_navigation', __( 'Secondary Navigation', 'heatmapthemeap' ), 'heatmapthemeap_settings_field_secondary_navigation', 'features_options', 'navigation' );
		add_settings_field( 'footer_navigation', __( 'Footer Navigation', 'heatmapthemeap' ), 'heatmapthemeap_settings_field_footer_navigation', 'features_options', 'navigation' );
		add_settings_field( 'post_navigation', __( 'Post Navigation', 'heatmapthemeap' ), 'heatmapthemeap_settings_field_post_navigation', 'features_options', 'navigation' );
		
		do_action('heatmapthemeap_navigation_options_hook');

	// META
	add_settings_section( 'meta', __( 'Meta', 'heatmapthemeap' ), '__return_false', 'features_options' );
		add_settings_field( 'meta_date', __( 'Date', 'heatmapthemeap' ), 'heatmapthemeap_settings_field_meta_date', 'features_options', 'meta' );
		add_settings_field( 'meta_author', __( 'Author', 'heatmapthemeap' ), 'heatmapthemeap_settings_field_meta_author', 'features_options', 'meta' );
		add_settings_field( 'meta_comments', __( 'Comments', 'heatmapthemeap' ), 'heatmapthemeap_settings_field_meta_comments', 'features_options', 'meta' );
		add_settings_field( 'meta_categories', __( 'Categories', 'heatmapthemeap' ), 'heatmapthemeap_settings_field_meta_categories', 'features_options', 'meta' );
		add_settings_field( 'meta_tags', __( 'Tags', 'heatmapthemeap' ), 'heatmapthemeap_settings_field_meta_tags', 'features_options', 'meta' );
		add_settings_field( 'page_meta', __( 'Display Meta on Pages', 'heatmapthemeap' ), 'heatmapthemeap_settings_field_page_meta', 'features_options', 'meta' );

		do_action('heatmapthemeap_meta_options_hook');

	// IMAGES
	add_settings_section( 'theme_images', __( 'Images', 'heatmapthemeap' ), '__return_false', 'features_options' );
		add_settings_field( 'featured_image', __( 'Featured Image', 'heatmapthemeap' ), 'heatmapthemeap_settings_field_featured_image', 'features_options', 'theme_images' );
	
}

add_action('heatmapthemead_featured_page_options_hook', 'heatmapthemeap_pro_features');


/* SANITIZE PRO FEATURES
----------------------------------------------- */

function heatmapthemeap_pro_features_santize ( $output, $input ) {

		// BRANDING
		if ( ! isset( $input['branding'] ) )
			$input['branding'] = 'off';
		$output['branding'] = ( $input['branding'] == 'on' ? 'on' : 'off' );
		// PRIMARY NAVIGATION	
		if ( ! isset( $input['primary_navigation'] ) )
			$input['primary_navigation'] = 'off';
		$output['primary_navigation'] = ( $input['primary_navigation'] == 'on' ? 'on' : 'off' );
		// SECONDARY NAVIGATION
		if ( ! isset( $input['secondary_navigation'] ) )
			$input['secondary_navigation'] = 'off';
		$output['secondary_navigation'] = ( $input['secondary_navigation'] == 'on' ? 'on' : 'off' );	
		// FOOTER NAVIGATION
		if ( ! isset( $input['footer_navigation'] ) )
			$input['footer_navigation'] = 'off';
		$output['footer_navigation'] = ( $input['footer_navigation'] == 'on' ? 'on' : 'off' );							
		// POST NAVIGATION
		if ( ! isset( $input['post_navigation'] ) )
			$input['post_navigation'] = 'off';
		$output['post_navigation'] = ( $input['post_navigation'] == 'on' ? 'on' : 'off' );
		// META DATE
		if ( ! isset( $input['meta_date'] ) )
			$input['meta_date'] = 'off';
		$output['meta_date'] = ( $input['meta_date'] == 'on' ? 'on' : 'off' );
		// META AUTHOR
		if ( ! isset( $input['meta_author'] ) )
			$input['meta_author'] = 'off';
		$output['meta_author'] = ( $input['meta_author'] == 'on' ? 'on' : 'off' );
		// META COMMENTS
		if ( ! isset( $input['meta_comments'] ) )
			$input['meta_comments'] = 'off';
		$output['meta_comments'] = ( $input['meta_comments'] == 'on' ? 'on' : 'off' );
		// META CATEGORIES
		if ( ! isset( $input['meta_categories'] ) )
			$input['meta_categories'] = 'off';
		$output['meta_categories'] = ( $input['meta_categories'] == 'on' ? 'on' : 'off' );
		// META TAGS
		if ( ! isset( $input['meta_tags'] ) )
			$input['meta_tags'] = 'off';
		$output['meta_tags'] = ( $input['meta_tags'] == 'on' ? 'on' : 'off' );
		// PAGE META
		if ( ! isset( $input['page_meta'] ) )
			$input['page_meta'] = 'off';
		$output['page_meta'] = ( $input['page_meta'] == 'on' ? 'on' : 'off' );
		// FEATURED IMAGES
		if ( ! isset( $input['featured_image'] ) )
			$input['featured_image'] = 'off';
		$output['featured_image'] = ( $input['featured_image'] == 'on' ? 'on' : 'off' );
		
		return $output;
}

add_filter('heatmapthemead_features_options_sanitize_hook', 'heatmapthemeap_pro_features_santize',10,2);

/* BRANDING
----------------------------------------------- */

if ( ! function_exists( 'heatmapthemeap_settings_field_branding' ) ):

	function heatmapthemeap_settings_field_branding() {
		
		$options = heatmapthemead_get_theme_options();
		?>
		<label for="heatmapthemead-branding">
			<input type="checkbox" name="heatmapthemead_theme_options[branding]" id="heatmapthemead-branding" <?php checked( 'on', $options['branding'] ); ?> />
		</label>
		<?php
	}

endif; // heatmapthemeap_settings_field_branding


/* PRIMARY NAVIGATION
----------------------------------------------- */

if ( ! function_exists( 'heatmapthemeap_settings_field_primary_navigation' ) ):

	function heatmapthemeap_settings_field_primary_navigation() {
		
		$options = heatmapthemead_get_theme_options();
		?>
		<label for="heatmapthemead-primary-navigation">
			<input type="checkbox" name="heatmapthemead_theme_options[primary_navigation]" id="heatmapthemead-primary-navigation" <?php checked( 'on', $options['primary_navigation'] ); ?> />
		</label>
		<?php
	}

endif; // heatmapthemeap_settings_field_primary_navigation


/* SECONDARY NAVIGATION
----------------------------------------------- */

if ( ! function_exists( 'heatmapthemeap_settings_field_secondary_navigation' ) ):

	function heatmapthemeap_settings_field_secondary_navigation() {
		
		$options = heatmapthemead_get_theme_options();
		?>
		<label for="heatmapthemead-secondary-navigation">
			<input type="checkbox" name="heatmapthemead_theme_options[secondary_navigation]" id="heatmapthemead-secondary-navigation" <?php checked( 'on', $options['secondary_navigation'] ); ?> />
		</label>
		<?php
	}

endif; // heatmapthemeap_settings_field_secondary_navigation


/* FOOTER NAVIGATION
----------------------------------------------- */

if ( ! function_exists( 'heatmapthemeap_settings_field_footer_navigation' ) ):

	function heatmapthemeap_settings_field_footer_navigation() {
		
		$options = heatmapthemead_get_theme_options();
		?>
		<label for="heatmapthemead-footer-navigation">
			<input type="checkbox" name="heatmapthemead_theme_options[footer_navigation]" id="heatmapthemead-footer-navigation" <?php checked( 'on', $options['footer_navigation'] ); ?> />
		</label>
		<?php
	}

endif; // heatmapthemeap_settings_field_footer_navigation


/* POST NAVIGATION
----------------------------------------------- */

if ( ! function_exists( 'heatmapthemeap_settings_field_post_navigation' ) ):

	function heatmapthemeap_settings_field_post_navigation() {
		
		$options = heatmapthemead_get_theme_options();
		?>
		<label for="heatmapthemead-post-navigation">
			<input type="checkbox" name="heatmapthemead_theme_options[post_navigation]" id="heatmapthemead-post-navigation" <?php checked( 'on', $options['post_navigation'] ); ?> />
		</label>
		<?php
	}

endif; // heatmapthemeap_settings_field_post_navigation


/* DATE
----------------------------------------------- */

if ( ! function_exists( 'heatmapthemeap_settings_field_meta_date' ) ):

	function heatmapthemeap_settings_field_meta_date() {
		
		$options = heatmapthemead_get_theme_options();
		?>
		<label for="heatmapthemead-meta-date">
			<input type="checkbox" name="heatmapthemead_theme_options[meta_date]" id="heatmapthemead-meta-date" <?php checked( 'on', $options['meta_date'] ); ?> />
		</label>
		<?php
	}

endif; // heatmapthemeap_settings_field_meta_date


/* AUTHOR
----------------------------------------------- */

if ( ! function_exists( 'heatmapthemeap_settings_field_meta_author' ) ):

	function heatmapthemeap_settings_field_meta_author() {
		
		$options = heatmapthemead_get_theme_options();
		?>
		<label for="heatmapthemead-meta-author">
			<input type="checkbox" name="heatmapthemead_theme_options[meta_author]" id="heatmapthemead-meta-author" <?php checked( 'on', $options['meta_author'] ); ?> />
		</label>
		<?php
	}

endif; // heatmapthemeap_settings_field_meta_author


/* COMMENTS
----------------------------------------------- */

if ( ! function_exists( 'heatmapthemeap_settings_field_meta_comments' ) ):

	function heatmapthemeap_settings_field_meta_comments() {
		
		$options = heatmapthemead_get_theme_options();
		?>
		<label for="heatmapthemead-meta-comments">
			<input type="checkbox" name="heatmapthemead_theme_options[meta_comments]" id="heatmapthemead-meta-comments" <?php checked( 'on', $options['meta_comments'] ); ?> />
		</label>
		<?php
	}

endif; // heatmapthemeap_settings_field_meta_comments


// CATEGORIES ------------------------

if ( ! function_exists( 'heatmapthemeap_settings_field_meta_categories' ) ):

	function heatmapthemeap_settings_field_meta_categories() {
		$options = heatmapthemead_get_theme_options();
		?>
		<label for="heatmapthemead-meta-categories">
			<input type="checkbox" name="heatmapthemead_theme_options[meta_categories]" id="heatmapthemead-meta-categories" <?php checked( 'on', $options['meta_categories'] ); ?> />
		</label>
		<?php
	}

endif; // heatmapthemeap_settings_field_meta_categories


/* TAGS
----------------------------------------------- */

if ( ! function_exists( 'heatmapthemeap_settings_field_meta_tags' ) ):

	function heatmapthemeap_settings_field_meta_tags() {
		$options = heatmapthemead_get_theme_options();
		?>
		<label for="heatmapthemead-meta-tags">
			<input type="checkbox" name="heatmapthemead_theme_options[meta_tags]" id="heatmapthemead-meta-tags" <?php checked( 'on', $options['meta_tags'] ); ?> />
		</label>
		<?php
	}

endif; // heatmapthemeap_settings_field_meta_tags


/* PAGE META
----------------------------------------------- */

if ( ! function_exists( 'heatmapthemeap_settings_field_page_meta' ) ):

	function heatmapthemeap_settings_field_page_meta() {
		$options = heatmapthemead_get_theme_options();
		?>
		<label for="heatmapthemead-page-meta">
			<input type="checkbox" name="heatmapthemead_theme_options[page_meta]" id="heatmapthemead-page-meta" <?php checked( 'on', $options['page_meta'] ); ?> />
		</label>
		<?php
	}

endif; // heatmapthemeap_settings_field_page_meta


/* FEATURED IMAGES
----------------------------------------------- */

if ( ! function_exists( 'heatmapthemeap_settings_field_featured_image' ) ):

	function heatmapthemeap_settings_field_featured_image() {
		
		$options = heatmapthemead_get_theme_options();
		?>
		<label for="heatmapthemead-featured-image">
			<input type="checkbox" name="heatmapthemead_theme_options[featured_image]" id="heatmapthemead-featured-image" <?php checked( 'on', $options['featured_image'] ); ?> />
		</label>
		<?php
	}

endif; // heatmapthemeap_settings_field_featured_image


/* PRO SOCIAL
--------------------------------------------------------------------------------------------- */

function heatmapthemeap_pro_social () {
	// LIKE
	add_settings_section( 'like', __( 'Like Buttons', 'heatmapthemeap' ), '__return_false', 'social_options' );
		add_settings_field( 'facebook_like', __( 'Facebook Like Button', 'heatmapthemeap' ), 'heatmapthemeap_settings_field_facebook_like', 'social_options', 'like' );
		add_settings_field( 'twitter_like', __( 'Twitter Tweet Button', 'heatmapthemeap' ), 'heatmapthemeap_settings_field_twitter_like', 'social_options', 'like' ); 
		add_settings_field( 'googleplusone_like', __( 'Google +1 Button', 'heatmapthemeap' ), 'heatmapthemeap_settings_field_googleplusone_like', 'social_options', 'like' ); 
		
		do_action('heatmapthemeap_like_buttons_options_hook');
}

add_action('heatmapthemead_social_profile_options_hook', 'heatmapthemeap_pro_social');


/* SANITIZE PRO SOCIAL
----------------------------------------------- */

function heatmapthemeap_pro_social_santize ( $output, $input ) {

		// FACEBOOK LIKE
		if ( ! isset( $input['facebook_like'] ) )
			$input['facebook_like'] = 'off';
		$output['facebook_like'] = ( $input['facebook_like'] == 'on' ? 'on' : 'off' );
		// TWITTER LIKE
		if ( ! isset( $input['twitter_like'] ) )
			$input['twitter_like'] = 'off';
		$output['twitter_like'] = ( $input['twitter_like'] == 'on' ? 'on' : 'off' );
		// GOOGLE PLUS ONE LIKE
		if ( ! isset( $input['googleplusone_like'] ) )
			$input['googleplusone_like'] = 'off';
		$output['googleplusone_like'] = ( $input['googleplusone_like'] == 'on' ? 'on' : 'off' );
		
		return $output;
}

add_filter('heatmapthemead_social_options_sanitize_hook', 'heatmapthemeap_pro_social_santize',10,2);


/* SOCIAL OPTIONS - LIKE BUTTONS
----------------------------------------------- */

/* FACEBOOK LIKE BUTTON
----------------------------------------------- */

if ( ! function_exists( 'heatmapthemeap_settings_field_facebook_like' ) ):

	function heatmapthemeap_settings_field_facebook_like() {
		
		$options = heatmapthemead_get_theme_options();
		?>
		<label for="heatmapthemead-facebook-like">
			<input type="checkbox" name="heatmapthemead_theme_options[facebook_like]" id="heatmapthemead-facebook-like" <?php checked( 'on', $options['facebook_like'] ); ?> />
		</label>
		<?php
	}

endif; // heatmapthemead_settings_field_facebook_like


/* TWITTER LIKE BUTTON
----------------------------------------------- */

if ( ! function_exists( 'heatmapthemeap_settings_field_twitter_like' ) ):

	function heatmapthemeap_settings_field_twitter_like() {
		
		$options = heatmapthemead_get_theme_options();
		?>
		<label for="heatmapthemead-twitter-like">
			<input type="checkbox" name="heatmapthemead_theme_options[twitter_like]" id="heatmapthemead-twitter-like" <?php checked( 'on', $options['twitter_like'] ); ?> />
		</label>
		<?php
	}

endif; // heatmapthemead_settings_field_twitter_like


/* GOOGLEPLUSONE LIKE BUTTON
----------------------------------------------- */

if ( ! function_exists( 'heatmapthemeap_settings_field_googleplusone_like' ) ):

	function heatmapthemeap_settings_field_googleplusone_like() {
		$options = heatmapthemead_get_theme_options();
		?>
		<label for="heatmapthemead-googleplusone-like">
			<input type="checkbox" name="heatmapthemead_theme_options[googleplusone_like]" id="heatmapthemead-googleplusone-like" <?php checked( 'on', $options['googleplusone_like'] ); ?> />
		</label>
		<?php
	}

endif; // heatmapthemead_settings_field_googleplusone_like


// FACEBOOK SDK
/*-----------------------------------------------------------------------------------*/

if ( ! function_exists( 'heatmapthemeap_fb_sdk' ) ):

	function heatmapthemeap_fb_sdk() {
		
		$options = heatmapthemead_get_theme_options();
		
		if ($options['facebook_like'] == 'on') {
		
			print '
			<div id="fb-root"></div>
			<script>
				(function(d, s, id) {
  					var js, fjs = d.getElementsByTagName(s)[0];
  					if (d.getElementById(id)) return;
  					js = d.createElement(s); js.id = id;
  					js.src = "//connect.facebook.net/en_GB/all.js#xfbml=1&status=0";
  					fjs.parentNode.insertBefore(js, fjs);
				}(document, \'script\', \'facebook-jssdk\'));
			</script>';
		}
	}

endif; // heatmapthemead_fb_sdk

add_action('heatmapthemead_end_body_hook', 'heatmapthemeap_fb_sdk');



/* PRO MISC
--------------------------------------------------------------------------------------------- */

function heatmapthemeap_pro_misc () {
	// SCRIPTS
	add_settings_section( 'scripts', __( 'Scripts', 'heatmapthemeap' ), '__return_false', 'misc_options' );
	
		add_settings_field( 'css_scripts', __( 'Custom CSS Override', 'heatmapthemeap' ), 'heatmapthemeap_settings_field_css_scripts', 'misc_options', 'scripts' );	
		add_settings_field( 'head_scripts', __( '&lt;HEAD&gt; Scripts', 'heatmapthemeap' ), 'heatmapthemeap_settings_field_head_scripts', 'misc_options', 'scripts' );
		add_settings_field( 'footer_scripts', __( '&lt;/BODY&gt; Scripts', 'heatmapthemeap' ), 'heatmapthemeap_settings_field_footer_scripts', 'misc_options', 'scripts' );
		
	// CREDITS
	add_settings_section( 'credits', __( 'Credits', 'heatmapthemeap' ), '__return_false', 'misc_options' );
		add_settings_field( 'subfooter_navigation', __( 'Credits Subfooter Bar', 'heatmapthemeap' ), 'heatmapthemeap_settings_field_subfooter_navigation', 'misc_options', 'credits' );
		add_settings_field( 'credits_footer', __( 'Credit Link', 'heatmapthemeap' ), 'heatmapthemeap_settings_field_credits_footer', 'misc_options', 'credits' );
}

add_action('heatmapthemead_misc_options_top_hook', 'heatmapthemeap_pro_misc');


/* SANITIZE PRO MISC
----------------------------------------------- */

function heatmapthemeap_pro_misc_santize ( $output, $input ) {

		// CSS SCRIPTS
		if ( isset( $input['css_scripts'] ) )
			$output['css_scripts'] = wp_kses_stripslashes( $input['css_scripts'] ); 
		// HEAD SCRIPTS
		if ( isset( $input['head_scripts'] ) )
			$output['head_scripts'] = wp_kses_stripslashes( $input['head_scripts'] ); 
		// FOOTER SCRIPTS
		if ( isset( $input['footer_scripts'] ) )
			$output['footer_scripts'] = wp_kses_stripslashes( $input['footer_scripts'] );
		// SUBFOOTER NAVIGATION
		if ( ! isset( $input['subfooter_navigation'] ) )
			$input['subfooter_navigation'] = 'off';
		$output['subfooter_navigation'] = ( $input['subfooter_navigation'] == 'on' ? 'on' : 'off' );	
		// CREDITS FOOTER
		if ( isset( $input['credits_footer'] ) )
			$output['credits_footer'] = wp_kses_post( $input['credits_footer'] );	
			 
		return $output;
}

add_filter('heatmapthemead_misc_options_sanitize_hook', 'heatmapthemeap_pro_misc_santize',10,2);



/* PRO CSS SCRIPT FORM FIELD
----------------------------------------------- */

if ( ! function_exists( 'heatmapthemeap_settings_field_css_scripts' ) ):

	function heatmapthemeap_settings_field_css_scripts() {
		
		$options = heatmapthemead_get_theme_options();
		if ( !isset( $options['css_scripts'] ) ) $options['css_scripts'] = '';
		?>
		<label for="heatmapthemead-css-scripts">
			<textarea class="large-text" name="heatmapthemead_theme_options[css_scripts]" id="heatmapthemead-css-scripts" cols="50" rows="12"><?php echo esc_textarea( $options['css_scripts'] ); ?></textarea>
			<?php _e ( 'Any CSS placed here will override CSS in the theme itself. Use it to make quick customisations.', 'heatmapthemeap' ) ?>
		</label>
		<?php
	}

endif; // heatmapthemead_settings_field_css_scripts

/* HEAD SCRIPTS
----------------------------------------------- */

if ( ! function_exists( 'heatmapthemeap_settings_field_head_scripts' ) ):

	function heatmapthemeap_settings_field_head_scripts() {
		
		$options = heatmapthemead_get_theme_options();
		if ( !isset( $options['head_scripts'] ) ) $options['head_scripts'] = '';
		?>
		<label for="heatmapthemead-head-scripts">
			<textarea class="large-text" name="heatmapthemead_theme_options[head_scripts]" id="heatmapthemead-head-scripts" cols="50" rows="12"><?php echo esc_textarea( $options['head_scripts'] ); ?></textarea>
			<?php _e ('You place can tracking scripts like Google Analytics here. They will appear between the HEAD HTML tags.', 'heatmapthemeap') ?>
		</label>
		<?php
	}

endif; // heatmapthemeap_settings_field_head_scripts


/* FOOTER SCRIPTS
----------------------------------------------- */

if ( ! function_exists( 'heatmapthemeap_settings_field_footer_scripts' ) ):

	function heatmapthemeap_settings_field_footer_scripts() {
		$options = heatmapthemead_get_theme_options();
		if ( !isset( $options['footer_scripts'] ) ) $options['footer_scripts'] = '';
		?>
		<label for="heatmapthemead-footer-scripts">
			<textarea class="large-text" name="heatmapthemead_theme_options[footer_scripts]" id="heatmapthemead-footer-scripts" cols="50" rows="12" ><?php echo esc_textarea( $options['footer_scripts'] ); ?></textarea>
			<?php _e ('Scripts placed here will appear just before the closing BODY HTML tag.', 'heatmapthemeap') ?>
		</label>	
		<?php
	}

endif; // heatmapthemeap_settings_field_footer_scripts


/* SUBFOOTER NAVIGATION (CREDITS AREA)
----------------------------------------------- */

if ( ! function_exists( 'heatmapthemeap_settings_field_subfooter_navigation' ) ):

	function heatmapthemeap_settings_field_subfooter_navigation() {
		
		$options = heatmapthemead_get_theme_options();
		?>
		<label for="heatmapthemead-subfooter-navigation">
			<input type="checkbox" name="heatmapthemead_theme_options[subfooter_navigation]" id="heatmapthemead-subfooter-navigation" <?php checked( 'on', $options['subfooter_navigation'] ); ?> />
			<?php _e( 'Like the theme? If you choose to keep the credit link we say thankyou!', 'heatmapthemeap' );  ?>
		</label>
		<?php
	}

endif; // heatmapthemeap_settings_field_subfooter_navigation 


/* CREDITS
----------------------------------------------- */

if ( ! function_exists( 'heatmapthemeap_settings_field_credits_footer' ) ):

	function heatmapthemeap_settings_field_credits_footer() {
		
		$options = heatmapthemead_get_theme_options();
		if ( !isset( $options['credits_footer'] ) ) $options['credits_footer'] = '';
		?>
		<label for="heatmapthemead-credits">
			<textarea class="large-text" name="heatmapthemead_theme_options[credits_footer]" id="heatmapthemead-credits" cols="50" rows="4"><?php echo esc_textarea( $options['credits_footer'] ); ?></textarea>
		</label>
		<?php
	}

endif; // heatmapthemeap_settings_field_credits_footer


/* THEME CUSTOMISER
--------------------------------------------------------------------------------------------- */
if ( ! function_exists( 'heatmapthemeap_customize_register' ) ):

	function heatmapthemeap_customize_register( $wp_customize ) {
		$wp_customize->get_setting( 'blogname' )->transport = 'postMessage';
		$wp_customize->get_setting( 'blogdescription' )->transport = 'postMessage';
	
		$options  = heatmapthemead_get_theme_options();
		$defaults = heatmapthemead_get_default_theme_options();
	
		// Home Page Layout
		$wp_customize->add_setting( 'heatmapthemead_theme_options[theme_home_page_layout]', array(
			'type'              => 'option',
			'default'           => $defaults['theme_home_page_layout'],
			'sanitize_callback' => 'sanitize_key',
		) );
	
		$layouts = heatmapthemead_home_page_layouts( '' );
		$choices = array();
		foreach ( $layouts as $layout ) {
			$choices[$layout['value']] = $layout['label'];
		}
	
		$wp_customize->add_control( 'heatmapthemead_theme_options[theme_home_page_layout]', array(
			'label'    => __( 'Home Page Layout', 'heatmapthemeap' ),
			'section'    => 'heatmapthemead_layout',
			'type'       => 'radio',
			'choices'    => $choices,
		) );
		
		// Post Layout
		$wp_customize->add_setting( 'heatmapthemead_theme_options[theme_post_layout]', array(
			'type'              => 'option',
			'default'           => $defaults['theme_post_layout'],
			'sanitize_callback' => 'sanitize_key',
		) );
	
		$layouts = heatmapthemead_post_layouts( '' );
		$choices = array();
		foreach ( $layouts as $layout ) {
			$choices[$layout['value']] = $layout['label'];
		}
	
		$wp_customize->add_control( 'heatmapthemead_theme_options[theme_post_layout]', array(
			'label'    => __( 'Post Layout', 'heatmapthemeap' ),
			'section'    => 'heatmapthemead_layout',
			'type'       => 'radio',
			'choices'    => $choices,
		) );
		
		// Page Layout
		$wp_customize->add_setting( 'heatmapthemead_theme_options[theme_page_layout]', array(
			'type'              => 'option',
			'default'           => $defaults['theme_page_layout'],
			'sanitize_callback' => 'sanitize_key',
		) );
	
		$layouts = heatmapthemead_page_layouts( '' );
		$choices = array();
		foreach ( $layouts as $layout ) {
			$choices[$layout['value']] = $layout['label'];
		}
	
		$wp_customize->add_control( 'heatmapthemead_theme_options[theme_page_layout]', array(
			'label'    => __( 'Page Layout', 'heatmapthemeap' ),
			'section'    => 'heatmapthemead_layout',
			'type'       => 'radio',
			'choices'    => $choices,
		) );		
		
		// Default Layout
		$wp_customize->add_setting( 'heatmapthemead_theme_options[theme_layout]', array(
			'type'              => 'option',
			'default'           => $defaults['theme_layout'],
			'sanitize_callback' => 'sanitize_key',
		) );
	
		$layouts = heatmapthemead_layouts( '' );
		$choices = array();
		foreach ( $layouts as $layout ) {
			$choices[$layout['value']] = $layout['label'];
		}
	
		$wp_customize->add_control( 'heatmapthemead_theme_options[theme_layout]', array(
			'label'    => __( 'Default Layout', 'heatmapthemeap' ),
			'section'    => 'heatmapthemead_layout',
			'type'       => 'radio',
			'choices'    => $choices,
		) );
	}

endif; // heatmapthemeap_customize_register

add_action( 'customize_register', 'heatmapthemeap_customize_register' );


/* WELCOME TAB CONTENT
--------------------------------------------------------------------------------------------- */

function heatmapthemeap_welcome_tab_content () {

	print '<div style="max-width: 600px">';
	
	print '<p><strong>' . __('To change the default logo','heatmapthemeap') . '</strong> '; 
	printf(__('<a href="%s">use the Header options</a>.</p>', 'heatmapthemeap'), admin_url('themes.php?page=custom-header')); 
	
	print '<p><strong>' . __('To create and position an ad','heatmapthemeap') . '</strong> ';
	printf(__('<a href="%s">use the Widget Manager</a>', 'heatmapthemeap'), admin_url('widgets.php'));
	print ' ';
	print __('and then drag a','heatmapthemeap') . '<strong> ' . __('HeatMap AdAptive Ad widget', 'heatmapthemeap') . '</strong> ' . __('into the widget position of your choice.', 'heatmapthemeap') . '</p>';
	
	print '<p><strong>' . __('For information about creating responsive ads','heatmapthemeap') . '</strong> '; 
	printf(__('<a href="%s" target="_blank">read these tips</a>.</p>', 'heatmapthemeap'), HMTA_RESPONSIVE_ADS_URL);
	
	print '<h3>' . __('Here is a map of my widget positions', 'heatmapthemeap') . '</h3>'; 
	
	print '<img src="';
	print HMTAP_IMAGES_URL;
	print 'widget-placement-map.png"  alt="' . __( 'Widget Placement Map', 'heatmapthemeap' ) . '" />';
	
	print '<hr/>';
	print '</div>';
}

remove_action ('heatmapthemead_settings_field_welcome_hook', 'heatmapthemead_welcome_tab_content');
add_action ('heatmapthemead_settings_field_welcome_hook', 'heatmapthemeap_welcome_tab_content');	
?>