<?php 
/* 
This file is part of HeatMap Theme AdAptive
See license.txt (distributed with this file) for details of
license, contributors, copyright notices, credits and trademarks.
*/

// SET THE DOMAIN FOR TRANSLATIONS 
/*-----------------------------------------------------------------------------------*/

function heatmapthemead_theme_setup(){
    load_theme_textdomain('heatmapthemead', get_template_directory() . '/languages');
}
add_action('after_setup_theme', 'heatmapthemead_theme_setup');

// load_theme_textdomain('heatmapthemead');
									
//  BREAK FUNCTIONS.PHP DOWN INTO SOME MORE MEANINGFUL CHUNKS
/*-----------------------------------------------------------------------------------*/

require( get_template_directory() . '/inc/wp-tweaks.php' );
require( get_template_directory() . '/inc/theme-vars.php' );
require( get_template_directory() . '/inc/theme-header.php' );
require( get_template_directory() . '/inc/theme-menus.php' );
require( get_template_directory() . '/inc/theme-widgets.php' );
require( get_template_directory() . '/inc/theme-options.php' );
require( get_template_directory() . '/inc/theme-metabox.php' );
require( get_template_directory() . '/inc/theme-tags.php' );

//  ADD SUPPORT FOR CUSTOM BACKGROUNDS
/*-----------------------------------------------------------------------------------*/

add_theme_support( 'custom-background' );

//  ADD SUPPORT FOR FEATURED IMAGES
/*-----------------------------------------------------------------------------------*/

add_theme_support( 'post-thumbnails' );

//  ADD SUPPORT FOR AUTOMATIC THEME LINKS
/*-----------------------------------------------------------------------------------*/

add_theme_support( 'automatic-feed-links' );

//  SET THE CONTENT WIDTH
/*-----------------------------------------------------------------------------------*/

function heatmapthemead_content_width() {
	global $content_width;
	$options = heatmapthemead_get_theme_options();
	$content_width = $options['default_image_width'];
}
add_action( 'after_setup_theme', 'heatmapthemead_content_width' );

/* ENQUEUE STYLES FOR THEME OPTIONS PAGE
--------------------------------------------------------------------------------------------- */

function heatmapthemead_admin_enqueue_scripts( $hook_suffix ) {
	wp_enqueue_style( 'heatmapthemead-theme-options', get_template_directory_uri() . '/css/theme-options.css', false, '2013-04-30' );
}
add_action( 'admin_print_styles-appearance_page_theme_options', 'heatmapthemead_admin_enqueue_scripts' );

// thanks Matt Wiebe for the the tute here
// http://make.wordpress.org/core/2012/11/30/new-color-picker-in-wp-3-5/
function heatmapthemead_enqueue_color_picker( $hook_suffix ) {
    wp_enqueue_style( 'wp-color-picker' );
    wp_enqueue_script( 'my-script-handle', get_template_directory_uri() . '/js/theme-options.js', array( 'wp-color-picker' ), false, true );
}
add_action( 'admin_enqueue_scripts', 'heatmapthemead_enqueue_color_picker' );


//  ENQUEUE SCRIPTS INTO wp_head()
/*-----------------------------------------------------------------------------------*/

function heatmapthemead_scripts() {
	global $post;
	
	add_filter( 'use_default_gallery_style', '__return_false' ); /* remove the default gallery styling */

	wp_enqueue_style( 'style', get_stylesheet_uri(),'','20130606' );
	
	wp_enqueue_script( 'heatmapthemead-small-menu', get_template_directory_uri() . '/js/small-menu.js', array( 'jquery' ) );
	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}
	
	// Detect < IE9 and include fixes
	if(preg_match('/(?i)msie [1-8]/',$_SERVER['HTTP_USER_AGENT']))
	{
		wp_enqueue_style( 'heatmapthemead-iefix', get_template_directory_uri() . '/css/iefix.css','style','20130606');
		wp_enqueue_script( 'heatmapthemead-html5', get_template_directory_uri() . '/js/html5.js','','20130606');
		wp_enqueue_script( 'heatmapthemead-respond', get_template_directory_uri() . '/js/respond.min.js','','20130606');
	}
}
add_action( 'wp_enqueue_scripts', 'heatmapthemead_scripts' );

do_action ( 'heatmapthemead_additional_plugins_hook' );

// DANGER WILL ROBINSON! Only uncomment below when you want to completely erase the theme options.
// delete_option ( 'heatmapthemead_theme_options'); 
 
/* ADD THE OPTIONS TO THE DATABASE IF THEY DONT EXIST ALREADY
--------------------------------------------------------------------------------------------- */

$initialise_options = heatmapthemead_get_default_theme_options();
add_option ( 'heatmapthemead_theme_options', $initialise_options );
?>