<?php
/* 
This file is part of HeatMap Theme AdAptive
See license.txt (distributed with this file) for details of
license, contributors, copyright notices, credits and trademarks.
*/

/* REGISTER ALL WIDGET POSITIONS
--------------------------------------------------------------------------------------------- */

function heatmapthemead_register_sidebars () {

	// PRIMARY SIDEBAR
	register_sidebar(
		array(
		'name' => __( 'Primary Sidebar','heatmapthemead' ),
		'id' => 'heatmapthemeadprimary',
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => '</aside>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4>'
		)	
	);
	
	do_action('heatmapthemead_primary_sidebar_registration_hook');

	// SECONDARY SIDEBAR
	register_sidebar(
		array(
		'name' => __( 'Secondary Sidebar','heatmapthemead' ),
		'id' => 'heatmapthemeadsecondary',
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => '</aside>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4>'
		)
	);

	do_action('heatmapthemead_secondary_sidebar_registration_hook');

	// HEADER
	register_sidebar(
		array(
		'name' => __( 'Header','heatmapthemead' ),
		'id' => 'heatmapthemeadheader',
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => '</aside>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4>'
		)
	);
	
	do_action('heatmapthemead_header_registration_hook');
	
	// LEADERBOARD
	register_sidebar(
		array(
		'name' => __( 'Leaderboard','heatmapthemead' ),
		'id' => 'heatmapthemeadleaderboard',
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => '</aside>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4>'
		)
	);
	
	do_action('heatmapthemead_leaderboard_registration_hook');
		
	// BLOG TOP
	register_sidebar(
		array(
		'name' => __( 'Blog (top)','heatmapthemead' ),
		'id' => 'heatmapthemeadblogabove',
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => '</aside>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4>'
		)
	);
	
	do_action('heatmapthemead_blog_top_registration_hook');

	// POST INLINE
	register_sidebar(
		array(
		'name' => __( 'Post (inline)','heatmapthemead' ),
		'id' => 'heatmapthemeadpostinline',
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => '</aside>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4>'
		)
	);
	
	do_action('heatmapthemead_post_inline_registration_hook');
	
	// POST IN-CONTENT
	register_sidebar(
		array(
		'name' => __( 'Post (in-content)','heatmapthemead' ),
		'id' => 'heatmapthemeadpostincontent',
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => '</aside>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4>'
		)
	);
	
	do_action('heatmapthemead_post_content_registration_hook');
	
	// POST BELOW
	register_sidebar(
		array(
		'name' => __( 'Post (below content)','heatmapthemead' ),
		'id' => 'heatmapthemeadpostbelow',
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => '</aside>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4>'
		)
	);
	
	do_action('heatmapthemead_post_below_registration_hook');
	
	// BLOG BOTTOM
	register_sidebar(
		array(
		'name' => __( 'Blog (bottom)','heatmapthemead' ),
		'id' => 'heatmapthemeadblogbelow',
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => '</aside>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4>'
		)
	);	
	
	do_action('heatmapthemead_blog_bottom_registration_hook');
		
}	

/* WIDGET POSITION FUNCTIONS
--------------------------------------------------------------------------------------------- */

// PRIMARY
function heatmapthemead_widget_position_primary() {
	if ( heatmapthemead_is_sidebar_active( 'heatmapthemeadprimary' ) ) {
		print '<div id="heatmapthemead-widget-position-primary" class="heatmapthemead-widget-position heatmapthemead-primary" role="complementary">';
		dynamic_sidebar( 'heatmapthemeadprimary' );
		print '</div> <!-- id="heatmapthemead-widget-position-primary" -->'; 
		print HMTA_NL; 
	} else {
		print '<h4 class="widget-title">' . __( 'Primary Sidebar', 'heatmapthemead' ) . '</h4>';
		print '<div class="text-widget">';
		print '<p>' . __( 'Where are the widgets?', 'heatmapthemead' ) . '<br/>' . __( 'There are none here yet.', 'heatmapthemead' ) . '<br/>' . __( 'Its time to set some.', 'heatmapthemead' ) . '</p>';
		print '<p>' . __( 'Appearance > Widgets', 'heatmapthemead' ) . '</p>';
		print '</div>';
	}
}

// SECONDARY
function heatmapthemead_widget_position_secondary() {
	if ( heatmapthemead_is_sidebar_active( 'heatmapthemeadsecondary' ) ) {	
		print '<div id="heatmapthemead-widget-position-secondary" class="heatmapthemead-widget-position heatmapthemead-secondary widget-area" role="complementary">';
		dynamic_sidebar( 'heatmapthemeadsecondary' );
		print '</div> <!-- id="heatmapthemead-widget-position-secondary" -->'; 
		print HMTA_NL;
	} else {
		print '<h4 class="widget-title">' . __( 'Secondary Sidebar', 'heatmapthemead' ) . '</h4>';
		print '<div class="text-widget">';
		print '<p>' . __( 'This Sidebar has no widgets.', 'heatmapthemead' ) . '<br/>' . __( 'You should set some now.', 'heatmapthemead' ) . '<br/>' . __( 'This message will then dissapear.', 'heatmapthemead' ) . '</p>';
		print '<p>' . __( 'Appearance > Widgets', 'heatmapthemead' ) . '</p>';
		print '</div>';
	}
}

// HEADER
function heatmapthemead_widget_position_header() {
	if ( heatmapthemead_is_sidebar_active ( 'heatmapthemeadheader' ) ) {	
		print '<div id="heatmapthemead-widget-position-header" class="heatmapthemead-widget-position heatmapthemead-homeheader widget-area" role="complementary">';
			dynamic_sidebar( 'heatmapthemeadheader' );
		print '</div> <!-- id="heatmapthemead-widget-position-header" -->'; 
		print HMTA_NL;
	}
	else {
		
		$options = heatmapthemead_get_theme_options();
		// make sure we dont generate a blank social icons widget
		if (
			!$options['facebook_url'] &&
			!$options['twitter_url'] &&
			!$options['googleplus_url'] &&
			!$options['youtube_url'] &&
			!$options['linkedin_url'] &&
			!$options['myspace_url'] &&
			$options['rss_icon'] != 'on' &&
			$options['rss_comments_icon']  != 'on'
		) return;

		print '<div id="heatmapthemead-widget-position-header" class="heatmapthemead-widget-position heatmapthemead-homeheader widget-area heatmapthemead-static-header-widget" role="complementary">';
			print '<aside class="widget">';
				heatmapthemead_display_social_icons ();
			print '</aside>';
		print '</div> <!-- id="heatmapthemead-widget-position-header" -->'; 
		print HMTA_NL;
	}
}

// LEADERBOARD
function heatmapthemead_widget_position_leaderboard() {
	if ( heatmapthemead_is_sidebar_active ( 'heatmapthemeadleaderboard' ) ) {	
		print '<div id="heatmapthemead-widget-position-leaderboard" class="heatmapthemead-widget-position heatmapthemead-leaderboard widget-area" role="complementary">';
		dynamic_sidebar( 'heatmapthemeadleaderboard' );
		print '</div> <!-- id="heatmapthemead-widget-position-leaderboard" -->'; 
		print HMTA_NL;
	}
}

// BLOG TOP
function heatmapthemead_widget_position_blogabove() {
	if ( heatmapthemead_is_sidebar_active ( 'heatmapthemeadblogabove' ) ) {	
		print '<div id="heatmapthemead-widget-position-blogabove" class="heatmapthemead-widget-position heatmapthemead-blogabove widget-area" role="complementary">';
		dynamic_sidebar( 'heatmapthemeadblogabove' );
		print '</div> <!-- id="heatmapthemead-widget-position-blogabove" -->'; 
		print HMTA_NL;
	}
}

// BLOG BOTTOM
function heatmapthemead_widget_position_blogbelow() {
	if ( heatmapthemead_is_sidebar_active ( 'heatmapthemeadblogbelow' ) ) {	
		print '<div id="heatmapthemead-widget-position-blogbelow" class="heatmapthemead-widget-position heatmapthemead-blogbelow widget-area" role="complementary">';
		dynamic_sidebar( 'heatmapthemeadblogbelow' );
		print '</div> <!-- id="heatmapthemead-widget-position-blogbelow" -->'; 
		print HMTA_NL;
	}
}


// POST INLINE
function heatmapthemead_widget_position_postinline() {
	global $heatmapthemead_options_override;
	
	// if the ad has already been displayed or if we have already seen the first blog post don't show the widget
	if ( $heatmapthemead_options_override ['post_inline_widget_displayed'] == true ) return;
	if ( $heatmapthemead_options_override ['blog_posts_displayed'] == true ) return;
	
	if ( heatmapthemead_is_sidebar_active ( 'heatmapthemeadpostinline' ) ) {	
		print '<div id="heatmapthemead-widget-position-postinline" class="heatmapthemead-widget-position heatmapthemead-postinline widget-area" role="complementary">';
		dynamic_sidebar( 'heatmapthemeadpostinline' );
		print '</div> <!-- id="heatmapthemead-widget-position-postinline" -->'; 
		print HMTA_NL;
		
		$heatmapthemead_options_override ['post_inline_widget_displayed'] = true;
	}
}


// POST INCONTENT
function heatmapthemead_widget_position_postincontent() {
	global $heatmapthemead_options_override;
		
		// if the ad has already been displayed or if we have already seen the first blog post don't show the widget	
	if ( $heatmapthemead_options_override ['post_incontent_widget_displayed'] == true ) return;
	if ( $heatmapthemead_options_override ['blog_posts_displayed'] == true ) return;
		
	if ( heatmapthemead_is_sidebar_active ( 'heatmapthemeadpostincontent' ) ) {	
		print '<div id="heatmapthemead-widget-position-postincontent" class="heatmapthemead-widget-position heatmapthemead-postincontent widget-area" role="complementary">';
		dynamic_sidebar( 'heatmapthemeadpostincontent' );
		print '</div> <!-- id="heatmapthemead-widget-position-postincontent" -->'; 
		print HMTA_NL;
		
		$heatmapthemead_options_override ['post_incontent_widget_displayed'] = true;
	}
}


// POST BELOW
function heatmapthemead_widget_position_postbelow() {
	global $heatmapthemead_options_override;
	
		// if the ad has already been displayed or if we have already seen the first blog post don't show the widget	
	if ( $heatmapthemead_options_override ['post_below_widget_displayed'] == true ) return;
	if ( $heatmapthemead_options_override ['blog_posts_displayed'] == true ) return;
		
	if ( heatmapthemead_is_sidebar_active ( 'heatmapthemeadpostbelow' ) ) {	
		print '<div id="heatmapthemead-widget-position-postbelow" class="heatmapthemead-widget-position heatmapthemead-postbelow widget-area" role="complementary">';
		dynamic_sidebar( 'heatmapthemeadpostbelow' );
		print '</div> <!-- id="heatmapthemead-widget-position-postbelow" -->'; 
		print HMTA_NL;
		
		$heatmapthemead_options_override ['post_below_widget_displayed'] = true;
	}
}


/* CHECK FOR STATIC WIDGETS IN WIDGET-READY AREAS
- thanks to Chaos Kaizer and Ian Stewart (themeshaper.com) for this function which makes the sidebar validation much neater
--------------------------------------------------------------------------------------------- */

function heatmapthemead_is_sidebar_active($index){
	
	global $wp_registered_sidebars;
	$widgetcolums = wp_get_sidebars_widgets();
	if (isset($widgetcolums[$index]) && $widgetcolums[$index]) return true;
	return false;
}

/* need this here as its called above */
add_action( 'widgets_init', 'heatmapthemead_register_sidebars' );


/* SOCIAL ICONS WIDGET
--------------------------------------------------------------------------------------------- */

// use widgets_init action hook to execute custom function
add_action( 'widgets_init', 'heatmapthemead_social_icons_widget_register_widgets' );

 //register our widget
function heatmapthemead_social_icons_widget_register_widgets() {
    register_widget( 'heatmapthemead_social_icons_widget' );
}

//widget class
class heatmapthemead_social_icons_widget extends WP_Widget {

    //process the new widget
    function heatmapthemead_social_icons_widget() {
        $widget_ops = array( 
			'classname' => 'heatmapthemead_social_icons_widget_class', 
			'description' => __( 'Displays HeatMap Social Icons', 'heatmapthemead' )
			); 
        $this->WP_Widget( 'heatmapthemead_social_icons_widget', 'HeatMap Social Icons', $widget_ops );
    }
 
     //build the widget settings form
    function form($instance) {
        $defaults = array( 'title' => __( 'Follow Us', 'heatmapthemead' ) ); 
        $instance = wp_parse_args( (array) $instance, $defaults );
        $title = $instance['title'];

        ?>
		<p>
			<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e('Title:', 'heatmapthemead'); ?></label>
			<input id="<?php echo $this->get_field_id( 'title' ); ?>" class="widefat" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo $instance['title']; ?>" />
		</p>       
	<?php
    }
 
    //save the widget settings
    function update($new_instance, $old_instance) {
        $instance = $old_instance;
        $instance['title'] = strip_tags( $new_instance['title'] );
        return $instance;
    }
 
    //display the widget
    function widget($args, $instance) {
        extract($args);
 
        echo $before_widget;
        $title = apply_filters( 'widget_title', $instance['title'] );
        if ( !empty( $title ) ) { echo $before_title . $title . $after_title; };
		heatmapthemead_display_social_icons ();
        echo $after_widget;
    }
}


/* AD WIDGET
--------------------------------------------------------------------------------------------- */

// This widget is adapted directly from the built in WordPress text widget

// use widgets_init action hook to execute custom function
add_action( 'widgets_init', 'heatmapthemead_ad_widget_register_widgets' );

 //register our widget
function heatmapthemead_ad_widget_register_widgets() {
    register_widget( 'heatmapthemead_ad_widget' );
}

class heatmapthemead_ad_widget extends WP_Widget {

	function __construct() {
		// if the user has the right to use unfiltered HTML then show the javascript message below
		if ( current_user_can('unfiltered_html') )
			$widget_ops = array('classname' => 'heatmapthemead_ad_widget', 'description' => __('Javascript or HTML ad code', 'heatmapthemead'));
		else
		// otherwise only let them only do html banner ads
			$widget_ops = array('classname' => 'heatmapthemead_ad_widget', 'description' => __('HTML ad code only (no Javascript)', 'heatmapthemead'));
		$control_ops = null;
		parent::__construct('heatmapthemead_ad', __('HeatMap AdAptive Ad', 'heatmapthemead'), $widget_ops, $control_ops);
	}

	function widget( $args, $instance ) {
		extract($args);
		
		// only do this for pages or posts - it doesnt apply to anything else
		if ( is_page () || is_single () ) {
			// if the meta for the current page or post says to hide the ads then return without doing anything
			$current_post_id = get_the_ID();
			$current_meta = get_post_meta ( $current_post_id );		
			if (( isset ( $current_meta['_heatmapthemead_postmeta_hide_heatmapthemead_ad_widgets'][0] ) ) && ( $current_meta['_heatmapthemead_postmeta_hide_heatmapthemead_ad_widgets'][0] == 'on' ))
				return;
		}
			
		// Okay lets start displaying this widget
		$title = apply_filters( 'widget_title', empty( $instance['title'] ) ? '' : $instance['title'], $instance, $this->id_base );
		$ad = apply_filters( 'widget_ad', empty( $instance['ad'] ) ? '' : $instance['ad'], $instance );
		
		// show ad widget dependant on settings

		if( ( !empty( $instance['blog_pages'] ) && (is_home () || is_front_page () || is_archive () ) ) ||
			( !empty( $instance['single_pages'] ) && (is_page () && !is_front_page () ) ) ||
			( !empty( $instance['single_posts'] ) && (is_single () ) ) ) {
		
			echo $before_widget;
			if ( !empty( $title ) && !empty( $instance['display_title'] ) ) { echo $before_title . $title . $after_title; } 
			?>
				<div class="heatmapthemead_ad_widget"><?php echo $ad; ?></div>
			<?php
			echo $after_widget;
		}
	}

	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		if ( current_user_can('unfiltered_html') )
			$instance['ad'] =  $new_instance['ad'];
		else
			$instance['ad'] = stripslashes( wp_filter_post_kses( addslashes($new_instance['ad']) ) ); // wp_filter_post_kses() expects slashed
		$instance['display_title'] = isset($new_instance['display_title']);
		$instance['blog_pages'] = isset($new_instance['blog_pages']);
		$instance['single_pages'] = isset($new_instance['single_pages']);
		$instance['single_posts'] = isset($new_instance['single_posts']);
		return $instance;
	}

	function form( $instance ) {
		$instance = wp_parse_args( (array) $instance, array( 'title' => '', 'ad' => '', 'blog_pages' => '', 'single_pages' => '', 'single_posts' => '' ) );
		$title = strip_tags($instance['title']);
		$text = esc_textarea($instance['ad']);
?>
		<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:', 'heatmapthemead'); ?></label>
		<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" /></p>

		<p><label for="<?php echo $this->get_field_id('ad'); ?>"><?php _e('HTML or Javascript Ad Code:', 'heatmapthemead'); ?></label>
		<textarea class="widefat" rows="16" cols="20" id="<?php echo $this->get_field_id('ad'); ?>" name="<?php echo $this->get_field_name('ad'); ?>"><?php echo $text; ?></textarea>

		<p><input id="<?php echo $this->get_field_id('display_title'); ?>" name="<?php echo $this->get_field_name('display_title'); ?>" type="checkbox" <?php checked(isset($instance['display_title']) ? $instance['display_title'] : 0); ?> />&nbsp;<label for="<?php echo $this->get_field_id('display_title'); ?>"><?php _e('Display Title?', 'heatmapthemead'); ?></label></p>
		
		<p><input id="<?php echo $this->get_field_id('blog_pages'); ?>" name="<?php echo $this->get_field_name('blog_pages'); ?>" type="checkbox" <?php checked(isset($instance['blog_pages']) ? $instance['blog_pages'] : 1); ?> />&nbsp;<label for="<?php echo $this->get_field_id('blog_pages'); ?>"><?php _e('Display on Home, Front Page, Category, Tag and Archive Pages?', 'heatmapthemead'); ?></label></p>	
		
		<p><input id="<?php echo $this->get_field_id('single_pages'); ?>" name="<?php echo $this->get_field_name('single_pages'); ?>" type="checkbox" <?php checked(isset($instance['single_pages']) ? $instance['single_pages'] : 1); ?> />&nbsp;<label for="<?php echo $this->get_field_id('single_pages'); ?>"><?php _e('Display on Single Pages?', 'heatmapthemead'); ?></label></p>	
		
		<p><input id="<?php echo $this->get_field_id('single_posts'); ?>" name="<?php echo $this->get_field_name('single_posts'); ?>" type="checkbox" <?php checked(isset($instance['single_posts']) ? $instance['single_posts'] : 1); ?> />&nbsp;<label for="<?php echo $this->get_field_id('single_posts'); ?>"><?php _e('Display on Single Posts?', 'heatmapthemead'); ?></label></p>			
<?php
	}
}