<?php
/* Change default attachment pages to use a larger image
--------------------------------------------------------------------------------------------- */
// overrides built in WordPress Function prepend_attachment()

function heatmapthemead_prepend_attachment($content) {
	$post = get_post();

	if ( empty($post->post_type) || $post->post_type != 'attachment' )
		return $content;

	$p = '<p class="attachment">';
	// show the medium sized image representation of the attachment if available, and link to the raw file
	$p .= wp_get_attachment_link(0, 'large', false);
	$p .= '</p>';
	$p = apply_filters('heatmapthemead_prepend_attachment', $p);

	return "$p\n";
}

add_filter ('prepend_attachment', 'heatmapthemead_prepend_attachment' );


/* Remove rel="category tag" which causes validation errors
--------------------------------------------------------------------------------------------- */

function heatmapthemead_remove_category_list_rel( $output ) {
    // Remove rel attribute from the category list
    return str_replace( ' rel="category tag"', ' rel="tag"', $output );
}
 
add_filter( 'wp_list_categories', 'heatmapthemead_remove_category_list_rel' );
add_filter( 'the_category', 'heatmapthemead_remove_category_list_rel' );

/* Remove rel="rel attachment" which causes validation errors
--------------------------------------------------------------------------------------------- */

function heatmapthemead_remove_rel_attr($content) {
    return preg_replace('/\s+rel="attachment wp-att-[0-9]+"/i', '', $content);
}
add_filter('the_content', 'heatmapthemead_remove_rel_attr');


/* Upgrade notice
--------------------------------------------------------------------------------------------- */

function heatmapthemead_upgrade_notice() {
	
	if ( function_exists ( 'heatmapthemeap_exists' ) ) return;
	
	global $current_screen;
	if ( $current_screen->base == 'appearance_page_theme_options' ) {
		print '<div class="updated" style="background-color:#DCEFF8; border-color: #888;"><p><span style="margin-right:20px">';
		_e ( 'Welcome to HeatMap AdAptive! For official support and more features upgrade to', 'heatmapthemead' );
		print ' <strong><u><a href="' . HMTA_UPGRADE_URL . '">';
		_e ( 'HeatMap AdAptive Pro', 'heatmapthemead' );
		print '</a></u></strong>.</span>';
		
		print '</div>';
	}
}

add_action( 'admin_notices', 'heatmapthemead_upgrade_notice' );
?>