<?php
/* 
This file is part of HeatMap Theme AdAptive
See license.txt (distributed with this file) for details of
license, contributors, copyright notices, credits and trademarks.
*/

/*
Template Name: Primary Sidebar + Content
Single Post Template: Primary Sidebar + Content
*/
//Setting these global allows us to override the option settings on a page by by basis. Cool huh!
global $heatmapthemead_options_override;

// Use $heatmapthemead_theme_layout with the following values:
// 'content' - full width content / no sidebars
// 'primary-sidebar-content' - Primary sidebar on left with content on right
// 'both-sidebars' - Both primary and secondary sidebars showing with content in center
// 'content-secondary-sidebar' - Content with secondary sidebar on the right
$heatmapthemead_options_override['theme_layout'] = 'primary-sidebar-content';

// You can also set the theme width on a page by page basis
// uncomment below and add your chosen width
// $heatmapthemead_options_override['max_width'] = your-width-here;

// if you want to change the theme colour just for this page then you can do that here
// $heatmapthemead_options_override['color_scheme'] = 'colour-scheme-slug-here';
// don't add the actual name of the css file below - it gets added to the path automatically
// $heatmapthemead_options_override['color_scheme_path'] = url-to-css-file-here;

get_header(); 	// You could just replace this with code copied from header.php to customise whats in the header for this page

// CONTENT HOOK
add_action('heatmapthemead_the_content_hook', 'heatmapthemead_the_loop');
	
	// THE LOOP HOOK
	add_action('heatmapthemead_the_loop_hook', 'heatmapthemead_single_post');
		// SINGLE POSTS HOOK
		add_action('heatmapthemead_single_posts_hook', 'heatmapthemead_widget_position_blogabove');
		add_action('heatmapthemead_single_posts_hook', 'heatmapthemead_widget_position_postinline');
		add_action('heatmapthemead_single_posts_hook', 'heatmapthemead_single_post_header');
		add_action('heatmapthemead_single_posts_hook', 'heatmapthemead_posted_on');
		add_action('heatmapthemead_single_posts_hook', 'heatmapthemead_featured_image');
		add_action('heatmapthemead_single_posts_hook', 'heatmapthemead_widget_position_postincontent');
		add_action('heatmapthemead_single_posts_hook', 'heatmapthemead_the_content');
		// add_action('heatmapthemead_single_posts_hook', 'heatmapthemead_like_buttons');
		add_action('heatmapthemead_single_posts_hook', 'heatmapthemead_article_meta');
		add_action('heatmapthemead_single_posts_hook', 'heatmapthemead_widget_position_postbelow');
		add_action('heatmapthemead_single_posts_hook', 'heatmapthemead_comments');

	// POST LOOP HOOK
	add_action('heatmapthemead_the_post_loop_hook', 'heatmapthemead_the_loop_errors');

add_action('heatmapthemead_the_content_hook', 'heatmapthemead_widget_position_blogbelow');
add_action('heatmapthemead_the_content_hook', 'heatmapthemead_content_nav');
	
get_sidebar(); 	// Replace this with code copied from sidebar.php to customise whats in the sidebar for this page
get_footer();	// Same with this. Replace get_footer(); with all the code copied from footer.php to customise whats in the footer

get_template_part( 'unhook' );
get_template_part( 'unhook-custom' );
get_template_part( 'render' );
?>