<?php
/* 
This file is part of HeatMap Theme AdAptive
See license.txt (distributed with this file) for details of
license, contributors, copyright notices, credits and trademarks.
*/

global $heatmapthemead_options_override;
$options = heatmapthemead_get_theme_options();


// HOME PAGE
if ( !isset ( $heatmapthemead_options_override['featured_page'] ) ) {
	// if its not the home page then we really dont need the featured page hooked
	if ( !is_home () || $options['featured_page'] == 'off' ) {
			remove_action('heatmapthemead_the_content_hook', 'heatmapthemead_featured_page');
	}
	
	// we dont want the featured page if we are looking at older posts either
	if ( is_home () && is_paged () ) {
			remove_action('heatmapthemead_the_content_hook', 'heatmapthemead_featured_page');
	}
}

// ALL TEMPLATE TYPES
if ( $options['branding'] == 'off' ) 
	remove_action('heatmapthemead_header_hook', 'heatmapthemead_custom_header');

if ( $options['primary_navigation'] == 'off' )
	remove_action('heatmapthemead_header_hook', 'heatmapthemead_primary_menu');
	
if ( $options['secondary_navigation'] == 'off' )
	remove_action('heatmapthemead_header_hook', 'heatmapthemead_secondary_menu');
	
if ( $options['footer_navigation'] == 'off' )
	remove_action('heatmapthemead_footer_hook', 'heatmapthemead_footer_menu');

if ( $options['subfooter_navigation'] == 'off' )		
	remove_action('heatmapthemead_footer_hook', 'heatmapthemead_credits');
	
if ( $options['post_navigation'] == 'off' )	
	remove_action('heatmapthemead_the_content_hook', 'heatmapthemead_content_nav');
	
// date, author and comment line are in combined in a single block heatmapthemead_posted_on()		
if ( ( $options['meta_date'] == 'off' ) && ( $options['meta_author'] == 'off' ) && ( $options['meta_comments'] == 'off' ) ) {
	remove_action('heatmapthemead_blog_posts_hook', 'heatmapthemead_posted_on');
	remove_action('heatmapthemead_single_posts_hook', 'heatmapthemead_posted_on');
}

// categories and tags are in combined in a single block heatmapthemead_article_meta ()	
if ( ( $options['meta_categories'] == 'off' ) && ( $options['meta_tags'] == 'off' ) ) {
	remove_action('heatmapthemead_blog_posts_hook', 'heatmapthemead_article_meta');
	remove_action('heatmapthemead_single_posts_hook', 'heatmapthemead_article_meta');
}
	
if ( $options['meta_comments'] == 'off' ) {
	remove_action('heatmapthemead_single_posts_hook', 'heatmapthemead_comments');
}

// Remove all meta from pages if page meta not set (ie dont show any author, date, comments or whatever for pages )

// we dont want the featured page if we are looking at older posts either
if ( is_page() && ( $options['page_meta'] == 'off' ) ) {
	remove_action('heatmapthemead_single_posts_hook', 'heatmapthemead_posted_on');
	remove_action('heatmapthemead_single_posts_hook', 'heatmapthemead_article_meta');
	remove_action('heatmapthemead_single_posts_hook', 'heatmapthemead_comments');
}

if ( $options['featured_image'] == 'off' ) { 
	remove_action('heatmapthemead_single_posts_hook', 'heatmapthemead_featured_image');
	remove_action('heatmapthemead_blog_posts_hook', 'heatmapthemead_featured_image');
}

// make sure that the content divs are always cleared at the end of a post
add_action('heatmapthemead_blog_posts_hook', 'heatmapthemead_clear_the_content_hook',999);
?>