<?php
/* 
HeatMap Theme(r) ClickMissile Ads
http://heatmaptheme.com

Copyright Stuart Wider / StuartCindy Art

The name 'HeatMap Theme' and the 'notched circle and flame' logo 
are registered tradmarks of StuartCindy Art and may not be used
without the express written permission of the trademark owner.
*/

/*ADD THE META BOXES
--------------------------------------------------------------------------------------------- */

function cmam_add_custom_meta_box() {
    add_meta_box(
		'cmam_ads_ads_meta_box', // $id
		__('Ad Code','cmamtx'), // $title
		'cmam_show_ads_meta_box', // $callback
		'cmam_ads', // $page
		'normal', // $context
		'high'); // $priority
		
	add_meta_box(
		'cmam_posts', // $id
		__('Click Missile','cmamtx'), // $title
		'cmam_show_posts_meta_box', // $callback
		'post', // $page
		'normal', // $context
		'high'); // $priority	
		
	add_meta_box(
		'cmam_pages', // $id
		__('Click Missile','cmamtx'), // $title
		'cmam_show_posts_meta_box', // $callback
		'page', // $page
		'normal', // $context
		'high'); // $priority
}

add_action('add_meta_boxes', 'cmam_add_custom_meta_box');


/* DEFINE THE FIELDS FOR THE METABOX
--------------------------------------------------------------------------------------------- */

function cmam_get_custom_meta_fields ($post_type, $meta_box_type) {

	// POST TYPE = cmam_ads
	if ($post_type == 'cmam_ads') {
	
		$prefix = 'cmam_ads_';
	
		$custom_meta_fields = array(
			array(
				'label'=> __('Ad Code', 'cmamtx' ),
				'desc'	=> __('You can place HTML or Javascript ad code here', 'cmamtx' ),
				'id'	=> $prefix.'ad_code_textarea',
				'type'	=> 'textarea'
			),
			array(
				'label'=> __('Is this ad for mobile devices?', 'cmamtx' ), 
				'desc'	=> '',
				'id'	=> $prefix.'is_mobile_ad',
				'type'	=> 'checkbox'
			),
			array(
				'label'=> __('Is this ad for tablet devices?', 'cmamtx' ), 
				'desc'	=> '',
				'id'	=> $prefix.'is_tablet_ad',
				'type'	=> 'checkbox'
			),
		);
		return $custom_meta_fields;
	}
	
	// POST TYPE = post
	if ($post_type == 'post') {
	
		$prefix = 'cmam_ads_';
	
		$custom_meta_fields = array(
			array(
				'label'=> __('Available for selection in ad widget?', 'cmamtx' ), 
				'desc'	=> '',
				'id'	=> '_' . $prefix . 'post_selectable',
				'type'	=> 'checkbox'
			),
			array(
				'label'=> __('Hide sidebar ad widgets?', 'cmamtx' ), 
				'desc'	=> '',
				'id'	=> '_' . $prefix . 'hide_ads',
				'type'	=> 'checkbox'
			),
			array(
				'label'=> __('Hide in-content ad widgets?',  'cmamtx' ), 
				'desc'	=> '',
				'id'	=> '_' . $prefix . 'hide_ad_widgets',
				'type'	=> 'checkbox'
			),
			array(
				'label'=> __('Hide non-post context ad widgets?','cmamtx' ),
				'desc'	=> '',
				'id'	=> '_' . $prefix . 'hide_out_of_context_ad_widgets',
				'type'	=> 'checkbox'
			)
			
		);
		return $custom_meta_fields;
	}
	
	// POST TYPE = page
	if ($post_type == 'page') {
	
		$prefix = 'cmam_ads_';
	
		$custom_meta_fields = array(
			array(
				'label'=> __('Hide sidebar ad widgets?', 'cmamtx' ), 
				'desc'	=> '',
				'id'	=> '_' . $prefix . 'hide_ads',
				'type'	=> 'checkbox'
			),
			array(
				'label'=> __('Hide in-content ad widgets?', 'cmamtx' ), 
				'desc'	=> '',
				'id'	=> '_' . $prefix . 'hide_ad_widgets',
				'type'	=> 'checkbox'
			),
			array(
				'label'=> __('Hide out-of-context ad widgets?', 'cmamtx' ), 
				'desc'	=> '',
				'id'	=> '_' . $prefix . 'hide_out_of_context_ad_widgets',
				'type'	=> 'checkbox'
			)
		);
		return $custom_meta_fields;
	}		
}

/* THE CALLBACK
--------------------------------------------------------------------------------------------- */

function cmam_show_ads_meta_box() {
	if ( current_user_can('manage_options') ) {
		cmam_show_custom_meta_box( 'ads' );
	}
}

function cmam_show_posts_meta_box() {
	if ( current_user_can('manage_options') ) {
		cmam_show_custom_meta_box( 'post' );
	}
}

/* RENDER THE METABOX
--------------------------------------------------------------------------------------------- */

function cmam_show_custom_meta_box( $meta_box_type ) {
	
	// $meta_box_type will be used if we add more than one meta box later
	
	global $post;
	
	// UNCOMMENT BELOW IF WE START USING THE AD SELECTOR DROPDOWN HERE AGAIN
	// get the array of ads that have been saved currenty
	// these will be used in the select box later
	// $cmam_ads_array = cmam_get_the_ads ();

	// So if this post is of the type that needs clickmissile meta boxes then get custom fields for that specific post type
	// we only ad metaboxes to posts, pages, and clickmissile ad
	if ( ( 'cmam_ads' == $post->post_type ) || ( 'post' == $post->post_type ) || ( 'page' == $post->post_type ) )  {
		$custom_meta_fields = cmam_get_custom_meta_fields ( $post->post_type, $meta_box_type );
	}
	
	// Use nonce for verification
	echo '<input type="hidden" name="cmam_meta_box_nonce" value="'.wp_create_nonce(basename(__FILE__)).'" />';

	// Begin the field table and loop
	echo '<table class="form-table">';
	
	foreach ($custom_meta_fields as $field) {
		// get value of this field if it exists for this post
		$meta = get_post_meta($post->ID, $field['id'], true);
		
		// begin a table row with
		echo '<tr>
				<th><label for="'.$field['id'].'">'.$field['label'].'</label></th>
				<td>';
				switch($field['type']) {
					
					// and now out put the fields in the metabox according to those set in the $custom_meta_fields_array
					
					// text
					case 'text':
						echo '<input type="text" name="'.$field['id'].'" id="'.$field['id'].'" value="'.$meta.'" size="30" />
							<br /><span class="description">'.$field['desc']. '</span>';
					break;
					
					// textarea
					case 'textarea':
						echo '<textarea name="'.$field['id'].'" id="'.$field['id'].'" class="widefat" rows="12">'.htmlspecialchars($meta).'</textarea>
							<br /><span class="description">'.$field['desc'].'</span>';
					break;
					
					// checkbox
					case 'checkbox':
						echo '<input type="checkbox" name="'.$field['id'].'" id="'.$field['id'].'" ',$meta ? ' checked="checked"' : '','/>
							<label for="'.$field['id'].'">'.$field['desc'].'</label>';
					break;
					
					// select
					case 'select':
						echo '<select name="'.$field['id'].'" id="'.$field['id'].'">';
						foreach ($field['options'] as $option) {
							echo '<option', $meta == $option['value'] ? ' selected="selected"' : '', ' value="'.$option['value'].'">'.$option['label'].'</option>';
						}
						echo '</select><br /><span class="description">'.$field['desc'].'</span>';
					break;
					
				} //end switch
				 		
		echo '</td></tr>';
			
	} // end foreach
	
	// get the current meta
	$post_meta_data = get_post_custom($post->ID);

	echo '</table>'; // end table	
}

/* SAVE THE DATA
--------------------------------------------------------------------------------------------- */

function cmam_save_custom_meta($post_id) {
	
    global $custom_meta_fields;
	
	// check permissions - if the user does not have the right to manage options then do nothing
	if ( !current_user_can('manage_options') ) {
			return $post_id;
	}
	
	// check for the metabox nonce - if it doesnt exist or its not verified then get us out of here
	if ( !isset( $_POST['cmam_meta_box_nonce'] ) || (!wp_verify_nonce($_POST['cmam_meta_box_nonce'], basename(__FILE__))))
		return $post_id;
		
	// check autosave
	if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE)
		return $post_id;

	// if post type is ads then get the appropriate form field types
	if ('cmam_ads' == $_POST['post_type']) {
		 $custom_meta_fields = cmam_get_custom_meta_fields ( $_POST['post_type'], 'ads' );
	}
	
	// if post types is post or get the appropriate form field types
	if ('post' == $_POST['post_type']) {
		 $custom_meta_fields = cmam_get_custom_meta_fields ( $_POST['post_type'], 'post' );
	}
	
		// if post types is post or get the appropriate form field types
	if ('page' == $_POST['post_type']) {
		 $custom_meta_fields = cmam_get_custom_meta_fields ( $_POST['post_type'], 'page' );
	}
	
	// loop through fields and save the data
	foreach ($custom_meta_fields as $field) {
		
		$old = get_post_meta($post_id, $field['id'], true);
		
		if ( !isset ( $_POST[$field['id']] ) ) $new = '';
		else $new = $_POST[$field['id']];
		
		if ($new != $old) {
			update_post_meta($post_id, $field['id'], $new);
		} elseif ('' == $new && $old) {
			delete_post_meta($post_id, $field['id'], $old);
		}
	} // end foreach
}
add_action('save_post', 'cmam_save_custom_meta');
?>