<?php
/* 
HeatMap Theme(r) ClickMissile Ads
http://heatmaptheme.com

The name 'HeatMap Theme' and the 'notched circle and flame' logo 
are registered tradmarks of StuartCindy Art and may not be used
without the express written permission of the trademark owner.
*/

// Thanks to the wordpress.org / Automattic theme team for the twentyten, twentyeleven and
// underscores theme, the options code of which forms the starter point inspiration for this options page.

/* ADD A MENU FOR THE OPTIONS PAGE
--------------------------------------------------------------------------------------------- */

function cmam_add_page() {
	if ( current_user_can('manage_options') ) {
		
		// this code puts the options page in with the other settings pages - I like it better with the custom post type though!
		// add_options_page( 'Click Missile', 'Click Missile', 'manage_options', 'cmam', 'cmam_option_page' );
		
		add_submenu_page('edit.php?post_type=cmam_ads', __('Click Missile Options','cmamtx'), __('Settings','cmamtx'), 'edit_posts', basename(__FILE__), 'cmam_option_page');
	}
}

add_action('admin_menu', 'cmam_add_page');

/* RENDER THE OPTIONS PAGE
--------------------------------------------------------------------------------------------- */

function cmam_option_page() {		
?>
	<div class="wrap">
			
		<style type="text/css">
			#cmam-theme-options-buttons {
			display: inline-block;
			float:right;
			margin-top: 10px;
			}
		
			#cmam-theme-options-buttons .button-primary a {
				text-decoration: none;
				color: #FFF;
			}
		</style>
		
		<span id="cmam-theme-options-buttons">
			<span class="button-primary"><a href="http://heatmaptheme.com/click-missile-user-guide"><?php _e( 'User Guide' , 'cmamtx' ) ?></a></span> 
			<span class="button-primary"><a href="http://heatmaptheme.com/click-missile-support"><?php _e( 'Support', 'cmamtx' ) ?></a></span>
		</span>  
		
		<?php screen_icon(); ?>
		<h2><?php _e('Click Missile Settings','cmamtx') ?></h2>
		
		<?php
		// display the theme options page icon
		print '<a href="http://heatmaptheme.com/" target="_blank">';
		print'<img src="';
		print CMAM_IMAGES_URL;
		print 'heatmap-icon.png" width="193" height="32" alt="" style="float:right; margin: 4px 0 0 0;" />'; 
		print '</a>'; 
		?>
		
		<?php	
		if ( isset( $_REQUEST['settings-updated'] ) && $_REQUEST['settings-updated'] ) {
            echo '<div id="message" class="updated fade"><p>';
            _e(' Settings saved.','hmth');
            echo '</p></div>';
        }
		?>
		
		<form action="options.php" method="post">
			<?php settings_fields('cmam_options'); ?>
			<?php do_settings_sections('cmam'); ?>
			<br/>
			<input type="submit" name="Submit" class="button-primary" value="Save Changes" />
		</form>
	
	</div>
	<?php
}

/* REGISTER THE SECTIONS AND SETTINGS FOR THE OPTIONS PAGE
--------------------------------------------------------------------------------------------- */

add_action('admin_init', 'cmam_admin_init');
function cmam_admin_init(){
	
	register_setting(
		'cmam_options',
		'cmam_options',
		'cmam_validate_options'
	);
	

	// PARAGRAPH DETECTION SECTION
	add_settings_section(
		'cmam_paragraph_detection',
		__('Paragraph Detection','cmamtx'),
		'cmam_paragraph_detection_section_text',
		'cmam'
	);
	add_settings_field(
		'cmam_min_paragraph_size',
		__('Minimum paragraph size','cmamtx'),
		'cmam_min_paragraph',
		'cmam',
		'cmam_paragraph_detection'
	);
	
	// DEFAULT IN-CONTENT ADS SECTION
	add_settings_section(
		'cmam_incontent_ads',
		__('Blog Posts Alignment','cmamtx'),
		'cmam_incontent_ads_section_text',
		'cmam'
	);
	add_settings_field(
		'cmamtop_alignment',
		__('Top','cmamtx'),
		'cmamtop_alignment',
		'cmam',
		'cmam_incontent_ads'
	);
	add_settings_field(
		'cmampos1_alignment',
		__('Position 1','cmamtx'),
		'cmampos1_alignment',
		'cmam',
		'cmam_incontent_ads'
	);
	add_settings_field(
		'cmampos2_alignment',
		__('Position 2','cmamtx'),
		'cmampos2_alignment',
		'cmam',
		'cmam_incontent_ads'
	);
	add_settings_field(
		'cmampos3_alignment',
		__('Position 3','cmamtx'),
		'cmampos3_alignment',
		'cmam',
		'cmam_incontent_ads'
	);
	add_settings_field(
		'cmambottom_alignment',
		__('Bottom','cmamtx'),
		'cmambottom_alignment',
		'cmam',
		'cmam_incontent_ads'
	);
	
	// MAX AD REPEAT SECTION
	add_settings_section(
		'cmam_ad_repeat',
		__('Blog Posts Ad Repeat','cmamtx'),
		'cmam_ad_repeat_section_text',
		'cmam'
	);
	add_settings_field(
		'cmam_max_ad_repeat',
		__('Maximum ad repeat','cmamtx'),
		'cmam_max_ad_repeat',
		'cmam',
		'cmam_ad_repeat'
	);
	
	// POST IN-CONTENT ADS SECTION
	add_settings_section(
		'cmam_post_incontent_ads',
		__('Single Post Alignment','cmamtx'),
		'cmam_post_incontent_ads_section_text',
		'cmam'
	);
	add_settings_field(
		'cmamtop_post_alignment',
		__('Top','cmamtx'),
		'cmamtop_post_alignment',
		'cmam',
		'cmam_post_incontent_ads'
	);
	add_settings_field(
		'cmampos1_post_alignment',
		__('Position 1','cmamtx'),
		'cmampos1_post_alignment',
		'cmam',
		'cmam_post_incontent_ads'
	);
	add_settings_field(
		'cmampos2_post_alignment',
		__('Position 2','cmamtx'),
		'cmampos2_post_alignment',
		'cmam',
		'cmam_post_incontent_ads'
	);
	add_settings_field(
		'cmampos3_post_alignment',
		__('Position 3','cmamtx'),
		'cmampos3_post_alignment',
		'cmam',
		'cmam_post_incontent_ads'
	);
	add_settings_field(
		'cmambottom_post_alignment',
		__('Bottom','cmamtx'),
		'cmambottom_post_alignment',
		'cmam',
		'cmam_post_incontent_ads'
	);	
	
	// PAGE IN-CONTENT ADS SECTION
	add_settings_section(
		'cmam_page_incontent_ads',
		__('Single Page Alignment','cmamtx'),
		'cmam_page_incontent_ads_section_text',
		'cmam'
	);
	add_settings_field(
		'cmamtop_page_alignment',
		__('Top','cmamtx'),
		'cmamtop_page_alignment',
		'cmam',
		'cmam_page_incontent_ads'
	);
	add_settings_field(
		'cmampos1_page_alignment',
		__('Position 1','cmamtx'),
		'cmampos1_page_alignment',
		'cmam',
		'cmam_page_incontent_ads'
	);
	add_settings_field(
		'cmampos2_page_alignment',
		__('Position 2','cmamtx'),
		'cmampos2_page_alignment',
		'cmam',
		'cmam_page_incontent_ads'
	);
	add_settings_field(
		'cmampos3_page_alignment',
		__('Position 3','cmamtx'),
		'cmampos3_page_alignment',
		'cmam',
		'cmam_page_incontent_ads'
	);
	add_settings_field(
		'cmambottom_page_alignment',
		__('Bottom','cmamtx'),
		'cmambottom_page_alignment',
		'cmam',
		'cmam_page_incontent_ads'
	);
	
	// ADVANCED SETTINGS SECTION
	add_settings_section(
		'cmam_advanced',
		__('Advanced Widget Settings','cmamtx'),
		'cmam_advanced_section_text',
		'cmam'
	);
	
	add_settings_field(
		'cmam_custom_css',
		__('Custom CSS','cmamtx'),
		'cmam_custom_css',
		'cmam',
		'cmam_advanced'
	);
	
	add_settings_field(
		'cmam_individual_posts',
		__('Individual Posts','cmamtx'),
		'cmam_individual_posts',
		'cmam',
		'cmam_advanced'
	);
	
	add_settings_field(
		'cmam_individual_pages',
		__('Individual Pages','cmamtx'),
		'cmam_individual_pages',
		'cmam',
		'cmam_advanced'
	);
	
	add_settings_field(
		'cmam_posts_in_category',
		__('Posts In Category','cmamtx'),
		'cmam_posts_in_category',
		'cmam',
		'cmam_advanced'
	);
	
	add_settings_field(
		'cmam_category_archives',
		__('Category Archives','cmamtx'),
		'cmam_category_archives',
		'cmam',
		'cmam_advanced'
	);

	add_settings_field(
		'cmam_posts_with_tag',
		__('Posts with Tag','cmamtx'),
		'cmam_posts_with_tag',
		'cmam',
		'cmam_advanced'
	);	
	
	add_settings_field(
		'cmam_tag_archives',
		__('Tag Archives','cmamtx'),
		'cmam_tag_archives',
		'cmam',
		'cmam_advanced'
	);	
	
	// DEBUG SECTION
	add_settings_section(
		'cmam_debug',
		__('Developer Settings','cmamtx'),
		'cmam_debug_section_text',
		'cmam'
	);
	add_settings_field(
		'cmam_display_edit_links',
		__('Display Edit Links','cmamtx'),
		'cmam_display_edit_links',
		'cmam',
		'cmam_debug'
	);
	add_settings_field(
		'cmam_debug_mobile_ads',
		__('Debug Mobile Ads','cmamtx'),
		'cmam_debug_mobile_ads',
		'cmam',
		'cmam_debug'
	);	
	add_settings_field(
		'cmam_debug_tablet_ads',
		__('Debug Tablet Ads','cmamtx'),
		'cmam_debug_tablet_ads',
		'cmam',
		'cmam_debug'
	);		
}

/* SECTION HEADERS
--------------------------------------------------------------------------------------------- */

function cmam_paragraph_detection_section_text() {
	echo '<div style="padding:5px; width:700px; background-color: #FFFFBF; border: solid 1px #DFDFDF; -webkit-box-shadow: inset 0 1px 0 white; box-shadow: inset 0 1px 0 white; -webkit-border-radius: 3px; border-radius: 3px; ">';
	echo '<p style="padding:0px; margin: 0px;">';
	_e ('Increasing this value pushes Click Missile widget Position 1 to paragraphs further down the post and spaces Click Missile widget Positions 2 and 3 more paragraphs apart.', 'cmamtx');
	echo '</p>'; 
	echo '</div>';
}

function cmam_incontent_ads_section_text() {
	echo '<div style="padding:5px; width:700px; background-color: #FFFFBF; border: solid 1px #DFDFDF; -webkit-box-shadow: inset 0 1px 0 white; box-shadow: inset 0 1px 0 white; -webkit-border-radius: 3px; border-radius: 3px; ">';
	echo '<p style="padding:0px; margin: 0px;">';
	_e ('Sets the alignment of Click Missile widget positions for blog posts on the home page, category pages, tag pages and other blog style archives.', 'cmamtx');
	echo '</p>'; 
	echo '</div>';
}

function cmam_ad_repeat_section_text() {
	echo '<div style="padding:5px; width:700px; background-color: #FFFFBF; border: solid 1px #DFDFDF; -webkit-box-shadow: inset 0 1px 0 white; box-shadow: inset 0 1px 0 white; -webkit-border-radius: 3px; border-radius: 3px; ">';
	echo '<p style="padding:0px; margin: 0px;">';
	_e ('Limits the number of times the same Click Missile ad widgets will be repeated within the content of posts on blog style pages such as the home page, category pages, tag pages and other blog style archives.', 'cmamtx');
	echo '</p>'; 
	echo '</div>';
}

function cmam_post_incontent_ads_section_text() {
	echo '<div style="padding:5px; width:700px; background-color: #FFFFBF; border: solid 1px #DFDFDF; -webkit-box-shadow: inset 0 1px 0 white; box-shadow: inset 0 1px 0 white; -webkit-border-radius: 3px; border-radius: 3px; ">';
	echo '<p style="padding:0px; margin: 0px;">';
	_e ('Sets the alignment of Click Missile widget positions within the content of single posts.', 'cmamtx');
	echo '</p>'; 
	echo '</div>';
}

function cmam_page_incontent_ads_section_text() {
	echo '<div style="padding:5px; width:700px; background-color: #FFFFBF; border: solid 1px #DFDFDF; -webkit-box-shadow: inset 0 1px 0 white; box-shadow: inset 0 1px 0 white; -webkit-border-radius: 3px; border-radius: 3px; ">';
	echo '<p style="padding:0px; margin: 0px;">';
	_e ('Sets the alignment of Click Missile widget positions within the content of single pages.', 'cmamtx');
	echo '</p>'; 
	echo '</div>';
}

function cmam_debug_section_text() {
	echo '<div style="padding:5px; width:700px; background-color: #FFFFBF; border: solid 1px #DFDFDF; -webkit-box-shadow: inset 0 1px 0 white; box-shadow: inset 0 1px 0 white; -webkit-border-radius: 3px; border-radius: 3px; ">';
	echo '<p style="padding:0px; margin: 0px;">';
	_e ('Various settings for editing ads and debugging ads.', 'cmamtx');
	echo '</p>'; 
	echo '</div>';
}

function cmam_advanced_section_text() {
	echo '<div style="padding:5px; width:700px; background-color: #FFFFBF; border: solid 1px #DFDFDF; -webkit-box-shadow: inset 0 1px 0 white; box-shadow: inset 0 1px 0 white; -webkit-border-radius: 3px; border-radius: 3px; ">';
	echo '<p style="padding:0px; margin: 0px;">';
	_e ('Activates additional advanced options in the Click Missile Widget.', 'cmamtx');
	echo '</p>'; 
	echo '</div>';
}


/* SET UP THE OPTIONS SETTINGS FOR THE MIN PARAGRAPH DETECTION SIZE
--------------------------------------------------------------------------------------------- */

function cmam_min_paragraph_options() {
	$cmam_min_paragraph_options = array(
		'100' => array(
			'value' =>	'100',
			'label' => __( '100', 'cmamtx' )
		),
		'200' => array(
			'value' =>	'200',
			'label' => __( '200', 'cmamtx' )
		),
		'300' => array(
			'value' =>	'300',
			'label' => __( '300', 'cmamtx' )
		),
		'400' => array(
			'value' => '400',
			'label' => __( '400', 'cmamtx' )
		),
		'500' => array(
			'value' => '500',
			'label' => __( '500', 'cmamtx' )
		),
		'600' => array(
			'value' => '600',
			'label' => __( '600', 'cmamtx' )
		),
		'700' => array(
			'value' => '700',
			'label' => __( '700', 'cmamtx' )
		),
		'800' => array(
			'value' => '800',
			'label' => __( '800', 'cmamtx' )
		),
		'900' => array(
			'value' => '900',
			'label' => __( '900', 'cmamtx' )
		),
		'1000' => array(
			'value' => '1000',
			'label' => __( '1000', 'cmamtx' )
		),
		'1100' => array(
			'value' => '1100',
			'label' => __( '1100', 'cmamtx' )
		),
		'1200' => array(
			'value' => '1200',
			'label' => __( '1200', 'cmamtx' )
		),
		'1300' => array(
			'value' => '1300',
			'label' => __( '1300', 'cmamtx' )
		),
		'1400' => array(
			'value' => '1400',
			'label' => __( '1400', 'cmamtx' )
		),
		'1500' => array(
			'value' => '1500',
			'label' => __( '1500', 'cmamtx' )
		),
	);

	return apply_filters( 'cmam_min_paragraph_options', $cmam_min_paragraph_options );
}


/* OUTPUT THE OPTIONS SETTINGS FOR THE MIN PARAGRAPH DETECTION SIZE
--------------------------------------------------------------------------------------------- */

function cmam_min_paragraph() {
	$options = get_option( 'cmam_options' );
	?>
	<select name="cmam_options[cmam_min_paragraph]" id="cmam_min_paragraph">
		<?php
			$selected = $options['cmam_min_paragraph'];
			$p = '';
			$r = '';

			foreach ( cmam_min_paragraph_options() as $option ) {
				$label = $option['label'];
				if ( $selected == $option['value'] ) // Make default first in list
					$p = "\n\t<option style=\"padding-right: 10px;\" selected='selected' value='" . esc_attr( $option['value'] ) . "'>$label</option>";
				else
					$r .= "\n\t<option style=\"padding-right: 10px;\" value='" . esc_attr( $option['value'] ) . "'>$label</option>";
			}
			echo $p . $r;
		?>
	</select>
	<?php
}


/* SET UP THE OPTIONS SETTINGS FOR THE MAX AD REPEATS
--------------------------------------------------------------------------------------------- */

function cmam_max_ad_repeat_options() {
	$cmam_max_ad_repeat_options = array(
		'1' => array(
			'value' =>	'1',
			'label' => __( '1', 'cmamtx' )
		),
		'2' => array(
			'value' =>	'2',
			'label' => __( '2', 'cmamtx' )
		),
		'3' => array(
			'value' =>	'3',
			'label' => __( '3', 'cmamtx' )
		),
		'4' => array(
			'value' => '4',
			'label' => __( '4', 'cmamtx' )
		),
		'5' => array(
			'value' => '5',
			'label' => __( '5', 'cmamtx' )
		),
		'6' => array(
			'value' => '6',
			'label' => __( '6', 'cmamtx' )
		),
		'7' => array(
			'value' => '7',
			'label' => __( '7', 'cmamtx' )
		),
		'8' => array(
			'value' => '8',
			'label' => __( '8', 'cmamtx' )
		),
		'9' => array(
			'value' => '9',
			'label' => __( '9', 'cmamtx' )
		),
		'10' => array(
			'value' => '10',
			'label' => __( '10', 'cmamtx' )
		),
	);

	return apply_filters( 'cmam_max_ad_repeat_options', $cmam_max_ad_repeat_options );
}


/* OUTPUT THE OPTIONS SETTINGS FOR THE MAX AD REPEATS
--------------------------------------------------------------------------------------------- */

function cmam_max_ad_repeat() {
	$options = get_option( 'cmam_options' );
	?>
	<select name="cmam_options[cmam_max_ad_repeat]" id="cmam_max_ad_repeat">
		<?php
			$selected = $options['cmam_max_ad_repeat'];
			$p = '';
			$r = '';

			foreach ( cmam_max_ad_repeat_options() as $option ) {
				$label = $option['label'];
				if ( $selected == $option['value'] ) // Make default first in list
					$p = "\n\t<option style=\"padding-right: 10px;\" selected='selected' value='" . esc_attr( $option['value'] ) . "'>$label</option>";
				else
					$r .= "\n\t<option style=\"padding-right: 10px;\" value='" . esc_attr( $option['value'] ) . "'>$label</option>";
			}
			echo $p . $r;
		?>
	</select>
	<?php
}


/* SET UP THE OPTIONS SETTINGS FOR ALIGNMENT
--------------------------------------------------------------------------------------------- */

function cmam_alignment_options() {
	$cmam_alignment_options = array(
		'none' => array(
			'value' =>	'none',
			'label' => __( 'None', 'cmamtx' )
		),
		'left' => array(
			'value' =>	'left',
			'label' => __( 'Left', 'cmamtx' )
		),
		'right' => array(
			'value' => 'right',
			'label' => __( 'Right', 'cmamtx' )
		),
		'center' => array(
			'value' => 'center',
			'label' => __( 'Center', 'cmamtx' )
		),
		'floatleft' => array(
			'value' => 'floatleft',
			'label' => __( 'Float Left', 'cmamtx' )
		),
		'floatright' => array(
			'value' => 'floatright',
			'label' => __( 'Float Right', 'cmamtx' )
		),
		'random' => array(
			'value' => 'random',
			'label' => __( 'Random', 'cmamtx' )
		),
	);

	return apply_filters( 'cmam_alignment_options', $cmam_alignment_options );
}


/* OUTPUT THE OPTIONS SETTINGS FOR ALIGNMENT - DEFAULT
--------------------------------------------------------------------------------------------- */

// DEFAULT TOP
function cmamtop_alignment() {
	$options = get_option( 'cmam_options' );
	?>
	<select name="cmam_options[cmamtop_alignment]" id="cmamtop_alignment">
		<?php
			$selected = $options['cmamtop_alignment'];
			$p = '';
			$r = '';

			foreach ( cmam_alignment_options() as $option ) {
				$label = $option['label'];
				if ( $selected == $option['value'] ) // Make default first in list
					$p = "\n\t<option style=\"padding-right: 10px;\" selected='selected' value='" . esc_attr( $option['value'] ) . "'>$label</option>";
				else
					$r .= "\n\t<option style=\"padding-right: 10px;\" value='" . esc_attr( $option['value'] ) . "'>$label</option>";
			}
			echo $p . $r;
		?>
	</select>
	<?php
}

// DEFAULT POSITION 1
function cmampos1_alignment() {
	$options = get_option( 'cmam_options' );
	?>
	<select name="cmam_options[cmampos1_alignment]" id="cmampos1_alignment">
		<?php
			$selected = $options['cmampos1_alignment'];
			$p = '';
			$r = '';

			foreach ( cmam_alignment_options() as $option ) {
				$label = $option['label'];
				if ( $selected == $option['value'] ) // Make default first in list
					$p = "\n\t<option style=\"padding-right: 10px;\" selected='selected' value='" . esc_attr( $option['value'] ) . "'>$label</option>";
				else
					$r .= "\n\t<option style=\"padding-right: 10px;\" value='" . esc_attr( $option['value'] ) . "'>$label</option>";
			}
			echo $p . $r;
		?>
	</select>
	<?php
}

// DEFAULT POSITION 2
function cmampos2_alignment() {
	$options = get_option( 'cmam_options' );
	?>
	<select name="cmam_options[cmampos2_alignment]" id="cmampos2_alignment">
		<?php
			$selected = $options['cmampos2_alignment'];
			$p = '';
			$r = '';

			foreach ( cmam_alignment_options() as $option ) {
				$label = $option['label'];
				if ( $selected == $option['value'] ) // Make default first in list
					$p = "\n\t<option style=\"padding-right: 10px;\" selected='selected' value='" . esc_attr( $option['value'] ) . "'>$label</option>";
				else
					$r .= "\n\t<option style=\"padding-right: 10px;\" value='" . esc_attr( $option['value'] ) . "'>$label</option>";
			}
			echo $p . $r;
		?>
	</select>
	<?php
}

// DEFAULT POSITION 3
function cmampos3_alignment() {
	$options = get_option( 'cmam_options' );
	?>
	<select name="cmam_options[cmampos3_alignment]" id="cmampos3_alignment">
		<?php
			$selected = $options['cmampos3_alignment'];
			$p = '';
			$r = '';

			foreach ( cmam_alignment_options() as $option ) {
				$label = $option['label'];
				if ( $selected == $option['value'] ) // Make default first in list
					$p = "\n\t<option style=\"padding-right: 10px;\" selected='selected' value='" . esc_attr( $option['value'] ) . "'>$label</option>";
				else
					$r .= "\n\t<option style=\"padding-right: 10px;\" value='" . esc_attr( $option['value'] ) . "'>$label</option>";
			}
			echo $p . $r;
		?>
	</select>
	<?php
}

// DEFAULT BOTTOM
function cmambottom_alignment() {
	$options = get_option( 'cmam_options' );
	?>
	<select name="cmam_options[cmambottom_alignment]" id="cmambottom_alignment">
		<?php
			$selected = $options['cmambottom_alignment'];
			$p = '';
			$r = '';

			foreach ( cmam_alignment_options() as $option ) {
				$label = $option['label'];
				if ( $selected == $option['value'] ) // Make default first in list
					$p = "\n\t<option style=\"padding-right: 10px;\" selected='selected' value='" . esc_attr( $option['value'] ) . "'>$label</option>";
				else
					$r .= "\n\t<option style=\"padding-right: 10px;\" value='" . esc_attr( $option['value'] ) . "'>$label</option>";
			}
			echo $p . $r;
		?>
	</select>
	<?php
}


/* OUTPUT THE OPTIONS SETTINGS FOR ALIGNMENT - POSTS
--------------------------------------------------------------------------------------------- */

// POST TOP
function cmamtop_post_alignment() {
	$options = get_option( 'cmam_options' );
	?>
	<select name="cmam_options[cmamtop_post_alignment]" id="cmamtop_post_alignment">
		<?php
			$selected = $options['cmamtop_post_alignment'];
			$p = '';
			$r = '';

			foreach ( cmam_alignment_options() as $option ) {
				$label = $option['label'];
				if ( $selected == $option['value'] ) // Make default first in list
					$p = "\n\t<option style=\"padding-right: 10px;\" selected='selected' value='" . esc_attr( $option['value'] ) . "'>$label</option>";
				else
					$r .= "\n\t<option style=\"padding-right: 10px;\" value='" . esc_attr( $option['value'] ) . "'>$label</option>";
			}
			echo $p . $r;
		?>
	</select>
	<?php
}

// POST POSITION 1
function cmampos1_post_alignment() {
	$options = get_option( 'cmam_options' );
	?>
	<select name="cmam_options[cmampos1_post_alignment]" id="cmampos1_post_alignment">
		<?php
			$selected = $options['cmampos1_post_alignment'];
			$p = '';
			$r = '';

			foreach ( cmam_alignment_options() as $option ) {
				$label = $option['label'];
				if ( $selected == $option['value'] ) // Make default first in list
					$p = "\n\t<option style=\"padding-right: 10px;\" selected='selected' value='" . esc_attr( $option['value'] ) . "'>$label</option>";
				else
					$r .= "\n\t<option style=\"padding-right: 10px;\" value='" . esc_attr( $option['value'] ) . "'>$label</option>";
			}
			echo $p . $r;
		?>
	</select>
	<?php
}

// POST POSITION 2
function cmampos2_post_alignment() {
	$options = get_option( 'cmam_options' );
	?>
	<select name="cmam_options[cmampos2_post_alignment]" id="cmampos2_post_alignment">
		<?php
			$selected = $options['cmampos2_post_alignment'];
			$p = '';
			$r = '';

			foreach ( cmam_alignment_options() as $option ) {
				$label = $option['label'];
				if ( $selected == $option['value'] ) // Make default first in list
					$p = "\n\t<option style=\"padding-right: 10px;\" selected='selected' value='" . esc_attr( $option['value'] ) . "'>$label</option>";
				else
					$r .= "\n\t<option style=\"padding-right: 10px;\" value='" . esc_attr( $option['value'] ) . "'>$label</option>";
			}
			echo $p . $r;
		?>
	</select>
	<?php
}

// POST POSITION 3
function cmampos3_post_alignment() {
	$options = get_option( 'cmam_options' );
	?>
	<select name="cmam_options[cmampos3_post_alignment]" id="cmampos3_post_alignment">
		<?php
			$selected = $options['cmampos3_post_alignment'];
			$p = '';
			$r = '';

			foreach ( cmam_alignment_options() as $option ) {
				$label = $option['label'];
				if ( $selected == $option['value'] ) // Make default first in list
					$p = "\n\t<option style=\"padding-right: 10px;\" selected='selected' value='" . esc_attr( $option['value'] ) . "'>$label</option>";
				else
					$r .= "\n\t<option style=\"padding-right: 10px;\" value='" . esc_attr( $option['value'] ) . "'>$label</option>";
			}
			echo $p . $r;
		?>
	</select>
	<?php
}

// POST BOTTOM
function cmambottom_post_alignment() {
	$options = get_option( 'cmam_options' );
	?>
	<select name="cmam_options[cmambottom_post_alignment]" id="cmambottom_post_alignment">
		<?php
			$selected = $options['cmambottom_post_alignment'];
			$p = '';
			$r = '';

			foreach ( cmam_alignment_options() as $option ) {
				$label = $option['label'];
				if ( $selected == $option['value'] ) // Make default first in list
					$p = "\n\t<option style=\"padding-right: 10px;\" selected='selected' value='" . esc_attr( $option['value'] ) . "'>$label</option>";
				else
					$r .= "\n\t<option style=\"padding-right: 10px;\" value='" . esc_attr( $option['value'] ) . "'>$label</option>";
			}
			echo $p . $r;
		?>
	</select>
	<?php
}


/* OUTPUT THE OPTIONS SETTINGS FOR ALIGNMENT - PAGES
--------------------------------------------------------------------------------------------- */

// PAGE TOP
function cmamtop_page_alignment() {
	$options = get_option( 'cmam_options' );
	?>
	<select name="cmam_options[cmamtop_page_alignment]" id="cmamtop_page_alignment">
		<?php
			$selected = $options['cmamtop_page_alignment'];
			$p = '';
			$r = '';

			foreach ( cmam_alignment_options() as $option ) {
				$label = $option['label'];
				if ( $selected == $option['value'] ) // Make default first in list
					$p = "\n\t<option style=\"padding-right: 10px;\" selected='selected' value='" . esc_attr( $option['value'] ) . "'>$label</option>";
				else
					$r .= "\n\t<option style=\"padding-right: 10px;\" value='" . esc_attr( $option['value'] ) . "'>$label</option>";
			}
			echo $p . $r;
		?>
	</select>
	<?php
}

// PAGE POSITION 1
function cmampos1_page_alignment() {
	$options = get_option( 'cmam_options' );
	?>
	<select name="cmam_options[cmampos1_page_alignment]" id="cmampos1_page_alignment">
		<?php
			$selected = $options['cmampos1_page_alignment'];
			$p = '';
			$r = '';

			foreach ( cmam_alignment_options() as $option ) {
				$label = $option['label'];
				if ( $selected == $option['value'] ) // Make default first in list
					$p = "\n\t<option style=\"padding-right: 10px;\" selected='selected' value='" . esc_attr( $option['value'] ) . "'>$label</option>";
				else
					$r .= "\n\t<option style=\"padding-right: 10px;\" value='" . esc_attr( $option['value'] ) . "'>$label</option>";
			}
			echo $p . $r;
		?>
	</select>
	<?php
}

// PAGE POSITION 2
function cmampos2_page_alignment() {
	$options = get_option( 'cmam_options' );
	?>
	<select name="cmam_options[cmampos2_page_alignment]" id="cmampos2_page_alignment">
		<?php
			$selected = $options['cmampos2_page_alignment'];
			$p = '';
			$r = '';

			foreach ( cmam_alignment_options() as $option ) {
				$label = $option['label'];
				if ( $selected == $option['value'] ) // Make default first in list
					$p = "\n\t<option style=\"padding-right: 10px;\" selected='selected' value='" . esc_attr( $option['value'] ) . "'>$label</option>";
				else
					$r .= "\n\t<option style=\"padding-right: 10px;\" value='" . esc_attr( $option['value'] ) . "'>$label</option>";
			}
			echo $p . $r;
		?>
	</select>
	<?php
}

// PAGE POSITION 3
function cmampos3_page_alignment() {
	$options = get_option( 'cmam_options' );
	?>
	<select name="cmam_options[cmampos3_page_alignment]" id="cmampos3_page_alignment">
		<?php
			$selected = $options['cmampos3_page_alignment'];
			$p = '';
			$r = '';

			foreach ( cmam_alignment_options() as $option ) {
				$label = $option['label'];
				if ( $selected == $option['value'] ) // Make default first in list
					$p = "\n\t<option style=\"padding-right: 10px;\" selected='selected' value='" . esc_attr( $option['value'] ) . "'>$label</option>";
				else
					$r .= "\n\t<option style=\"padding-right: 10px;\" value='" . esc_attr( $option['value'] ) . "'>$label</option>";
			}
			echo $p . $r;
		?>
	</select>
	<?php
}

// PAGE BOTTOM
function cmambottom_page_alignment() {
	$options = get_option( 'cmam_options' );
	?>
	<select name="cmam_options[cmambottom_page_alignment]" id="cmambottom_page_alignment">
		<?php
			$selected = $options['cmambottom_page_alignment'];
			$p = '';
			$r = '';

			foreach ( cmam_alignment_options() as $option ) {
				$label = $option['label'];
				if ( $selected == $option['value'] ) // Make default first in list
					$p = "\n\t<option style=\"padding-right: 10px;\" selected='selected' value='" . esc_attr( $option['value'] ) . "'>$label</option>";
				else
					$r .= "\n\t<option style=\"padding-right: 10px;\" value='" . esc_attr( $option['value'] ) . "'>$label</option>";
			}
			echo $p . $r;
		?>
	</select>
	<?php
}

/* OUTPUT DEBUG OPTIONS
--------------------------------------------------------------------------------------------- */

// do we want to show edit links on ads?
function cmam_display_edit_links() {
	$options = get_option( 'cmam_options' );
	?>
	<label for="cmam-display-edit-links">
		<input type="checkbox" name="cmam_options[display_edit_links]" id="cmam-display-edit-links" <?php checked( 'on', $options['display_edit_links'] ); ?> />
		<?php _e( 'Display edit links beneath ads when logged in', 'cmamtx' );  ?>
	</label>
	<?php 
}

// lets pretend the ads think the are being shown on a mobile phone
function cmam_debug_mobile_ads() {
	$options = get_option( 'cmam_options' );
	if (isset ( $options['debug_mobile_ads'] ) ) {
		$debug_mobile_ads = $options['debug_mobile_ads'];
	}
	else {
		$debug_mobile_ads = 'off';
	}
	?>
	<label for="cmam-debug-mobile-ads">
		<input type="checkbox" name="cmam_options[debug_mobile_ads]" id="cmam-debug-mobile-ads" <?php checked( 'on', $debug_mobile_ads ); ?> />
		<?php _e( 'Force Click Missile to behave as if it has detected a mobile device', 'cmamtx' );  ?>
	</label>
	<?php 
}

// lets pretend the ads think the are being shown on a tablet
function cmam_debug_tablet_ads() {
	$options = get_option( 'cmam_options' );
	if (isset ( $options['debug_tablet_ads'] ) ) {
		$debug_tablet_ads = $options['debug_tablet_ads'];
	}
	else {
		$debug_tablet_ads = 'off';
	}
	?>
	<label for="cmam-debug-tablet-ads">
		<input type="checkbox" name="cmam_options[debug_tablet_ads]" id="cmam-debug-tablet-ads" <?php checked( 'on', $debug_tablet_ads ); ?> />
		<?php _e( 'Force Click Missile to behave as if it has detected a tablet device', 'cmamtx' );  ?>
	</label>
	<?php 
}


// Custom CSS box
function cmam_custom_css() {
	$options = get_option( 'cmam_options' );
	if (isset ( $options['custom_css'] ) ) {
		$custom_css = $options['custom_css'];
	}
	else {
		$custom_css = 'off';
	}
	?>
	<label for="cmam-custom-css">
		<input type="checkbox" name="cmam_options[custom_css]" id="cmam-custom-css" <?php checked( 'on', $custom_css ); ?> />
		<?php _e( 'Activate Custom CSS box', 'cmamtx' );  ?>
	</label>
	<?php 
}

// Individual Posts
function cmam_individual_posts() {
	$options = get_option( 'cmam_options' );
	if (isset ( $options['individual_posts'] ) ) {
		$individual_posts = $options['individual_posts'];
	}
	else {
		$individual_posts = 'off';
	}
	?>
	<label for="cmam-individual-posts">
		<input type="checkbox" name="cmam_options[individual_posts]" id="cmam-individual-posts" <?php checked( 'on', $individual_posts ); ?> />
		<?php _e( 'Activate Individual Posts Box', 'cmamtx' );  ?>
	</label>
	<?php 
}

// Individual Pages
function cmam_individual_pages() {
	$options = get_option( 'cmam_options' );
	if (isset ( $options['individual_pages'] ) ) {
		$individual_pages = $options['individual_pages'];
	}
	else {
		$individual_pages = 'off';
	}
	?>
	<label for="cmam-individual-pages">
		<input type="checkbox" name="cmam_options[individual_pages]" id="cmam-individual-pages" <?php checked( 'on', $individual_pages ); ?> />
		<?php _e( 'Activate Individual Pages Box', 'cmamtx' );  ?>
	</label>
	<?php 
}

// Individual Pages
function cmam_posts_in_category() {
	$options = get_option( 'cmam_options' );
	if (isset ( $options['posts_in_category'] ) ) {
		$posts_in_category = $options['posts_in_category'];
	}
	else {
		$posts_in_category = 'off';
	}
	?>
	<label for="cmam-posts-in-category">
		<input type="checkbox" name="cmam_options[posts_in_category]" id="cmam-posts-in-category" <?php checked( 'on', $posts_in_category ); ?> />
		<?php _e( 'Activate Posts in Category Box', 'cmamtx' );  ?>
	</label>
	<?php 
}

// Category Archives
function cmam_category_archives() {
	$options = get_option( 'cmam_options' );
	if (isset ( $options['category_archives'] ) ) {
		$category_archives = $options['category_archives'];
	}
	else {
		$category_archives = 'off';
	}
	?>
	<label for="cmam-category-archives">
		<input type="checkbox" name="cmam_options[category_archives]" id="cmam-category-archives" <?php checked( 'on', $category_archives ); ?> />
		<?php _e( 'Activate Category Archives Box', 'cmamtx' );  ?>
	</label>
	<?php 
}

// Posts with Tag
function cmam_posts_with_tag() {
	$options = get_option( 'cmam_options' );
	if (isset ( $options['posts_with_tag'] ) ) {
		$posts_with_tag = $options['posts_with_tag'];
	}
	else {
		$posts_with_tag = 'off';
	}
	?>
	<label for="cmam-posts-with-tag">
		<input type="checkbox" name="cmam_options[posts_with_tag]" id="cmam-posts-with-tag" <?php checked( 'on', $posts_with_tag ); ?> />
		<?php _e( 'Activate Posts with Tag Box', 'cmamtx' );  ?>
	</label>
	<?php 
}

// Tag Archives
function cmam_tag_archives() {
	$options = get_option( 'cmam_options' );
	if (isset ( $options['tag_archives'] ) ) {
		$tag_archives = $options['tag_archives'];
	}
	else {
		$tag_archives = 'off';
	}
	?>
	<label for="cmam-tag-archives">
		<input type="checkbox" name="cmam_options[tag_archives]" id="cmam-tag-archives" <?php checked( 'on', $tag_archives ); ?> />
		<?php _e( 'Activate Tag Archves Box', 'cmamtx' );  ?>
	</label>
	<?php 
}

/* IS THIS REALLY A CHECKBOX?
--------------------------------------------------------------------------------------------- */

function cmam_sanitize_checkbox( $input ) {
	if ($input == 'on') {
		$output = 'on'; 
	}
	else {
		$output = 'off';
	}
	return $output;
}


/* SANITIZE THE OPTIONS PAGE
--------------------------------------------------------------------------------------------- */

function cmam_validate_options( $input ) {

	if ( !current_user_can('manage_options') ) return '';

	// DEBUG OPTIONS
	if ( !isset ($input['display_edit_links'] ) ) $input['display_edit_links'] = 'off';
	if ( !isset ($input['debug_mobile_ads'] ) ) $input['debug_mobile_ads'] = 'off';
	if ( !isset ($input['debug_tablet_ads'] ) ) $input['debug_tablet_ads'] = 'off';
	if ( !isset ($input['custom_css'] ) ) $input['custom_css'] = 'off';
	if ( !isset ($input['individual_posts'] ) ) $input['individual_posts'] = 'off';
	if ( !isset ($input['individual_pages'] ) ) $input['individual_pages'] = 'off';
	if ( !isset ($input['posts_in_category'] ) ) $input['posts_in_category'] = 'off';
	if ( !isset ($input['category_archives'] ) ) $input['category_archives'] = 'off';
	if ( !isset ($input['posts_with_tag'] ) ) $input['posts_with_tag'] = 'off';
	if ( !isset ($input['tag_archives'] ) ) $input['tag_archives'] = 'off';
	if ( !isset ($input['suppress_duplicate_excerpt_ads'] ) ) $input['suppress_duplicate_excerpt_ads'] = 'off';
	$valid['display_edit_links'] = cmam_sanitize_checkbox( $input['display_edit_links'] );
	$valid['debug_mobile_ads'] = cmam_sanitize_checkbox( $input['debug_mobile_ads'] );
	$valid['debug_tablet_ads'] = cmam_sanitize_checkbox( $input['debug_tablet_ads'] );
	$valid['custom_css'] = cmam_sanitize_checkbox( $input['custom_css'] );
	$valid['individual_posts'] = cmam_sanitize_checkbox( $input['individual_posts'] );
	$valid['individual_pages'] = cmam_sanitize_checkbox( $input['individual_pages'] );
	$valid['posts_in_category'] = cmam_sanitize_checkbox( $input['posts_in_category'] );
	$valid['category_archives'] = cmam_sanitize_checkbox( $input['category_archives'] );
	$valid['posts_with_tag'] = cmam_sanitize_checkbox( $input['posts_with_tag'] );
	$valid['tag_archives'] = cmam_sanitize_checkbox( $input['tag_archives'] );
	
	// DEFAULT ALIGNMENT
	if ( isset( $input['cmamtop_alignment'] ) && array_key_exists( $input['cmamtop_alignment'], cmam_alignment_options() ) )
		$valid['cmamtop_alignment'] = $input['cmamtop_alignment'];
		
	if ( isset( $input['cmampos1_alignment'] ) && array_key_exists( $input['cmampos1_alignment'], cmam_alignment_options() ) )
		$valid['cmampos1_alignment'] = $input['cmampos1_alignment'];
	
	if ( isset( $input['cmampos2_alignment'] ) && array_key_exists( $input['cmampos2_alignment'], cmam_alignment_options() ) )
		$valid['cmampos2_alignment'] = $input['cmampos2_alignment'];
	
	if ( isset( $input['cmampos3_alignment'] ) && array_key_exists( $input['cmampos3_alignment'], cmam_alignment_options() ) )
		$valid['cmampos3_alignment'] = $input['cmampos3_alignment'];
		
	if ( isset( $input['cmambottom_alignment'] ) && array_key_exists( $input['cmambottom_alignment'], cmam_alignment_options() ) )
		$valid['cmambottom_alignment'] = $input['cmambottom_alignment'];
		
	// POST ALIGNMENT	
	if ( isset( $input['cmamtop_post_alignment'] ) && array_key_exists( $input['cmamtop_post_alignment'], cmam_alignment_options() ) )
		$valid['cmamtop_post_alignment'] = $input['cmamtop_post_alignment'];
		
	if ( isset( $input['cmampos1_post_alignment'] ) && array_key_exists( $input['cmampos1_post_alignment'], cmam_alignment_options() ) )
		$valid['cmampos1_post_alignment'] = $input['cmampos1_post_alignment'];
	
	if ( isset( $input['cmampos2_post_alignment'] ) && array_key_exists( $input['cmampos2_post_alignment'], cmam_alignment_options() ) )
		$valid['cmampos2_post_alignment'] = $input['cmampos2_post_alignment'];
	
	if ( isset( $input['cmampos3_post_alignment'] ) && array_key_exists( $input['cmampos3_post_alignment'], cmam_alignment_options() ) )
		$valid['cmampos3_post_alignment'] = $input['cmampos3_post_alignment'];
		
	if ( isset( $input['cmambottom_post_alignment'] ) && array_key_exists( $input['cmambottom_post_alignment'], cmam_alignment_options() ) )
		$valid['cmambottom_post_alignment'] = $input['cmambottom_post_alignment'];	

	// PAGE ALIGNMENT
	if ( isset( $input['cmamtop_page_alignment'] ) && array_key_exists( $input['cmamtop_page_alignment'], cmam_alignment_options() ) )
		$valid['cmamtop_page_alignment'] = $input['cmamtop_page_alignment'];
		
	if ( isset( $input['cmampos1_page_alignment'] ) && array_key_exists( $input['cmampos1_page_alignment'], cmam_alignment_options() ) )
		$valid['cmampos1_page_alignment'] = $input['cmampos1_page_alignment'];
	
	if ( isset( $input['cmampos2_page_alignment'] ) && array_key_exists( $input['cmampos2_page_alignment'], cmam_alignment_options() ) )
		$valid['cmampos2_page_alignment'] = $input['cmampos2_page_alignment'];
	
	if ( isset( $input['cmampos3_page_alignment'] ) && array_key_exists( $input['cmampos3_page_alignment'], cmam_alignment_options() ) )
		$valid['cmampos3_page_alignment'] = $input['cmampos3_page_alignment'];
		
	if ( isset( $input['cmambottom_page_alignment'] ) && array_key_exists( $input['cmambottom_page_alignment'], cmam_alignment_options() ) )
		$valid['cmambottom_page_alignment'] = $input['cmambottom_page_alignment'];		
		
	if ( isset( $input['cmam_min_paragraph'] ) && array_key_exists( $input['cmam_min_paragraph'], cmam_min_paragraph_options() ) )
		$valid['cmam_min_paragraph'] = $input['cmam_min_paragraph'];
		
	if ( isset( $input['cmam_max_ad_repeat'] ) && array_key_exists( $input['cmam_max_ad_repeat'], cmam_max_ad_repeat_options() ) )
		$valid['cmam_max_ad_repeat'] = $input['cmam_max_ad_repeat'];	
		
	// ALL CLEAR!
	return $valid;
}
?>