<?php
/* 
HeatMap Theme(r) ClickMissile Ads
http://heatmaptheme.com

Copyright Stuart Wider / StuartCindy Art

The name 'HeatMap Theme' and the 'notched circle and flame' logo 
are registered tradmarks of StuartCindy Art and may not be used
without the express written permission of the trademark owner.
*/

/* START OF CUSTOM POST TYPE FOR ADS
--------------------------------------------------------------------------------------------- */

/* CSS SPECIFIC TO THE ADMIN PAGE FOR THIS PLUGIN
--------------------------------------------------------------------------------------------- */
// basically hides a whole heap of unrequired elements so you can't select them

function posttype_admin_css() {
   global $post_type;
    if($post_type == 'cmam_ads') {
   echo '<style type="text/css">#view-post-btn, #post-preview, #message a, .misc-pub-section#visibility, #minor-publishing-actions, .inline-edit-group, #view-switch-excerpt, #view-switch-list, #misc-publishing-actions {display: none;}</style>';
    }
}
add_action('admin_head', 'posttype_admin_css');


/* REGISTER POST TYPES
--------------------------------------------------------------------------------------------- */

function cmam_register_post_types() {

    /* Set up the arguments for the 'cmam_ads' post type. */
    $ad_args = array(
        'public' => false,
		'show_ui' => true,
		'publicly_queryable' => false,
		'exclude_from_search' => true,
		'hierarchical' => false,
        'query_var' => 'cmam_ads',
        'rewrite' => array(
            'slug' => 'cmam/ads',
            'with_front' => false
        ),
		'capabilities' => array(
			'publish_posts' => 'manage_options',
			'edit_posts' => 'manage_options',
			'edit_others_posts' => 'manage_options',
			'delete_posts' => 'manage_options',
			'delete_others_posts' => 'manage_options',
			'read_private_posts' => 'manage_options',
			'edit_post' => 'manage_options',
			'delete_post' => 'manage_options',
			'read_post' => 'manage_options',
    	),
        'supports' => array(
			'title'
        ),
        'labels' => array(
            'name' => __('Click Missile', 'cmamtx'),
            'singular_name' => __('Ad', 'cmamtx'),
            'add_new' => __('Create New Ad', 'cmamtx'),
			'all_items' => __('All Ads', 'cmamtx'),
            'add_new_item' => __('Create New Ad', 'cmamtx'),
            'edit_item' => __('Edit Ad', 'cmamtx'),
            'new_item' => __('New Ad', 'cmamtx'),
            'view_item' => __('View Ad', 'cmamtx'),
            'search_items' => __('Search Ads', 'cmamtx'),
            'not_found' => __('No Ads Found', 'cmamtx'),
            'not_found_in_trash' => __('No Ads Found In Trash', 'cmamtx')
        ),
    );

	// this might not be necessary but lets lock out non admins from ever seeing the ads post type editing screen anyway	
	if( !current_user_can( 'manage_options' ) ):
        $ad_arg['show_ui'] = false;
    endif;

    /* Register the cmam ads album post type. */
    register_post_type( 'cmam_ads', $ad_args );
}
/* Set up the post types. */
add_action( 'init', 'cmam_register_post_types' );

// this might not be necessary but lets lock out non admins from ever seeing the ads post type editing screen anyway
function cmam_remove_menu_items() {
    if( !current_user_can( 'manage_options' ) ):
        remove_menu_page( 'edit.php?post_type=cmam_ads' );
    endif;
}
add_action( 'admin_menu', 'cmam_remove_menu_items' )
?>