<?php
/* 
HeatMap Theme(r) ClickMissile Ads
http://heatmaptheme.com

The name 'HeatMap Theme' and the 'notched circle and flame' logo 
are registered tradmarks of StuartCindy Art and may not be used
without the express written permission of the trademark owner.
*/

/* REGISTER THE IN-CONTENT WIDGET POSITIONS 
/* THESE ARE ADDED TO POSTS BY INJECTING SHORTCODES INTO THE CONTENT
/* They are in spans because block elements can cause validation problems when used in content
--------------------------------------------------------------------------------------------- */

function cmam_register_sidebars () {

	// POST TOP
	register_sidebar(
		array(
		'name' => __( 'Click Missile Top','cmamtx' ),
		'id' => 'cmamtop',
		'before_widget' => '<span class="cmamtop-content-widget cmam-content-widget widget %2$s">',
		'after_widget' => '</span>',
		'before_title' => '<span class="cmamtop-content-widget-title cmam-content-widget-title widget-title">',
		'after_title' => '</span>'
		)	
	);
	
	// POSITION 1
	register_sidebar(
		array(
		'name' => __( 'Click Missile Position 1','cmamtx' ),
		'id' => 'cmampos1',
		'before_widget' => '<span class="cmampos1-content-widget cmam-content-widget widget %2$s">',
		'after_widget' => '</span>',
		'before_title' => '<span class="cmampos1-content-widget-title cmam-content-widget-title widget-title">',
		'after_title' => '</span>'
		)	
	);
	
	// POSITION 2
	register_sidebar(
		array(
		'name' => __( 'Click Missile Position 2','cmamtx' ),
		'id' => 'cmampos2',
		'before_widget' => '<span class="cmampos2-content-widget cmam-content-widget widget %2$s">',
		'after_widget' => '</span>',
		'before_title' => '<span class="ccmampos2-content-widget-title cmam-content-widget-title widget-title">',
		'after_title' => '</span>'
		)	
	);
	
	// POSITION 3
	register_sidebar(
		array(
		'name' => __( 'Click Missile Position  3','cmamtx' ),
		'id' => 'cmampos3',
		'before_widget' => '<span class="cmampos3-content-widget cmam-content-widget widget %2$s">',
		'after_widget' => '</span>',
		'before_title' => '<span class="cmampos3-content-widget-title cmam-content-widget-title widget-title">',
		'after_title' => '</span>'
		)	
	);
	
	// BOTTOM
	register_sidebar(
		array(
		'name' => __( 'Click Missile Bottom','cmamtx' ),
		'id' => 'cmambottom',
		'before_widget' => '<span class="cmambottom-content-widget cmam-content-widget widget %2$s">',
		'after_widget' => '</span>',
		'before_title' => '<span class="cmambottom-content-widget-title cmam-content-widget-title widget-title">',
		'after_title' => '</span>'
		)	
	);
	
}

add_action( 'widgets_init', 'cmam_register_sidebars', 999 );

/* HANDLE IN-CONTENT WIDGET ALIGNMENT - INJECT STYLES INTO HEAD TO ALIGN IN-CONTENT ADS
--------------------------------------------------------------------------------------------- */

function cmam_random_alignment ( $arr ) {
	$num = 1;

	shuffle($arr);
    
    $r = array();
    for ($i = 0; $i < $num; $i++) {
        $r[] = $arr[$i];
    }
    return $num == 1 ? $r[0] : $r;
}


function get_widget_alignment_css ( $alignment, $position ) {

	$css_alignment = '';
	
	if ( cmam_is_mobile() ) return 'text-align: center;'; // if we are in mobile mode then just center the ad
	
	// we dont want the bottom position to float right as it looks messy
	if ( ( $alignment == 'random') && ($position == 'top') ) $alignment = cmam_random_alignment( array ( 'floatleft', 'floatright')); 
	elseif ( ( $alignment == 'random') && ($position == 'bottom') ) $alignment = cmam_random_alignment( array ( 'left', 'center' )); 
	elseif ( $alignment == 'random') $alignment = cmam_random_alignment( array ( 'floatleft','floatright', 'left', 'center' ));
	
	if ( $alignment == 'left') $css_alignment = 'text-align: left;'; 
	if ( $alignment == 'right') $css_alignment = 'text-align: right;'; 
	if ( $alignment == 'floatleft') $css_alignment = 'float:left; margin-right: 15px;'; 
	if ( $alignment == 'floatright') $css_alignment = ' float:right; margin-left: 15px;';
	if ( $alignment == 'center') $css_alignment = 'text-align: center;';
	if ( $alignment == 'none') $css_alignment = 'float:none;';	
	return $css_alignment;	
}


function cmam_widget_alignment() {
	$options = get_option( 'cmam_options' );
	?>
	<style>
		<?php if (is_single()) : ?>
			<?php if ( isset ($options['cmamtop_post_alignment']) ) ?>
				.cmamtop-content-widget {<?php print get_widget_alignment_css ( $options['cmamtop_post_alignment'], 'top'); ?>}
			<?php if ( isset ($options['cmampos1_post_alignment']) ) ?>
				.cmampos1-content-widget {<?php print get_widget_alignment_css ( $options['cmampos1_post_alignment'], 'pos1' ); ?>}
			<?php if ( isset ($options['cmampos2_post_alignment']) ) ?>
				.cmampos2-content-widget {<?php print get_widget_alignment_css ( $options['cmampos2_post_alignment'], 'pos2' ); ?>}
			<?php if ( isset ($options['cmampos3_post_alignment']) ) ?>
				.cmampos3-content-widget {<?php print get_widget_alignment_css ( $options['cmampos3_post_alignment'], 'pos3' ); ?>}
			<?php if ( isset ($options['cmambottom_post_alignment']) ) ?>
				.cmambottom-content-widget {<?php print get_widget_alignment_css ( $options['cmambottom_post_alignment'], 'bottom' ); ?>}
		<?php elseif( is_page() ): ?>
			<?php if ( isset ($options['cmamtop_page_alignment']) ) ?>
				.cmamtop-content-widget {<?php print get_widget_alignment_css ( $options['cmamtop_page_alignment'], 'top' ); ?>}
			<?php if ( isset ($options['cmampos1_page_alignment']) ) ?>
				.cmampos1-content-widget {<?php print get_widget_alignment_css ( $options['cmampos1_page_alignment'], 'pos1' ); ?>}
			<?php if ( isset ($options['cmampos2_page_alignment']) ) ?>
				.cmampos2-content-widget {<?php print get_widget_alignment_css ( $options['cmampos2_page_alignment'], 'pos2' ); ?>}
			<?php if ( isset ($options['cmampos3_page_alignment']) ) ?>
				.cmampos3-content-widget {<?php print get_widget_alignment_css ( $options['cmampos3_page_alignment'], 'pos3' ); ?>}
			<?php if ( isset ($options['cmambottom_page_alignment']) ) ?>
				.cmambottom-content-widget {<?php print get_widget_alignment_css ( $options['cmambottom_page_alignment'], 'bottom' ); ?>}
		<?php else: ?>
			<?php if ( isset ($options['cmamtop_alignment']) ) ?>
				.cmamtop-content-widget {<?php print get_widget_alignment_css ( $options['cmamtop_alignment'], 'top' ); ?>}
			<?php if ( isset ($options['cmampos1_alignment']) ) ?>
				.cmampos1-content-widget {<?php print get_widget_alignment_css ( $options['cmampos1_alignment'], 'pos1' ); ?>}
			<?php if ( isset ($options['cmampos2_alignment']) ) ?>
				.cmampos2-content-widget{<?php print get_widget_alignment_css ( $options['cmampos2_alignment'], 'pos2' ); ?>}
			<?php if ( isset ($options['cmampos3_alignment']) ) ?>
				.cmampos3-content-widget {<?php print get_widget_alignment_css ( $options['cmampos3_alignment'], 'pos3' ); ?>}
			<?php if ( isset ($options['cmambottom_alignment']) ) ?>
				.cmambottom-content-widget {<?php print get_widget_alignment_css ( $options['cmambottom_alignment'], 'bottom' ); ?>}
		<?php endif; ?>
    </style>
    <?php
}
add_action('wp_head', 'cmam_widget_alignment');



/* CHECK FOR STATIC WIDGETS IN WIDGET-READY AREAS
- thanks to Chaos Kaizer and Ian Stewart (themeshaper.com) for this function which makes the sidbar validation much neater
--------------------------------------------------------------------------------------------- */

function cmam_is_sidebar_active($index){
	
	global $wp_registered_sidebars;
	$widgetcolumns = wp_get_sidebars_widgets();
	
	if (isset($widgetcolumns[$index]) && $widgetcolumns[$index]) return true;
	return false;
}

/* INJECT THE WIDGET POSITIONS INTO THE AUTOMATICALLY INSERTED SHORTCODES
--------------------------------------------------------------------------------------------- */

// cmamtop
function cmam_widget_position_cmamtop( $atts ) {
	
	$options = get_option( 'cmam_options' );
	global $cmam_ad_repeat_count;
	$str = '';
	if (!isset($options['cmam_max_ad_repeat'])) $options['cmam_max_ad_repeat'] = 1; 
	
	if ( !( $cmam_ad_repeat_count > $options['cmam_max_ad_repeat'] ) ) { // sometimes you dont want ads to repear indefinately (eg adsense)
		if ( cmam_is_sidebar_active( 'cmamtop' ) ) {
			ob_start();
			dynamic_sidebar( 'cmamtop' );
			$myStr = ob_get_contents();
			ob_end_clean();
			$str .= $myStr;
			return $str;
		}
	}
}

// cmampos1
function cmam_widget_position_cmampos1( $atts ) {

	$options = get_option( 'cmam_options' );
	global $cmam_ad_repeat_count; 
	$str = '';
	if (!isset($options['cmam_max_ad_repeat'])) $options['cmam_max_ad_repeat'] = 1; 
	
	if ( !( $cmam_ad_repeat_count > $options['cmam_max_ad_repeat'] ) ) {
	
		if ( cmam_is_sidebar_active( 'cmampos1' ) ) {
			ob_start();
			dynamic_sidebar( 'cmampos1' );
			$myStr = ob_get_contents();
			ob_end_clean();
			$str .= $myStr;
			return $str;
		}
	}
}

// cmampos2
function cmam_widget_position_cmampos2( $atts ) {

	$options = get_option( 'cmam_options' );
	global $cmam_ad_repeat_count; 
	$str = '';
	if (!isset($options['cmam_max_ad_repeat'])) $options['cmam_max_ad_repeat'] = 1; 
	
	if ( !( $cmam_ad_repeat_count > $options['cmam_max_ad_repeat'] ) ) {
	
		if ( cmam_is_sidebar_active( 'cmampos2' ) ) {
			ob_start();
			dynamic_sidebar( 'cmampos2' );
			$myStr = ob_get_contents();
			ob_end_clean();
			$str .= $myStr;
			return $str;
		}
	}
}

// cmampos3
function cmam_widget_position_cmampos3( $atts ) {

	$options = get_option( 'cmam_options' );
	global $cmam_ad_repeat_count; 
	$str = '';
	if (!isset($options['cmam_max_ad_repeat'])) $options['cmam_max_ad_repeat'] = 1; 
	
	if ( !( $cmam_ad_repeat_count > $options['cmam_max_ad_repeat'] ) ) {

		if ( cmam_is_sidebar_active( 'cmampos3' ) ) {
			ob_start();
			dynamic_sidebar( 'cmampos3' );
			$myStr = ob_get_contents();
			ob_end_clean();
			$str .= $myStr;
			return $str;
		}	
	}
}

// cmambottom
function cmam_widget_position_cmambottom( $atts ) {
	
	$options = get_option( 'cmam_options' );
	global $cmam_ad_repeat_count; 
	$str = '';
	if (!isset($options['cmam_max_ad_repeat'])) $options['cmam_max_ad_repeat'] = 1; 
	
	if ( !( $cmam_ad_repeat_count > $options['cmam_max_ad_repeat'] ) ) {
	
		if ( cmam_is_sidebar_active( 'cmambottom' ) ) {
			ob_start();
			dynamic_sidebar( 'cmambottom' );
			$myStr = ob_get_contents();
			ob_end_clean();
			$str .= $myStr;
			return $str;
		}
	}	
}


/* OVERIDE wp_trim_excerpt() TO PREVENT IT CALLING the_content() WHICH HAS HAD SHORTCODES ADDED ALREADY
/* AND WHICH CAUSES ADS TO BE SHOWN TWICE WHEN IN BLOG POST LISTINGS - WHICH LOOKS WEIRD  
--------------------------------------------------------------------------------------------- */

function cmam_wp_trim_excerpt($text = '') {
	$raw_excerpt = $text;
	if ( '' == $text ) {
		$text = get_the_content('');

		$text = strip_shortcodes( $text );

		$text = str_replace(']]>', ']]&gt;', $text);
		$excerpt_length = apply_filters('excerpt_length', 55);
		$excerpt_more = apply_filters('excerpt_more', ' ' . '[...]');
		$text = wp_trim_words( $text, $excerpt_length, $excerpt_more );
	}
	return apply_filters('wp_trim_excerpt', $text, $raw_excerpt);
}

remove_filter ('get_the_excerpt', 'wp_trim_excerpt');
add_filter ('get_the_excerpt', 'cmam_wp_trim_excerpt');



/* TOP AND TAIL THE EXCERPT WITH A TOP WIDGET AND BOTTOM WIDGET ONLY
--------------------------------------------------------------------------------------------- */


function cmam_topntail_excerpt($excerpt_content) {
	
	global $cmam_previous_id;
	global $cmam_ad_repeat_count;
	global $post_excerpt_content;
	
	$str = '';
							
	$options = get_option( 'cmam_options' ); 
	if (!isset($options['cmam_max_ad_repeat'])) $options['cmam_max_ad_repeat'] = 1; 
	
	$this_page_post_id = get_the_ID();	
	$this_page_post_meta = get_post_meta ( $this_page_post_id );
	if (!isset ( $this_page_post_meta['_cmam_ads_hide_out_of_context_ad_widgets'][0])) $this_page_post_meta['_cmam_ads_hide_out_of_context_ad_widgets'][0] = '';
	
	if (!$this_page_post_meta['_cmam_ads_hide_out_of_context_ad_widgets'][0] == 'on') {
		if ($cmam_previous_id != $this_page_post_id) ++$cmam_ad_repeat_count; 
		
		if ( !( $cmam_ad_repeat_count > $options['cmam_max_ad_repeat'] ) ) {
			if ( cmam_is_sidebar_active( 'cmamtop' ) ) {
				ob_start();
				dynamic_sidebar( 'cmamtop' );
				$myStr = ob_get_contents();
				ob_end_clean();
				$str .= $myStr;
			}
		}
	}
	
	$myStr = $excerpt_content;
	$str .= $myStr;
	if (!cmam_contains_peas($excerpt_content)) $str = '<p>' . $str . '</p>';

	
	if (!$this_page_post_meta['_cmam_ads_hide_out_of_context_ad_widgets'][0] == 'on') {
		if ( !( $cmam_ad_repeat_count > $options['cmam_max_ad_repeat'] ) ) {	
			if ( cmam_is_sidebar_active( 'cmambottom' ) ) {
				ob_start();
				dynamic_sidebar( 'cmambottom' );
				$myStr = ob_get_contents();
				ob_end_clean();
				$str .= $myStr;
			}
		}
	}
	$cmam_previous_id = $this_page_post_id;
	$post_excerpt_content = '';
	return $str;
}

add_filter ('the_excerpt', 'cmam_topntail_excerpt' );

/* INJECT THE SHORTCODES INTO THE CONTENT
--------------------------------------------------------------------------------------------- */

// split the paragraphs out - we want to inject the shortcodes after every </p>
function cmam_explode_peas ( $content ) {
	$split_peas = preg_split('(<\/p>|<\/P>)', $content);
	return $split_peas; 
}


	
// check to see if a split out para really contains p tags before adding a /p	
function cmam_contains_peas($string) {
        
		$peas_found = false;
		
		if (!(strpos($string, '<p') === false)) {
			$peas_found = true;
        }
		
		if (!(strpos($string, '<P') === false)) {
			$peas_found = true;
        }
		
		if (!(strpos($string, '<PRE') === false)) {
			$peas_found = false;
        }
		
		if (!(strpos($string, '<pre') === false)) {
			$peas_found = false;
        }

	return $peas_found;
}
	

// now figure out where to split the content and insert the shortcodes which generate the in-content widget positions
function cmam_add_widget_areas_to_post($content) {
	
	global $post;
	global $cmam_ad_repeat_count;
	global $cmam_previous_id; 	// wp touch seems to call the_excerpt and the_content multiple times so we need to figure out
								// if this is a new post so we can increment the count
	
	$options = get_option( 'cmam_options' );

	$this_page_post_id = get_the_ID();	
	$this_page_post_meta = get_post_meta ( $this_page_post_id );	
	
	if (!isset ( $this_page_post_meta['_cmam_ads_hide_out_of_context_ad_widgets'][0])) $this_page_post_meta['_cmam_ads_hide_out_of_context_ad_widgets'][0] = '';
	
	if (!(is_page() || (is_single() && ($post->post_type == 'post'))) && ($this_page_post_meta['_cmam_ads_hide_out_of_context_ad_widgets'][0] == 'on')) { // if we have set this not to show if the page or post is out of context then don't show it
		$cmam_previous_id = $this_page_post_id;
		return $content;
	}	
	elseif ($cmam_previous_id != $this_page_post_id) ++$cmam_ad_repeat_count; // otherwise keep incrementing how many posts have shown so far
	
	if ( ( is_single() && ($post->post_type == 'post') ) || is_page() || is_home() || is_front_page() || is_archive() || is_category() || is_tag() || is_author() || is_date () || is_search() || is_404 () ) {
		
		
		// get the minimum size for paragraphs
		if ( !isset ($options['cmam_min_paragraph'] ) ) $min_para_chars = 100;
		else $min_para_chars = $options['cmam_min_paragraph'];
		
		$this_content = '';
		$widget_count = 1; // we want to count how many widgets we are generating so we dont get too many
		$total_content_length = strlen ($content);
		$processed_so_far = 0; // this is how many characters we have processed so we can see how far along we are
		$unprocessed = 0; // this is so we can compare if we have enough characters to split out another paragraph
		
		$this_content .=  '[cmamtop]';
		$index = 0; // we need to track how far we are through the array so we can handle the last para differently
	
		$output = cmam_explode_peas ( $content );
		
		end($output);
		$last_id=key($output); // find the last id of the array so we can process </p> differently for that. ie miss it out.
		reset($output);
		
		foreach ($output as $paragraph) {
			
			$trimmed_para = trim ($paragraph);
			
			/* check for paragraphs that only have html in them */ 
			$content_with_no_tags = '';
			$content_with_no_tags = strip_tags($trimmed_para);

			
			if (!empty ( $trimmed_para )) { // the last string in the array is always blank unless it has something in it other than a paragraph eg <pre>
											// thats because cmam_explode_peas finds the last </p> and splits out a blank there or tags with no paras
				$this_content .= $paragraph;
				
				$processed_so_far = $processed_so_far + strlen ($paragraph);
				
				if (((strlen ($paragraph) >= $min_para_chars ) && ($widget_count <= 3)) || $unprocessed >= $min_para_chars) {
					if (($index != $last_id) && cmam_contains_peas($paragraph)) $this_content .= '</p>'; // if we are on the last item in the array dont add a </p>
					if ((($total_content_length - $processed_so_far) >= $min_para_chars) && ( $content_with_no_tags != '' )) { 
						if ($widget_count <= 3) $this_content .= '[cmampos' . $widget_count . ']';
						++$widget_count;
						$unprocessed = 0; // reset the amount unprocessed so we can figure out if the next para is going to have a widget position in it
					}
				}
				else {
					if (($index != $last_id) && cmam_contains_peas($paragraph)) $this_content .= '</p>'; // if we are on the last item in the array dont add a </p>
					$unprocessed = $unprocessed + strlen ($paragraph);
				}
			}
			else $unprocessed = $unprocessed + strlen ($paragraph);
			++$index;
		}
		
		$this_content .=  '[cmambottom]';
		$content = $this_content;
	}
	
	$cmam_previous_id = $this_page_post_id;
	
  	return $content;
}

add_filter('the_content', 'cmam_add_widget_areas_to_post' );
?>