<?php
/* 
HeatMap Theme(r) ClickMissile Ads
http://heatmaptheme.com

The name 'HeatMap Theme' and the 'notched circle and flame' logo 
are registered tradmarks of StuartCindy Art and may not be used
without the express written permission of the trademark owner.
*/

/* SET UP THE WIDGET
--------------------------------------------------------------------------------------------- */

// use widgets_init action hook to execute custom function
add_action( 'widgets_init', 'cmam_responsive_ad_widget_register_widgets' );

 //register our widget
function cmam_responsive_ad_widget_register_widgets() {
    register_widget( 'cmam_responsive_ad_widget' );
}

function cmam_insertstring($string, $new, $pos) {
   return  str_replace($pos, $new.$pos ,$string);
}

/* THE WIDGET CLASS
--------------------------------------------------------------------------------------------- */

class cmam_responsive_ad_widget extends WP_Widget {

    //process the new widget
    function cmam_responsive_ad_widget() {
        $widget_ops = array( 
			'classname' => 'cmam_responsive_ad_widget_class', 
			'description' => __( 'Click Missile Ad Widget', 'cmamtx' )
			); 
		$control_ops = array( 'id_base' => 'cmam_responsive_ad_widget' );
        $this->WP_Widget( 'cmam_responsive_ad_widget', __('Click Missile Ad', 'cmamtx'), $widget_ops, $control_ops );
    }
 
    //build the widget settings form
    function form($instance) {
		
		$options = get_option( 'cmam_options' );	
			
		if ( isset ( $instance['title'] )) $title = $instance['title'];
		else $title = '';
        $defaults = array( 
			'title' => __( 'Advertisement', 'cmamtx' ), 
			'display_title' => 'off', 
			'ad_code_select' => '',
			'mobile_ad_code_select' => '',
			'tablet_ad_code_select' => '',
			'home_page' => 'off',
			'front_page' => 'off',
			'pages' => 'off',
			'posts' => 'off',
			'category_archives' => 'off',
			'tag_archives' => 'off',
			'date_archives' => 'off',
			'author_archives' => 'off',			
			'archives' => 'off',
			'search' => 'off',
			'attachments' => 'off',
			'404notfound' => 'off',
			'cats' => '',
			'tags' => '',
			'single_pages' => '',
			'single_posts' => '',
			'pics' => '',
			'pwts' => '',
			'custom_css' => ''
			); 
        $instance = wp_parse_args( (array) $instance, $defaults );
        ?>
<?php 
		/* WIDGET TITLE
		--------------------------------------------------------------------------------------------- */
?>
		<div style="clear:both; margin-top:10px; margin-bottom:10px;">	
			<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e('Title:', 'cmamtx'); ?></label>
			<input id="<?php echo $this->get_field_id( 'title' ); ?>" class="widefat" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo $instance['title']; ?>" style="width: 100%; margin-right:20px; margin-top:5px;" />
			</div>
			<div style="clear:both;  margin-bottom:10px;">	
			<label for="<?php echo $this->get_field_id( 'display_title' ); ?>" style="margin-right:20px;"><?php _e('Display title above ad?', 'cmamtx'); ?></label>	
			<input class="checkbox" type="checkbox" <?php checked($instance['display_title'],'on' ); ?> id="<?php echo $this->get_field_id( 'display_title' ); ?>" name="<?php echo $this->get_field_name( 'display_title' ); ?>" />
		</div>	

<?php 
		/* AD CODE BOXES
		--------------------------------------------------------------------------------------------- */
?>		
		<div style="clear:both;  margin-bottom:10px;">	
		<?php 
			$cmam_ads_array = cmam_get_the_ads (); // get the array of ads for the drop down 
			?>
			<label for="<?php echo $this->get_field_id( 'ad_code_select' ); ?>"><?php _e( 'Ad to display on desktop & tablet:', 'cmamtx' ); ?></label>
			<?php
			echo '<select name="' . $this->get_field_name( 'ad_code_select' ) . '" id="' . $this->get_field_id( 'ad_code_select' ) . '" style="width: 100%;">';
			echo '<option', $instance['ad_code_select'] == 'ad-off' ? ' selected="selected"' : '', ' value="ad-off">- ' . __('Off','cmamtx') . ' -</option>';
			foreach ($cmam_ads_array as $ads_option) {
				echo '<option', $instance['ad_code_select'] == $ads_option['value'] ? ' selected="selected"' : '', ' value="'.$ads_option['value'].'">'.$ads_option['label'].'</option>';
			} 
			echo '</select>';
		?>
		</div>
		<div style="clear:both;  margin-bottom:10px;">
		<?php 
			$cmam_ads_array = cmam_get_the_tablet_ads (); // get the array of ads for the drop down 
			?>
			<label for="<?php echo $this->get_field_id( 'tablet_ad_code_select' ); ?>"><?php _e( 'Ad to display on tablet devices:', 'cmamtx' ); ?></label>
			<br/>
			<?php
			echo '<select name="' . $this->get_field_name( 'tablet_ad_code_select' ) . '" id="' . $this->get_field_id( 'tablet_ad_code_select' ) . '" style="width: 100%;">';
			echo '<option', $instance['tablet_ad_code_select'] == 'ad-off' ? ' selected="selected"' : '', ' value="ad-off">- ' . __('Off','cmamtx') . ' -</option>';
			echo '<option', $instance['tablet_ad_code_select'] == 'display-desktop' ? ' selected="selected"' : '', ' value="display-desktop">- ' . __('Display desktop ad','cmamtx') . ' -</option>';
			foreach ($cmam_ads_array as $ads_option) {
				echo '<option', $instance['tablet_ad_code_select'] == $ads_option['value'] ? ' selected="selected"' : '', ' value="'.$ads_option['value'].'">'.$ads_option['label'].'</option>';
			} 
			echo '</select>';
		?>
		</div>
		<div style="clear:both;  margin-bottom:10px;">
		<?php 
			$cmam_ads_array = cmam_get_the_mobile_ads (); // get the array of ads for the drop down 
			?>
			<label for="<?php echo $this->get_field_id( 'mobile_ad_code_select' ); ?>"><?php _e( 'Ad to display on mobile devices:', 'cmamtx' ); ?></label>
			<br/>
			<?php
			echo '<select name="' . $this->get_field_name( 'mobile_ad_code_select' ) . '" id="' . $this->get_field_id( 'mobile_ad_code_select' ) . '" style="width: 100%;">';
			echo '<option', $instance['mobile_ad_code_select'] == 'ad-off' ? ' selected="selected"' : '', ' value="ad-off">- ' . __('Off','cmamtx') . ' -</option>';
			echo '<option', $instance['mobile_ad_code_select'] == 'display-desktop' ? ' selected="selected"' : '', ' value="display-desktop">- ' . __('Display desktop ad','cmamtx') . ' -</option>';
			foreach ($cmam_ads_array as $ads_option) {
				echo '<option', $instance['mobile_ad_code_select'] == $ads_option['value'] ? ' selected="selected"' : '', ' value="'.$ads_option['value'].'">'.$ads_option['label'].'</option>';
			} 
			echo '</select>';
		?>
		</div>
<?php 
		/* MAIN TEMPLATE TYPES
		--------------------------------------------------------------------------------------------- */
?>		
		<div style="clear:both; margin-bottom:10px;">	
			<p><?php _e('Display the ad on...', 'cmamtx'); ?></p>
					<input class="checkbox" type="checkbox" <?php checked($instance['home_page'],'on' ); ?> id="<?php echo $this->get_field_id( 'home_page' ); ?>" name="<?php echo $this->get_field_name( 'home_page' ); ?>" /> 
					<label for="<?php echo $this->get_field_id( 'home_page' ); ?>"><?php _e('Home Page', 'cmamtx'); ?></label>
					<?php echo "<br/>"; ?>
					
					<input class="checkbox" type="checkbox" <?php checked($instance['front_page'],'on' ); ?> id="<?php echo $this->get_field_id( 'front_page' ); ?>" name="<?php echo $this->get_field_name( 'front_page' ); ?>" /> 
					<label for="<?php echo $this->get_field_id( 'front_page' ); ?>"><?php _e('Front Page', 'cmamtx'); ?></label>
					<?php echo "<br/>"; ?>
		
					<input class="checkbox" type="checkbox" <?php checked($instance['pages'],'on' ); ?> id="<?php echo $this->get_field_id( 'pages' ); ?>" name="<?php echo $this->get_field_name( 'pages' ); ?>" /> 
					<label for="<?php echo $this->get_field_id( 'pages' ); ?>"><?php _e('All Pages', 'cmamtx'); ?></label>
					<?php echo "<br/>"; ?>
		
					<input class="checkbox" type="checkbox" <?php checked($instance['posts'],'on' ); ?> id="<?php echo $this->get_field_id( 'posts' ); ?>" name="<?php echo $this->get_field_name( 'posts' ); ?>" /> 
					<label for="<?php echo $this->get_field_id( 'posts' ); ?>"><?php _e('All Posts', 'cmamtx'); ?></label>
					<?php echo "<br/>"; ?>	
					
					<input class="checkbox" type="checkbox" <?php checked($instance['category_archives'],'on' ); ?> id="<?php echo $this->get_field_id( 'category_archives' ); ?>" name="<?php echo $this->get_field_name( 'category_archives' ); ?>" /> 
					<label for="<?php echo $this->get_field_id( 'category_archives' ); ?>"><?php _e('All Category Archives', 'cmamtx'); ?></label>
					<?php echo "<br/>"; ?>
					
					<input class="checkbox" type="checkbox" <?php checked($instance['tag_archives'],'on' ); ?> id="<?php echo $this->get_field_id( 'tag_archives' ); ?>" name="<?php echo $this->get_field_name( 'tag_archives' ); ?>" /> 
					<label for="<?php echo $this->get_field_id( 'tag_archives' ); ?>"><?php _e('All Tag Archives', 'cmamtx'); ?></label>
					<?php echo "<br/>"; ?>					
								
					<input class="checkbox" type="checkbox" <?php checked($instance['author_archives'],'on' ); ?> id="<?php echo $this->get_field_id( 'author_archives' ); ?>" name="<?php echo $this->get_field_name( 'author_archives' ); ?>" /> 
					<label for="<?php echo $this->get_field_id( 'author_archives' ); ?>"><?php _e('All Author Archives', 'cmamtx'); ?></label>
					<?php echo "<br/>"; ?>
		
					<input class="checkbox" type="checkbox" <?php checked($instance['date_archives'],'on' ); ?> id="<?php echo $this->get_field_id( 'date_archives' ); ?>" name="<?php echo $this->get_field_name( 'date_archives' ); ?>" /> 
					<label for="<?php echo $this->get_field_id( 'date_archives' ); ?>"><?php _e('All Date & Time Archives', 'cmamtx'); ?></label>
					<?php echo "<br/>"; ?>
			
					<input class="checkbox" type="checkbox" <?php checked($instance['archives'],'on' ); ?> id="<?php echo $this->get_field_id( 'archives' ); ?>" name="<?php echo $this->get_field_name( 'archives' ); ?>" /> 
					<label for="<?php echo $this->get_field_id( 'archives' ); ?>"><?php _e('All Archives', 'cmamtx'); ?></label>
					<?php echo "<br/>"; ?>			
			
					<input class="checkbox" type="checkbox" <?php checked($instance['search'],'on' ); ?> id="<?php echo $this->get_field_id( 'search' ); ?>" name="<?php echo $this->get_field_name( 'search' ); ?>" /> 
					<label for="<?php echo $this->get_field_id( 'search' ); ?>"><?php _e('Search', 'cmamtx'); ?></label>
					<?php echo "<br/>"; ?>
					
					<input class="checkbox" type="checkbox" <?php checked($instance['404notfound'],'on' ); ?> id="<?php echo $this->get_field_id( '404notfound' ); ?>" name="<?php echo $this->get_field_name( '404notfound' ); ?>" /> 
					<label for="<?php echo $this->get_field_id( '404notfound' ); ?>"><?php _e('404 Not Found', 'cmamtx'); ?></label>
		</div>
		<?php
					print '<div style="background-color: lightBlue;
		border: solid 1px #DDD; margin-top:5px; margin-bottom:10px; padding: 5px; ">' . __('To activate more widget options visit the Click Missile settings page.', 'cmamtx') . '</div>';
		?>
		
		<?php if ( isset ( $options [ 'custom_css' ] ) ):  ?>
			<?php if ($options [ 'custom_css' ] == 'on' ): ?>
				<div style="clear:both; margin-bottom:10px;">
					<p><?php _e('Custom CSS (desktop and tablet)', 'cmamtx'); ?></p>
					<textarea name="<?php echo $this->get_field_name( 'custom_css' ); ?>" type="text" style="width:100%; height: 100px;"><?php echo esc_textarea ( $instance['custom_css'] ); ?></textarea>
				</div>
			<?php endif; ?>
		<?php endif; ?>
<?php 
		/* INDIVIDUAL POSTS
		--------------------------------------------------------------------------------------------- */
?>	
		<?php if ( isset ( $options [ 'individual_posts' ] ) ):  ?>
			<?php if ($options [ 'individual_posts' ] == 'on' ): ?>
				<div style="clear:both; margin-bottom:10px;">
						<label for="<?php echo $this->get_field_id('single_posts'); ?>"><?php _e('Indvidual Posts:', 'cmamtx');?> 
							<div class="widefat" style="width:100%; height: 150px; overflow:auto; background-color:#FFFFFF; border: solid 1px #DDD;">
							<div style="padding:10px;">
								<?php
								$args = array(
									'orderby' => 'title',
									'order'=> 'ASC',
									'meta_query' => array(
										array(
											'key' => '_cmam_ads_post_selectable',
											'value' => 'on',
										)
									)
								);
		
								$single_posts = get_posts($args);
								foreach ($single_posts as $single_post) {
								$option='<input type="checkbox" id="'. $this->get_field_id( 'single_posts' ) .'[]" name="'. $this->get_field_name( 'single_posts' ) .'[]"';
									if (is_array($instance['single_posts'])) {
										foreach ($instance['single_posts'] as $single_posts) {
											if($single_posts == $single_post->ID) {
												 $option=$option.' checked="checked"';
											}
										}
									}
									$option .= ' value="'.$single_post->ID.'" />';
									
									if ( $single_post->post_title == '' ) $this_post_title = '<em>' . __('Untitled Post', 'cmamtx') . '</em>';
									else $this_post_title = $single_post->post_title;
									$option .= ' ' . $this_post_title;
									
									$option .= '<br />';
									echo $option;
								}
		
								print '<div style="background-color: lightYellow;
		border: solid 1px #E6DB55; margin-top:5px; padding: 5px; ">' . __('To add posts to this option, visit the post editor for your chosen post and tick the \'Available for selection in ad widget\' checkbox. It will then be selectable here.', 'cmamtx') . '</div>';
								?> 
							</div>
							</div>
						</label>
				</div>
			<?php endif; ?>
		<?php endif; ?>			
<?php 
		/* POSTS IN CATEGORY
		--------------------------------------------------------------------------------------------- */
		
?>
		<?php if ( isset ( $options [ 'posts_in_category' ] ) ):  ?>
			<?php if ($options [ 'posts_in_category' ] == 'on' ): ?>
				<div style="clear:both; margin-bottom:10px;">	
						<label for="<?php echo $this->get_field_id('pics'); ?>"><?php _e('Posts in Category:', 'cmamtx');?> 
							<div class="widefat" style="width:95%; height: 150px; overflow:auto; margin-top:5px;  padding-left: 10px; padding-top:10px; background-color:#FFFFFF; border: solid 1px #DDD;">
								<?php
								$pics=  get_categories('hide_empty=0');
								foreach ($pics as $pic) {
									$option='<input type="checkbox" id="'. $this->get_field_id( 'pics' ) .'[]" name="'. $this->get_field_name( 'pics' ) .'[]"';
									if (is_array($instance['pics'])) {
										foreach ($instance['pics'] as $pics) {
											if($pics==$pic->term_id) {
												 $option=$option.' checked="checked"';
											}
										}
									}
									$option .= ' value="'.$pic->term_id.'" />';
				
									$option .= ' ' . $pic->cat_name;
									
									$option .= '<br />';
									echo $option;
								}
								?>
							</div>
						</label>		
				</div>
			<?php endif; ?>
		<?php endif; ?>			
<?php 
	
		/* CATEGORY ARCHIVES
		--------------------------------------------------------------------------------------------- */
		
?>
		<?php if ( isset ( $options [ 'category_archives' ] ) ):  ?>
			<?php if ($options [ 'category_archives' ] == 'on' ): ?>
				<div style="clear:both; margin-bottom:10px;">				
						<label for="<?php echo $this->get_field_id('cats'); ?>"><?php _e('Category Archives:', 'cmamtx');?> 
							<div class="widefat" style="width:95%; height: 150px; overflow:auto; margin-top:5px; padding-left: 10px; padding-top:10px; background-color:#FFFFFF; border: solid 1px #DDD;">
								<?php
								$categories=  get_categories('hide_empty=0');
								foreach ($categories as $cat) {
									$option='<input type="checkbox" id="'. $this->get_field_id( 'cats' ) .'[]" name="'. $this->get_field_name( 'cats' ) .'[]"';
									if (is_array($instance['cats'])) {
										foreach ($instance['cats'] as $cats) {
											if($cats==$cat->term_id) {
												 $option=$option.' checked="checked"';
											}
										}
									}
									$option .= ' value="'.$cat->term_id.'" />';
				
									$option .= ' ' . $cat->cat_name;
									
									$option .= '<br />';
									echo $option;
								}
								?>
							</div>
						</label>
				</div>
			<?php endif; ?>
		<?php endif; ?>				
		<?php 

		/* INDIVIDUAL PAGES
		--------------------------------------------------------------------------------------------- */
		

?>
		<?php if ( isset ( $options [ 'individual_pages' ] ) ):  ?>
			<?php if ($options [ 'individual_pages' ] == 'on' ): ?>		
				<div style="clear:both; margin-bottom:10px;">
						<label for="<?php echo $this->get_field_id('single_pages'); ?>"><?php _e('Individual Pages:', 'cmamtx');?> 
							<div class="widefat" style="width:95%; height: 150px; overflow:auto; margin-top:5px; padding-left: 10px; padding-top:10px; background-color:#FFFFFF; border: solid 1px #DDD;">
								<?php
								$args =  array ('sort_order' => 'ASC', 'sort_column' => 'post_title', 'hierarchical' => 0);
								$single_pages = get_pages( $args );
								foreach ($single_pages as $single_page) {
								$option='<input type="checkbox" id="'. $this->get_field_id( 'single_pages' ) .'[]" name="'. $this->get_field_name( 'single_pages' ) .'[]"';
									if (is_array($instance['single_pages'])) {
										foreach ($instance['single_pages'] as $single_pages) {
											if($single_pages==$single_page->ID) {
												 $option=$option.' checked="checked"';
											}
										}
									}
									$option .= ' value="'.$single_page->ID.'" />';
									
									if ( $single_page->post_title == '' ) $this_page_title = '<em>Untitled Page</em>';
									else $this_page_title = $single_page->post_title;
									$option .= ' ' . $this_page_title;
									
									$option .= '<br />';
									echo $option;
								}
								?>
							</div>
						</label>
				</div>
			<?php endif; ?>
		<?php endif; ?>						
<?php 


		/* POSTS WITH TAG
		--------------------------------------------------------------------------------------------- */
		
?>
		<?php if ( isset ( $options [ 'posts_with_tag' ] ) ):  ?>
			<?php if ($options [ 'posts_with_tag' ] == 'on' ): ?>	
				<div style="clear:both; margin-bottom:10px;">		
						<label for="<?php echo $this->get_field_id('pwts'); ?>"><?php _e('Posts with Tag:', 'cmamtx');?> 
							<div class="widefat" style="width:95%; height: 150px; overflow:auto; margin-top:5px; padding-left: 10px; padding-top:10px; background-color:#FFFFFF; border: solid 1px #DDD;">
								<?php
								$pwts =  get_tags('hide_empty=0');
								foreach ($pwts as $pwt) {
									$option='<input type="checkbox" id="'. $this->get_field_id( 'pwts' ) .'[]" name="'. $this->get_field_name( 'pwts' ) .'[]"';
									if (is_array($instance['pwts'])) {
										foreach ($instance['pwts'] as $pwts) {
											if($pwts==$pwt->term_id) {
												 $option=$option.' checked="checked"';
											}
										}
									}
									$option .= ' value="'.$pwt->term_id.'" />';
				
									$option .= ' ' . $pwt->name;
									
									$option .= '<br />';
									echo $option;
								}
								?>
							</div>
						</label>
				</div>
			<?php endif; ?>
		<?php endif; ?>
<?php 


		/* TAG ARCHIVES
		--------------------------------------------------------------------------------------------- */
		

?>
		<?php if ( isset ( $options [ 'tag_archives' ] ) ):  ?>
			<?php if ($options [ 'tag_archives' ] == 'on' ): ?>		
				<div style="clear:both; margin-bottom:10px;">	
						<label for="<?php echo $this->get_field_id('tags'); ?>"><?php _e('Tag Archives:', 'cmamtx');?> 
							<div class="widefat" style="width:95%; height: 150px; overflow:auto; margin-top:5px; padding-left: 10px; padding-top:10px; background-color:#FFFFFF; border: solid 1px #DDD;">
								<?php
								$tags = get_tags('hide_empty=0');
								foreach ($tags as $tag) {
								$option='<input type="checkbox" id="'. $this->get_field_id( 'tags' ) .'[]" name="'. $this->get_field_name( 'tags' ) .'[]"';
									if (is_array($instance['tags'])) {
										foreach ($instance['tags'] as $tags) {
											if($tags==$tag->term_id) {
												 $option=$option.' checked="checked"';
											}
										}
									}
									$option .= ' value="'.$tag->term_id.'" />';
				
									$option .= ' ' . $tag->name;
									
									$option .= '<br />';
									echo $option;
								}
								?>
							</div>
						</label>
				</div>
			<?php endif; ?>
		<?php endif; ?>
		
		<div style="clear:both"></div>
        <?php
    }

	/* SAVE WIDGET SETTINGS
	--------------------------------------------------------------------------------------------- */ 

    function update($new_instance, $old_instance) {
		
        $instance = $old_instance;
		
        $instance['title'] = strip_tags( $new_instance['title'] );
		
		if ( !isset( $new_instance['display_title'] ) ) $new_instance['display_title'] = 'off';
		$instance['display_title'] = $new_instance['display_title'];
		
		if ( !isset( $new_instance['advanced_options'] ) ) $new_instance['advanced_options'] = 'off';
		$instance['advanced_options'] = $new_instance['advanced_options'];
		
		if ( !isset( $new_instance['home_page'] ) ) $new_instance['home_page'] = 'off';
		$instance['home_page'] = $new_instance['home_page'];
		
		if ( !isset( $new_instance['front_page'] ) ) $new_instance['front_page'] = 'off';
		$instance['front_page'] = $new_instance['front_page'];

		if ( !isset( $new_instance['pages'] ) ) $new_instance['pages'] = 'off';
		$instance['pages'] = $new_instance['pages'];
		
		if ( !isset( $new_instance['posts'] ) ) $new_instance['posts'] = 'off';
		$instance['posts'] = $new_instance['posts'];
		
		if ( !isset( $new_instance['category_archives'] ) ) $new_instance['category_archives'] = 'off';
		$instance['category_archives'] = $new_instance['category_archives'];
		
		if ( !isset( $new_instance['tag_archives'] ) ) $new_instance['tag_archives'] = 'off';
		$instance['tag_archives'] = $new_instance['tag_archives'];
		
		if ( !isset( $new_instance['author_archives'] ) ) $new_instance['author_archives'] = 'off';
		$instance['author_archives'] = $new_instance['author_archives'];
		
		if ( !isset( $new_instance['date_archives'] ) ) $new_instance['date_archives'] = 'off';
		$instance['date_archives'] = $new_instance['date_archives'];
		
		if ( !isset( $new_instance['archives'] ) ) $new_instance['archives'] = 'off';
		$instance['archives'] = $new_instance['archives'];
		
		if ( !isset( $new_instance['search'] ) ) $new_instance['search'] = 'off';
		$instance['search'] = $new_instance['search'];
		
		if ( !isset( $new_instance['404notfound'] ) ) $new_instance['404notfound'] = 'off';
		$instance['404notfound'] = $new_instance['404notfound'];
		
		$instance['ad_code_select'] = $new_instance['ad_code_select'];
		$instance['mobile_ad_code_select'] = $new_instance['mobile_ad_code_select'];
		$instance['tablet_ad_code_select'] = $new_instance['tablet_ad_code_select'];
		
		$options = get_option( 'cmam_options' );
		
		// css
		if  ( isset ( $options['custom_css'] ) ):
			if  ( $options['custom_css'] == 'on' ) :
				$instance['custom_css'] = wp_kses ( $new_instance['custom_css'] ) ;
			endif;
		else:
			$instance['custom_css'] = $old_instance	['custom_css'];
		endif;
		
		// categories
		if  ( isset ( $options['category_archives'] ) ):
			if  ( $options['category_archives'] == 'on' ) :
				$instance['cats'] = $new_instance['cats'] ;
			endif;
		else:
			$instance['cats'] = $old_instance	['cats'];
		endif;
		
		// tags
		if  ( isset ( $options['tag_archives'] ) ):
			if  ( $options['tag_archives'] == 'on' ) :
				$instance['tags'] = $new_instance['tags'] ;
			endif;
		else:
			$instance['tags'] = $old_instance	['tags'];
		endif;
		
		// single pages
		if  ( isset ( $options['individual_pages'] ) ):
			if  ( $options['individual_pages'] == 'on' ) :
				$instance['single_pages'] = $new_instance['single_pages'] ;
			endif;
		else:
			$instance['single_pages'] = $old_instance	['single_pages'];
		endif;
		
		// single posts
		if  ( isset ( $options['individual_posts'] ) ):
			if  ( $options['individual_posts'] == 'on' ) :
				$instance['single_posts'] = $new_instance['single_posts'] ;
			endif;
		else:
			$instance['single_posts'] = $old_instance	['single_posts'];
		endif;
		
		// posts in category
		if  ( isset ( $options['posts_in_category'] ) ):
			if  ( $options['posts_in_category'] == 'on' ) :
				$instance['pics'] = $new_instance['pics'] ;
			endif;
		else:
			$instance['pics'] = $old_instance	['pics'];
		endif;
		
		// posts with tag
		if  ( isset ( $options['posts_with_tag'] ) ):
			if  ( $options['posts_with_tag'] == 'on' ) :
				$instance['pwts'] = $new_instance['pwts'] ;
			endif;
		else:
			$instance['pwts'] = $old_instance	['pwts'];
		endif;
		
		
		// $instance['cats'] = $new_instance['cats'];
		// $instance['tags'] = $new_instance['tags'];
		// $instance['single_pages'] = $new_instance['single_pages'];
		// $instance['single_posts'] = $new_instance['single_posts'];
		// $instance['pics'] = $new_instance['pics'];
		// $instance['pwts'] = $new_instance['pwts'];
		
        return $instance;
    }
	
	/* DISPLAY THE WIDGET
	--------------------------------------------------------------------------------------------- */
	
    function widget($args, $instance) {
		
		extract($args);
		
		if (( $instance['mobile_ad_code_select'] == 'ad-off') && ( $instance['tablet_ad_code_select'] == 'ad-off') && ( $instance['ad_code_select'] == 'ad-off'))
			return; // if the widget has no ads settings then don't do anything at all - we can go home early
			
		if ( ( !cmam_is_mobile() && !cmam_is_tablet() ) && ( $instance['ad_code_select'] == 'ad-off' ) ) 
			return; // if this is a desktop and ads are switched off for desktop then don't do anything at all - we can go home early again
			
		if ( cmam_is_mobile () && ( $instance['mobile_ad_code_select'] == 'ad-off') ) 
			return; // if we've detected a mobile device and mobile ads are switched off for desktop then don't do anything at all - we can go home early again
			
		if ( cmam_is_tablet () && ( $instance['tablet_ad_code_select'] == 'ad-off') ) 
			return; // if we've detected a mobile device and mobile ads are switched off for desktop then don't do anything at all - we can go home early again	
		
		$display_ad = false;
		
		if ( !isset( $instance['home_page'] ) ) $instance['home_page'] = 'off';
        if ( is_home () &&  ( $instance['home_page'] == 'on' ) ): 
			$display_ad = true; 
		endif;
			
		if ( !isset( $instance['front_page'] ) ) $instance['front_page'] = 'off';
        if ( is_front_page () &&  ( $instance['front_page'] == 'on' ) ):
			$display_ad = true;
		endif;
		
		if ( !is_home() && !is_front_page() ):
		
			// ALL PAGES		
			if ( !isset( $instance['pages'] ) ) $instance['pages'] = 'off';
			if ( is_page () &&  ( $instance['pages'] == 'on' ) ) $display_ad = true;
			
			// INDIVIDUAL PAGES
			if ( is_page ()) {
				$this_page_id = get_the_ID();
				$this_meta = get_post_meta ( $this_page_id );
				
				if ( !isset ( $this_meta['_cmam_ads_hide_ads'][0] ) )  $this_meta['_cmam_ads_hide_ads'][0] = 'off'; // content ads
				if ( !isset ( $this_meta['_cmam_ads_hide_ad_widgets'][0] ) )  $this_meta['_cmam_ads_hide_ad_widgets'][0] = 'off'; // sidebar widgets
	
				if ( ( $this_meta['_cmam_ads_hide_ad_widgets'][0] == 'on' ) && ( cmam_is_content_widget ($args['id']) ) ) return;
				
				if ( ( $this_meta['_cmam_ads_hide_ads'][0] == 'on' ) && ( !cmam_is_content_widget ($args['id']) ) ) return; // if set not to display in the post then hide it.
				else {
					if ( isset ( $instance['single_pages'] )) {
						if (is_array($instance['single_pages'])) {
							foreach ($instance['single_pages'] as $single_pages) {
								if ( $single_pages == $this_page_id ) $display_ad = true;
							}
						}
					}
				}
			}
		endif;
		
		// ALL POSTS
		if ( !isset( $instance['posts'] ) ) $instance['posts'] = 'off';
		if ( is_single () &&  ( $instance['posts'] == 'on' ) ) $display_ad = true; 
		
		if ( is_single ()) {
			$this_post_id = get_the_ID();
			$this_meta = get_post_meta ( $this_post_id );
			
			if ( !isset ( $this_meta['_cmam_ads_hide_ads'][0] ) )  $this_meta['_cmam_ads_hide_ads'][0] = 'off';
			if ( !isset ( $this_meta['_cmam_ads_hide_ad_widgets'][0] ) )  $this_meta['_cmam_ads_hide_ad_widgets'][0] = 'off';

			if ( ( $this_meta['_cmam_ads_hide_ad_widgets'][0] == 'on' ) && ( cmam_is_content_widget ($args['id']) ) ) return;
			if ( ( $this_meta['_cmam_ads_hide_ads'][0] == 'on' ) && ( !cmam_is_content_widget ($args['id']) ) ) return; // if set not to display in the post then hide it.
			else {
				
				if ( !isset ( $this_meta['_cmam_ads_post_selectable'][0] ) )  $this_meta['_cmam_ads_post_selectable'][0] = 'off';
	
				if ( $this_meta['_cmam_ads_post_selectable'][0] == 'on' ) { // if the posts meta box allows this post to be selectable then show it
					// INDIVIDUAL POSTS
					// if the id of the current post is in the instance['single_posts'] then show ad
					if ( isset( $instance['single_posts'] ) ):
						if (is_array($instance['single_posts'])) {
							foreach ($instance['single_posts'] as $single_posts) {
								if ( $single_posts == $this_post_id ) $display_ad = true;
							}
						}
					endif;
				}
				
				// POSTS IN CATEGORY
				// ie. Is this ad active for the categories assigned to the post
				if ( isset( $instance['pics'] ) ):
					$these_categories = wp_get_post_categories( $this_post_id ); // categories array only contains ids (unlike the post tags array)
					if ( cmam_value_in_array( $instance['pics'], $these_categories ) ) $display_ad = true;
				endif;
				
				// POSTS WITH TAG
				// ie. Is this ad active for the tags assigned to the post
				if ( isset( $instance['pwts'] ) ):
					$these_tags = wp_get_post_tags( $this_post_id, array( 'fields' => 'ids') ); // only select the ids from the post tags array
					if ( cmam_value_in_array( $instance['pwts'], $these_tags ) ) $display_ad = true;
				endif;
			}
		}

		// ALL CATEGORY ARCHIVES		
		if ( !isset( $instance['category_archives'] ) ) $instance['category_archives'] = 'off';
		if ( is_category () &&  ( $instance['category_archives'] == 'on' ) ) $display_ad = true;
		
		// INDIVIDUAL CATEGORY ARCHIVES
		
		if ( isset( $instance['cats'] ) ) {
			if (is_category ()) {
				$this_category = cmam_get_cat_id ();
				if (cmam_single_value_in_array($instance['cats'], $this_category)) $display_ad = true;
			}
		}
		
		// ALL TAG ARCHIVES
		if ( !isset( $instance['tag_archives'] ) ) $instance['tag_archives'] = 'off';
		if ( is_tag () &&  ( $instance['tag_archives'] == 'on' ) ) $display_ad = true;
		
		// INDIVIDUAL TAG ARCHIVES
		if ( isset( $instance['tags'] ) ) {
			if (is_tag ()) {
				$this_tag = cmam_get_tag_id ();
				if (cmam_single_value_in_array($instance['tags'], $this_tag)) $display_ad = true;
			}
		}
		
		if ( !isset( $instance['author_archives'] ) ) $instance['author_archives'] = 'off';
		if ( is_author () &&  ( $instance['author_archives'] == 'on' ) ) $display_ad = true;
		
		if ( !isset( $instance['date_archives'] ) ) $instance['date_archives'] = 'off';
		if ( is_date () &&  ( $instance['date_archives'] == 'on' ) ) $display_ad = true;
		
		if ( !isset( $instance['archives'] ) ) $instance['archives'] = 'off';
		if ( is_archive () &&  ( $instance['archives'] == 'on' ) ) $display_ad = true;
		
		if ( !isset( $instance['search'] ) ) $instance['search'] = 'off';
		if ( is_search () &&  ( $instance['search'] == 'on' ) ) $display_ad = true;
		
		if ( !isset( $instance['404notfound'] ) ) $instance['404notfound'] = 'off';
		if ( is_404 () &&  ( $instance['404notfound'] == 'on' ) ) $display_ad = true;
		
		if ( $display_ad )  {
			$title='';
			if ( $instance['display_title'] == 'on' ) {
				$title = apply_filters( 'widget_title', $instance['title'] );
			}
			
			// inject style from widget into $before widget but only for desktops and tablets
			if ( isset( $instance['custom_css'] ) ) {
				if ( !cmam_is_mobile() ) {
					echo substr_replace($before_widget, ' style="' . $instance['custom_css'] . '" ' , strlen($before_widget) -1, 0);
				}
			}
			else {
				echo $before_widget;
			}
			
			if (
				(cmam_is_mobile() && ($instance['mobile_ad_code_select'] != 'ad-off')) || //only show titles if the ad hasnt been switched off
				(cmam_is_tablet() && ($instance['tablet_ad_code_select'] != 'ad-off')) ||
				( ( !cmam_is_mobile() && !cmam_is_tablet() ) && ($instance['ad_code_select'] != 'ad-off'))
				) {
				if ( !empty( $title ) ) { echo $before_title . $title . $after_title; };
			}
			
			$desktop_meta = get_post_meta($instance['ad_code_select']); // this could be the id or the status value
			$mobile_meta = get_post_meta($instance['mobile_ad_code_select']); // this could be the id or the status value
			$tablet_meta = get_post_meta($instance['tablet_ad_code_select']); // this could be the id or the status value
			
			if (!cmam_is_mobile() && !cmam_is_tablet()) {
				if ( isset ( $instance['ad_code_select'] ) ) {
					if ( $instance['ad_code_select'] != 'ad-off') {
						print cmam_display_rotated_ad($desktop_meta['cmam_ads_ad_code_textarea'][0]) . cmam_generate_adlink( $instance['ad_code_select'], $instance['tablet_ad_code_select'], $instance['mobile_ad_code_select'], 'ad' ); 
					}
				}
			}
			
			if (cmam_is_mobile()) {
				if ( isset ( $instance['mobile_ad_code_select'] ) ) {
					if ( $instance['mobile_ad_code_select'] != 'ad-off') {
						if ( $instance['mobile_ad_code_select'] == 'display-desktop') // print $desktop_meta['cmam_ads_ad_code_textarea'][0];
							print cmam_display_rotated_ad($desktop_meta['cmam_ads_ad_code_textarea'][0]) . cmam_generate_adlink( $instance['ad_code_select'],  $instance['tablet_ad_code_select'], $instance['mobile_ad_code_select'], 'ad' );	
						else 
							print cmam_display_rotated_ad($mobile_meta['cmam_ads_ad_code_textarea'][0]) . cmam_generate_adlink( $instance['ad_code_select'], $instance['tablet_ad_code_select'], $instance['mobile_ad_code_select'], 'mobile' );	
					}
				}
			}
			
			if (cmam_is_tablet()) {
				if ( isset ( $instance['tablet_ad_code_select'] ) ) {
					if ( $instance['tablet_ad_code_select'] != 'ad-off') {
						if ( $instance['tablet_ad_code_select'] == 'display-desktop') // print $desktop_meta['cmam_ads_ad_code_textarea'][0];
							print cmam_display_rotated_ad($desktop_meta['cmam_ads_ad_code_textarea'][0]) . cmam_generate_adlink( $instance['ad_code_select'], $instance['tablet_ad_code_select'], $instance['mobile_ad_code_select'], 'ad' );	
						else 
							print cmam_display_rotated_ad($tablet_meta['cmam_ads_ad_code_textarea'][0]) . cmam_generate_adlink( $instance['ad_code_select'], $instance['tablet_ad_code_select'], $instance['mobile_ad_code_select'], 'tablet' );	
					}
				}
			}
			
			echo $after_widget;
		}
    }
}

/* DISCOVER IF VALUES FROM INSIDE ONE ARRAY EXIST IN ANOTHER
--------------------------------------------------------------------------------------------- */
function cmam_value_in_array($array, $find){
	$exists = FALSE;
	if(!is_array($array)){
		return;
	}
	foreach ($array as $key => $value) {
		foreach ($find as $find_key => $find_value) {	
			if($find_value == $value){
				$exists = TRUE;
			}
		}
	}
	return $exists;
}

/* DISCOVER IF VALUES FROM INSIDE ONE ARRAY EXIST IN ANOTHER
--------------------------------------------------------------------------------------------- */
function cmam_single_value_in_array($array, $find){
	$exists = FALSE;
	if(!is_array($array)){
		return;
	}
	foreach ($array as $key => $value) {	
		if($find == $value){
			$exists = TRUE;
		}
	}
	return $exists;
}

/* GET THE CURRENT CATEGORY ID
--------------------------------------------------------------------------------------------- */
function cmam_get_cat_id(){
	global $wp_query;
	if(is_category() || is_single()){
		$cat_ID = get_query_var('cat');
	}
	return $cat_ID;
}

/* GET THE CURRENT TAG ID
--------------------------------------------------------------------------------------------- */
function cmam_get_tag_id(){
	global $wp_query;
	if(is_tag() || is_single()){
		$tag_ID = get_query_var('tag_id');
	}
	return $tag_ID;
}


/* GET THE ARRAY OF CURRENT DESKTOP / TABLET ADS FOR USE IN DROP DOWN BOXES
--------------------------------------------------------------------------------------------- */
function cmam_get_the_ads () {
	
	global $post;
	
	$temp_post = $post;
	$ads_array = array ();
	
	/* Query ads from the database. */
	$loop = new WP_Query(
		array(
			'post_type' => 'cmam_ads',
			'orderby' => 'title',
			'order' => 'ASC',
			'posts_per_page' => -1,
		)
	);
	
	/* Check if any ads were returned. */
	if ( $loop->have_posts() ) {

		/* Loop through the ads (The Loop). */
		while ( $loop->have_posts() ) {

			$loop->the_post();

			$id = get_the_ID();

			$mobile_meta = '';
			$tablet_meta = '';
			$mobile_meta = get_post_meta($id, 'cmam_ads_is_mobile_ad', true);
			$tablet_meta = get_post_meta($id, 'cmam_ads_is_tablet_ad', true);
			
			if (($mobile_meta != 'on') && ($tablet_meta != 'on')) { 	// only add desktop / tablet ads to the array... no mobile ads
				if (get_the_title($id)) {
					$ads_array [$id]['label'] = get_the_title($id);
				}
				else {
					$ads_array [$id]['label'] = 'untitled ad (id=' . $id . ')';
				}
				$ads_array [$id]['value'] = $id;
			}
		}
	}
	
	$post = $temp_post;
	
	return $ads_array;
}


/* GET THE ARRAY OF CURRENT MOBILE ADS FOR USE IN DROP DOWN BOXES
--------------------------------------------------------------------------------------------- */

function cmam_get_the_mobile_ads () {
	
	global $post;
	
	$temp_post = $post; // save the current $post value
	$ads_array = array ();
	
	/* Query ads from the database. */
	$loop = new WP_Query(
		array(
			'post_type' => 'cmam_ads',
			'orderby' => 'title',
			'order' => 'ASC',
			'posts_per_page' => -1,
		)
	);
	
	/* Check if any ads were returned. */
	if ( $loop->have_posts() ) {

		/* Loop through the ads (The Loop). */
		while ( $loop->have_posts() ) {

			$loop->the_post();

			$id = get_the_ID();

			$meta = '';
			$meta = get_post_meta($id, 'cmam_ads_is_mobile_ad', true);
	
			if ($meta == 'on') {  	// if the mobile ads tick box is set then add this to the array
				if (get_the_title($id)) {
					$ads_array [$id]['label'] = get_the_title($id);
				}
				else {
					$ads_array [$id]['label'] = 'untitled ad (id=' . $id . ')';
				}
				$ads_array [$id]['value'] = $id;
			}
		}
	}
	
	$post = $temp_post; // restore the previous $post value
	return $ads_array;
}


/* GET THE ARRAY OF CURRENT TABLET ADS FOR USE IN DROP DOWN BOXES
--------------------------------------------------------------------------------------------- */

function cmam_get_the_tablet_ads () {
	
	global $post;
	
	$temp_post = $post; // save the current $post value
	$ads_array = array ();
	
	/* Query ads from the database. */
	$loop = new WP_Query(
		array(
			'post_type' => 'cmam_ads',
			'orderby' => 'title',
			'order' => 'ASC',
			'posts_per_page' => -1,
		)
	);
	
	/* Check if any ads were returned. */
	if ( $loop->have_posts() ) {

		/* Loop through the ads (The Loop). */
		while ( $loop->have_posts() ) {

			$loop->the_post();

			$id = get_the_ID();

			$meta = '';
			$meta = get_post_meta($id, 'cmam_ads_is_tablet_ad', true);
	
			if ($meta == 'on') {  	// if the tablet ads tick box is set then add this to the array
				if (get_the_title($id)) {
					$ads_array [$id]['label'] = get_the_title($id);
				}
				else {
					$ads_array [$id]['label'] = 'untitled ad (id=' . $id . ')';
				}
				$ads_array [$id]['value'] = $id;
			}
		}
	}
	
	$post = $temp_post; // restore the previous $post value
	return $ads_array;
}



/* IS THIS AN INCONTENT WIDGET? Used for figuring out whether to turn them on or off
--------------------------------------------------------------------------------------------- */

function cmam_is_content_widget ( $widget_id ) {
	$status = false;
	if ( $widget_id == 'cmamtop' ) $status = true;
	if ( $widget_id == 'cmambottom' ) $status = true;
	if ( $widget_id == 'cmampos1' ) $status = true;
	if ( $widget_id == 'cmampos2' ) $status = true;
	if ( $widget_id == 'cmampos3' ) $status = true;
	return $status;
}
?>